*******************************************************************************
What's new (trunk):

12/06 CLEANUP: 3.0.13 OR.

11/01 CLEANUP: The autoconf/automake config scripts are cleaned up.

11/01 CLEANUP: Remove a lot of compilation warnings (not used variables).

10/30 BUGFIXING: Bad MG_PRINTF usage.

10/30 BUGFIXING: Incorrect elif condition usage; some incore rbf defonts are not 
included correctly.
	* src/font/devfont.c

10/30 CLEANUP: Merge differences from rel-3-0 mannually!

10/26 CLEANUP: svn merge -r 13673:13828 ^/branches/rel-3-0

10/24-2017 CLEANUP: Remove some 'inline' definitions:
	* GetIMEPos/SetIMEPos. 
	* WndRect -> gui_WndRect. 
	* WndClientRect -> gui_WndClientRect. 

12/06. CLEANUP #11: Merge differences from rel-3-0, and remove unnecessary
files. svn merge -r 12913:13673 ../branches/rel-3-0 (wanzheng)
	* ... ...

*******************************************************************************
What's new in rel-3-0 branch (3.0.12 OR, 2010/12/03 ~ )

07/29. ENHANCEMENT #11: Use Expand16CBitmapEx to contain the alpha component 
for XorBits of cursor and reserve the alpha component of screen when showing
cursor.
	* src/kernel/cursor.c
	* src/kernel/cursor-sa.c
	* src/kernel/cursor-procs.c

07/29. ENHANCEMENT #10: Implement Expand16CBitmapEx, Expand256CBitmapEx, and 
ExpandPart16CBitmap APIs, and define inline stubs for the old APIs.
	* include/gdi.h
	* src/newgdi/bitmap.c

07/21. BUGFIXING #?: Fix the question of dead lock by screensaver_hide. Now send 
message to active window and let active window to hide screensaver. (xwyan)
	* src/include/internals.h
	* src/gui/window.c
	* src/misc/license.c

07/06. BUGFIXING #?: Add macro control for we_heap.(xwyan)
	* src/gui/lf_manager.c

06/14. BUGFIXING #5640: fix bug of double click of event(houhh)
	* src/kernel/event.c

05/25. BUGFIXING #5606: fix bug of selectAll of mTextEdit (wanzheng)
	* src/textedit/mtextedit.c

05/20. BUGFIXING #5560: fixed bug of calc window client rect error in
calc_we_area().(houhh)
	* src/mybmp/winbmp.c

05/03. BUGFIXING #?: fixed bitmap BI_BITFIELDS format load problem.(humingming)
	* src/mybmp/winbmp.c

04/29. BUGFIXING #5534: fixed DrawText can't deal with the first char is '\n'.(humingming)
	* src/newgdi/drawtext.c

04/02. BUGFIXING #5527: Change MSG_KEYSYM/MSG_KEYLONGPRESS/MSG_KEYALWAYSPRESS
define value, Modfiy error position of __mg_msgstr2(houhh).
	* src/include/msgstr.h
	* include/window.h

04/01. BUGFIXING #?: Make GetClipBox rect coordinate correct.(humingming)
	* src/newgdi/clip.c

03/25. BUGFIXING #?: After dialog created, we should update local hOwner variable 
in DialogBoxIndirectParamEx. It can be avoid to create many model dialogs when
using HWND_DESKTOP as hOwner.(xwyan)
	* src/gui/dialog.c

03/22. BUGFIXING #?: Modify GetPalette() and fontGetTypeNameFromName()
prototype. (houhh)
	* src/include/fontname.h
	* include/gdi.h

03/15. BUGFIXING #?: GetBoundRect() can't deal with an empty rect correctly.
(wanzheng)
	* src/newgdi/rect.c

03/07. BUGFIXING #?: Modify wndDrawNCButton to use input hdc when draw
scrollbar. (houhh)
	* src/gui/window.c
	* include/window.h

03/04. BUGFIXING #?: Add FT_LOAD_FORCE_AUTOHINT style for ft2 font enigne when
open cache support. (houhh)
	* src/font/freetype2.c

03/04. ENHANCEMENT #9: Some enhancements for UXDemo. (CR department)
	* 1) Eliminate accumulated error of timer.
	  2) Add an API UpdateInvalidRect() to update the invalidate rect without
	     calling InvalidateRect(NULL)
	  3) Improve S3C6410 GAL
	  4) Make it able to create a hardware surface with different color format
	     from the screen surface. Attention, All GAL module are influenced.
	  5) Initialize local-cutting-region (lcrgn) correctly when create a memory
	     DC.
	  6) Used GetWindowElementPixelEx to replace GetWindowElementPixel,
	     specify dc.
	* src/control/static.c
	* src/gui/window.c
	* src/kernel/timer.c
	* src/newgal/pixels.c
	* src/newgal/s3c6410/gal-s3c6410.c
	* src/newgal/s3c6410/gal-s3c6410.h
	* src/newgal/surface.c
	* src/newgal/videomem-bucket.c
	* src/newgdi/gdi.c
	* src/sysres/font/_font_inner_res.c

03/04. BUGFIXING #5408: GAL_revcpy should use 'cld' after using 'std'.(xwyan)
	* src/include/memops.h

03/02. BUGFIXING #5402: These is a mistake in del_all_devfonts(), and remove
it in font_DelDevFont(). (xhmao)
	* src/font/devfont.c
	* src/include/devfont.h

03/01. BUGFIXING #5423: remove the restrict of the DC's max size when use
CreateSecondaryDC. (wangxubin)
	* src/newgdi/gdi.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/gui/window.c

03/01: BUGFIXING #?: Fix a memory leak issue on arcCache. (wanzheng)
	* src/kernel/init.c
	* src/newgdi/miarc.c
	* src/newgdi/mifillarc.h

02/25: ENHANCEMENT #8: Add _MGFONT_TTF_GRAYADJUST for ttf font to adjust the gray
bitmap that return by font engine. (houhh)
	* src/newgdi/glyph.c
	* CMakeLists.txt
	* cmake_mgconfig.h.in 

02/21: ENHANCEMENT #7: Enhance PCXVFB IAL, add IAL_RECORD_MANUAL_START support,
makes recording started after <F5> was pressed. (dengmin)
	* src/ial/pcxvfbial.c

02/18: ENHANCEMENT #6: Enhance AUTO IAL, let it replay IAL record automatically
if environment value 'MG_ENV_IAL_AUTO_REPLY' is specified.
(dengmin)
	* src/ial/auto.c

02/17: ENHANCEMENT #5: Enhance PCXVFB IAL, let MiniGUI can record IAL while
using PCXVFB GAL engine. (dengmin)
	* src/ial/pcxvfbial.c

02/15. BUGFIXING#5401: Fix compiling error. (wanzheng)
	* src/kernel/cursor.c

01/21. BUGFIXING#5373: Fix the bug of copy text to ES_UPPERCASE or ES_LOWERCASE
style edit control.(humingming)
	* src/control/edit.c
	* src/textedit/mtextedit.c

01/19. BUGFIXING#?: Fix memory leak in ReleaseDC when do MAKE_REGION_INFINITE, we
should EmptyClipRgn it before exit gui or reinit rgn.(houhh)
	* src/newgdi/gdi.c

01/12. ENHANCEMENT #?: Add missing options in CMakeLists.txt and configure.in.
change the time of display splash to 1s. change the event of screensaver.(wangxubin)
	* src/kernel/event.c
	* src/misc/license.c
	* src/newgal/CMakeLists.txt
	* CMakeLists.txt
	* configure.in

01/11. BUGFIXING #?: Fix bug of core dump when MiniGUI uses Bitmap Font with alpha mask
(ZhaolinHu)
	* src/gui/caret.c
	* src/gui/window.c
	* src/gui/lf_skin.c
	* src/font/bitmapfont.c
	* src/newgal/surface.c
	* src/newgdi/rotatebmp.c
	* src/newgdi/readbmp.c
	* src/newgdi/bitmap.c
	* include/gdi.h

01/11. BUGFIXING #?: Fix bug of using stack in vxworks.(xwyan)
	* src/libc/vxworks_pprivate.h
	* src/libc/vxworks_pthread.c

01/07. ENHANCEMENT #4: Add mgetc_win32.c for Windows. (wanzheng)
	* src/sysres/mgetc_win32.c
	* src/sysres/CMakeLists.txt

01/05. BUGFIXING #?: Fix bug of GetClipBox, Add IntersectRect with DevRC.(houhh)
	* src/newgdi/clip.c

01/05. BUGFIXING #5342: Fix bug of shadow engine, sometimes core dump
in start and quit.(wangxubin)
	* src/newgal/shadow/shadow.c

01/05. CLEANUP #3: Update the description of MSG_ERASEBKGND. (wanzheng)
	* include/window.h

12/29. BUGFIXING #?: Fix bug of new textedit calc mulit-charset length not
correct in some borad.(humingming)
	* src/textedit/mtextedit.c

12/28. CLEANUP #2: Resolve compiling issues on Windows. (wanzheng)

12/23. BUGFIXING #?: Fix bug of GetSubDC, you can specify off_x/off_y < 0 if 
dcType is memdc.(houhh)
	* src/newgdi/gdi.c

12/23. BUGFIXING #?: Fix bug of drawing and fill hline, can not limited in 
screen area.(houhh)
	* src/newgdi/pixel_ops.c
	* _dc_draw_hline_clip, _dc_fill_hline_clip. 

12/20: ENHANCEMENT #3: Enhance stgfb GAL support 32bit and 255 alpha pixel format.
(humingming)
	* src/newgal/stgfb/stgfb_video.c

12/14: ENHANCEMENT #2: Enhance PCXVFB GAL engine, let MiniGUI quit if the VFB
didn't come for a long time. (wanzheng)
	* src/newgal/pcxvfb/pcxvfb.c

12/14: BUGFIXING #5(new-bugzilla): Do not destroy the znode of screensaver
until EndSession. (wanzheng)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/kernel/init.c
	* src/kernel/init-lite.c

12/09: BUGFIXING #5340: Close Menu when ESCAPE pressed. (wanzheng)
	* src/gui/menu.c

12/09: ENHANCEMENT #1: PCXVFB GAL: Change the group id of the VFB process, so
that we can interrupt the application when debugging. (wanzheng)
	* src/kernel/init.c
	* src/kernel/init-lite.c
	* src/newgal/pcxvfb/pcxvfb.c

12/07: CLEANUP #1: Corrected the spelling mistake `ncsParseConstrcutParams'.
(wanzheng)
	* src/textedit/mbtree.c
	* src/textedit/mtextedit.c
	* src/textedit/object.c
	* src/textedit/object.h

12/06: BUGFIXING #?: Fixed the bug of own_overlapped_bitblit. (humingming)
	* src/newgal/surface.c

*******************************************************************************
What's new in this branch (3.0.10 OR, 2010/08/06 ~ 2010/12/03)

12/01: BUGFIXING #5337: Fixed bug of RecalcScrollInfo when hide scrollar ,it
should me call ShowScrollBar to hide. (houhh)
	* src/gui/window.c

12/01: CLEANUP #9: Rename vmbucket_xxx to gal_vmbucket_xxx. (wanzheng)
	* src/newgal/hisi/gal_hi3560a.c
	* src/newgal/hisi/gal_hi3560a.h
	* src/newgal/s3c6410/gal-s3c6410.c
	* src/newgal/s3c6410/gal-s3c6410.h
	* src/newgal/stgfb/stgfb_video.c
	* src/newgal/stgfb/stgfb_video.h
	* src/newgal/videomem-bucket.c
	* src/newgal/videomem-bucket.h

12/01: BUGFIXING #?: Resolve compiling issue for Windows. (wanzheng)
	* src/ial/pcxvfbial.c
	* src/kernel/init-lite.c

11/30: BUGFIXING #5291: Fix the bug that edit is empty can't show caret.
(humingming)
	* src/texte/mtextedit.c

11/29: CLEANUP #8: Tuning CMakeLists.txt for Windows. (wanzheng)
	* CMakeLists.txt
	* src/CMakeLists.txt

11/29: BUGFIXING #5299: Fix the issues of quiting on Windows. (wanzheng)
	* src/ial/pcxvfbial.c
	* src/newgal/pcxvfb/pcxvfb-winfb.c

11/27: BUGFIXING #5234: Fixed caret postion display error when move mouse
to select text in edit control.(houhh)
	* src/control/edit.c

11/27: BUGFIXING #5318: Add set content width in add_icon_item 
of iconview.(houhh)
	* src/ex_ctrl/iconview.c

11/26: BUGFIXING #?: Fixed compiling question in vxWorks(mipse).(xwyan)
	* include/common.h

11/26: ENHANCEMENT #?: Add stgfb GAL engine. (humingming)
	* src/server/request.c
	* src/newgal/sysvideo.h
	* src/newgal/videomem-bucket.c
	* src/newgal/video.c
	* src/newgal/Makefile.am
	* src/newgal/surface.c
	* configure.in
	* ++++++++ Add ++++++++++
	* src/newgal/stgfb
	* src/newgal/stgfb/stgfb_video.c
	* src/newgal/stgfb/stgfb_video.h
	* src/newgal/stgfb/Makefile.am
	* src/newgal/stgfb/st_include
	* src/newgal/stgfb/st_include/stblit_ioctl.h
	* src/newgal/stgfb/st_include/stddefs.h
	* src/newgal/stgfb/st_include/stcommon.h
	* src/newgal/stgfb/st_include/stevt_ioctl.h
	* src/newgal/stgfb/st_include/linuxwrapper.h
	* src/newgal/stgfb/st_include/stblit.h
	* src/newgal/stgfb/st_include/stlite.h
	* src/newgal/stgfb/st_include/stevt.h
	* src/newgal/stgfb/st_include/stgfb.h
	* src/newgal/stgfb/st_include/stdevice.h
	* src/newgal/stgfb/st_include/linuxcommon.h
	* src/newgal/stgfb/st_include/stavmem.h
	* src/newgal/stgfb/st_include/stlayer_ioctl.h
	* src/newgal/stgfb/st_include/stgxobj.h
	* src/newgal/stgfb/st_include/stlayer.h
	* src/newgal/stgfb/st_include/stsys.h
	* src/newgal/stgfb/st_include/layer_rev.h
	* src/newgal/stgfb/st_include/stos.h

11/26: ENHANCEMENT #?: Change CreateProcess called to support if
user set simulation path. (houhh)
	* src/newgal/pcxvfb/pcxvfb-winfb.c

11/24: ENHANCEMENT #?: Add skin support for gvfb. (zouqizhi)
	* src/newgal/pcxvfb/pcxvfb-winfb.h
	* src/newgal/pcxvfb/pcxvfb.c
	* src/newgal/pcxvfb/pcxvfb-winfb.c

11/24: BUGFIXING #?: Tunning the semaphore definition file for vxworks.(xwyan)
	* include/vxworks_semaphore.h
	* include/common.h

11/24: CLEANUP #7: Merge the modifications of textedit from mGNCS. And cleanup 
the '\t' charactor in the source files by using ":retab" command. (wanzheng)
	* src/textedit/mtextedit.c
	* src/textedit/mtextedit.h

11/23: BUGFIXING #?: check makefile in non-linux system and make dist script.(xwyan) 
	* makefile.ng
	* src/control/makefile.ng
	* src/control/Makefile.am
	* src/kernel/makefile.ng
	* src/kernel/Makefile.am
	* src/makefile.ng
	* src/mybmp/makefile.ng
	* src/mybmp/Makefile.am
	* src/gui/makefile.ng
	* src/gui/Makefile.am
	* src/main/makefile.ng
	* src/main/Makefile.am
	* src/sysres/makefile.ng
	* src/sysres/resmgr.c
	* src/sysres/icon/makefile.ng
	* src/sysres/icon/Makefile.am
	* src/sysres/font/makefile.ng
	* src/sysres/font/Makefile.am
	* src/sysres/Makefile.am
	* src/sysres/cursor/makefile.ng
	* src/sysres/cursor/Makefile.am
	* src/sysres/bmp/makefile.ng
	* src/sysres/bmp/Makefile.am
	* src/textedit/makefile.ng
	* src/textedit/Makefile.am
	* src/misc/makefile.ng
	* src/misc/Makefile.am
	* src/ex_ctrl/makefile.ng
	* src/ex_ctrl/Makefile.am
	* src/ial/makefile.ng
	* src/ial/dlcustom/Makefile.am
	* src/ial/Makefile.am
	* src/font/makefile.ng
	* src/font/in-core/makefile.ng
	* src/font/in-core/Makefile.am
	* src/font/Makefile.am
	* src/libc/makefile.ng
	* src/libc/Makefile.am
	* src/Makefile.am
	* src/newgal/makefile.ng
	* src/newgal/bf533/makefile.ng
	* src/newgal/bf533/Makefile.am
	* src/newgal/utpmc/makefile.ng
	* src/newgal/utpmc/Makefile.am
	* src/newgal/hisi/Makefile.am
	* src/newgal/svpxxosd/makefile.ng
	* src/newgal/svpxxosd/Makefile.am
	* src/newgal/s3c6410/Makefile.am
	* src/newgal/wvfb/makefile.ng
	* src/newgal/wvfb/Makefile.am
	* src/newgal/mb93493/makefile.ng
	* src/newgal/mb93493/Makefile.am
	* src/newgal/mlshadow/makefile.ng
	* src/newgal/mlshadow/Makefile.am
	* src/newgal/shadow/makefile.ng
	* src/newgal/shadow/Makefile.am
	* src/newgal/dummy/makefile.ng
	* src/newgal/dummy/Makefile.am
	* src/newgal/dfb/makefile.ng
	* src/newgal/dfb/Makefile.am
	* src/newgal/nexus/makefile.ng
	* src/newgal/nexus/Makefile.am
	* src/newgal/Makefile.am
	* src/newgal/commlcd/makefile.ng
	* src/newgal/commlcd/Makefile.am
	* src/newgdi/makefile.ng
	* src/newgdi/Makefile.am
	* rules.make
	* make_tarball
	* include/makefile.ng
	* include/ctrl/makefile.ng
	* include/ctrl/Makefile.am
	* configure.in
	* ChangeLog
	* configs/feature.in
	* configs/defconfig
	* configs/Configure.help
	* configs/config.in
	* build/rules-pc.vxworks
	* build/rules-longxin.vxworks
	* build/rules-mnt.nucleus
	* build/rules-ppc.vxworks
	* build/rules-pc.win32
	* Makefile.am

11/22: BUGFIXING #?: Add check for return value of CreateProcess.(houhh)
	* src/newgal/pcxvfb/pcxvfb-winfb.c

11/22: BUGFIXING #?: change execl to execlp.(xwyan)
	* src/newgal/pcxvfb/pcxvfb.c

11/20: TUNNING #11: Fix the policy of AlphaBlending in _PutBoxAlpha(),
dA = sA + dA - ((sA * dA) >> 8). (wanzheng)
	* src/newgal/surface.c

11/20: BUGFIXING #5299: Let the threads quit in orders, and do not exit()
directly in pcxvfb IAL. (wanzheng)
	* src/ial/pcxvfbial.c
	* src/include/internals.h
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/kernel/desktop-ths.c
	* src/kernel/init.c
	* src/kernel/init-lite.c
	* src/kernel/message.c
	* src/kernel/timer.c
	* src/misc/license.c

11/19: BUGFIXING #5314: Modify listview to reset nContX/nContY when content
width or height change smaller than visible.(houhh)
	* src/kernel/desktop.c

11/18: BUGFIXING #5300: Change the zorder lock range in dskScrollWindow
to avoid dead lock.(houhh)
	* src/kernel/desktop.c

11/17: BUGFIXING #5247: Initialize variables manually for timer.(xwyan)
	* src/kernel/timer.c

11/12: BUGFIXING #5291: Make textedit get focus don't auto move cursor.
(humingming).
	* src/textedit/mtextedit.c

11/10: ENHANCEMENT ?: Add common dfb modules. (humingming).
	* src/ial/dfb.c
	* src/newgal/dfb/st7167_video.c  -- New Add
	* src/newgal/dfb/st7167_video.h  -- New Add
	* src/newgal/dfb/dfbvideo.c
	* src/newgal/dfb/dfbvideo.h
	* src/newgal/dfb/Makefile.am
	* configure.in

11/10: BUGFIXING #5206: Correct the path of icon for fashion renderer.
(wanzheng).
	* etc/MiniGUI.cfg

11/09: BUGFIXING #5284: Fix bug of textedit scroll problem.(humingming)
	* src/textedit/mtextedit.h
	* src/textedit/mtextedit.c

11/09: BUGFIXING #5282: Fix bug of control border, display focus border color
whenever in foucs or not focus status.(houhh)
	* src/gui/window.c

11/09: BUGFIXING #5234: Fix bug of display problem edit control caret.(houhh)
	* src/control/edit.c

11/09: CLEANUP #6: Resolve compile issue for VxWorks. (wanzheng)
	* src/ial/auto.c
	* src/libc/vxworks_mutex.c
	* src/makefile.ng

11/08: BUGFIXING #?: Fixed the bug in windows(dongjunjie)
	* src/font/qpf.h        -- Add the struct align at 8bytes
	* src/kernel/desktop.c  -- the death lock bettwen lock_zi_for_read and get_valid_dc

11/08: BUGFIXING #5247: Initialize variables manually for VxWorks.
(author: xwyan and wangyang, commited by wanzheng)
	* src/font/freetype2.c
	* src/kernel/cursor.c
	* src/kernel/init.c
	* src/misc/clipboard.c
	* src/misc/license.c
	* src/sysres/resmgr.c

11/04: BUGFIXING #5222: Fix bug of lf_flat scrollbar thumb draw
incorrect.(humingming)
	* src/gui/lf_flat.c

11/04: BUGFIXING #5217: Fix bug of LoadBitmapFromFile load the gif that have
application extension decode error.(humingming)
	* src/mybmp/gif.c

11/04: BUGFIXING #5225: Fix bug of load icon failed when treeview control
register.(houhh)
	* src/ex_ctrl/treeview.c

11/03: BUGFIXING #5224: use _MG_PRINTF instead of fprintf in make_devfont func. 
(ymwei)
	* src/font/devfont.c

11/02: BUGFIXING #5210: Fix bug of memory leak.(houhh)
	* src/control/static_impl.h
	* src/font/bitmapfont.c
	* src/font/freetype2.c
	* src/font/freetype.c
	* src/newgdi/bitmap.c
	* src/kernel/sharedres.c
	* src/kernel/desktop.c
	* src/newgal/fbcon/fbvideo.c
	* src/newgal/hi3560aInit/hi3560a_init.c
	* src/neagal/sigma8654/sigma8654.c

11/02: BUGFIXING #5212: Fix bug of scrollbar control and system scroll.(houhh)
	* src/gui/lf_skin.c
	* src/control/scrollbar.c

11/01: BUGFIXING #?: Revert MiniGUI.cfg to resolve the issue of system
scrollbar. (wanzheng)
	* etc/MiniGUI.cfg

11/01: BUGFIXING #5212: Modify the value of `scrollbar' in MiniGUI.cfg.
(wanzheng)
	* etc/MiniGUI.cfg

11/01: BUGFIXING #5213: Fix the bug that the screensaver znode doesn't be
created the in stand-alone run mode. (wanzheng)
	* src/gui/window.c

10/30: BUGFIXING #5209: Fix hscroll bar if if do not response to 
MSG_LBUTTONUP message, send it to vscroll bar. (houhh)
	* src/gui/window.c

10/30: BUGFIXING #5207: Fix ShowScrollBar that get scrollbar rect befor
set scrollbar hide. (houhh)
	* src/gui/window.c

10/30: BUGFIXING #5205: Make cmake support the 'with_licensepicture'
configuration option. (wanzheng)
	* CMakeLists.txt
	* src/CMakeLists.txt

10/28: BUGFIXING #5168,#5170: Merged from mGNCS. (Modified by dongjunjie,
merged by wanzheng)
	* src/textedit/mtexteditbase.h
	* src/textedit/mtextedit.c
	* src/textedit/mtextedit.h

10/27: BUGFIXING #?: Simplify MoveWindow() to avoid refresh issues. (wanzheng)
	* src/gui/window.c

10/27: BUGFIXING #5187: Fix bugs of scrollview custom draw. (houhh)
	* src/control/scrollview.c

10/26: BUGFIXING #5104,5174,5173,4983,7179: Fix bugs of listview. (houhh)
	* src/ex_ctrl/listview.c
	* src/control/scrolled.c

10/26: BUGFIXING #5018: Resolve the bug that sometimes we treat NULLREGION as
an INFINITE region. (wanzheng)
	* src/include/cliprect.h
	* src/kernel/desktop.c
	* src/kernel/desktop-procs.c
	* src/kernel/desktop-sa.c
	* src/kernel/desktop-ths.c
	* src/newgdi/clip.c
	* src/newgdi/gdi.c
	* src/newgdi/region.c

10/26: BUGFIXING #5184 & 5185: fixed bug about textedit cursor display.
(humingming)
	* src/textedit/mtextedit.c

10/26: BUGFIXING #5176: Resolve the 'multiple definition' issue of textedit.
(wanzheng)
	* src/textedit/mtextedit.c
	* src/textedit/object.h

10/24: ENHANCEMENT #24: Make it able to alter splash pictures by using
'--with-licensepicture' configure option. (wanzheng)
	* M ChangeLog
	* M configure.in
	* M src/sysres/license/runme.sh
	* A src/sysres/license/pictures/common
	* A src/sysres/license/pictures/common/01_fmsoft.png
	* A src/sysres/license/pictures/common/02_feiman.png
	* A src/sysres/license/pictures/common/03_progressbar.png
	* A src/sysres/license/pictures/common/04_progressbar-bk.png
	* A src/sysres/license/pictures/hybridos
	* A src/sysres/license/pictures/hybridos/00_minigui.png
	* A src/sysres/license/pictures/hybridos/01_fmsoft.png
	* A src/sysres/license/pictures/hybridos/02_feiman.png
	* A src/sysres/license/pictures/hybridos/03_progressbar.png
	* A src/sysres/license/pictures/hybridos/04_progressbar-bk.png
	* A src/sysres/license/pictures/mdolphin
	* A src/sysres/license/pictures/mdolphin/00_minigui.png
	* A src/sysres/license/pictures/mdolphin/01_fmsoft.png
	* A src/sysres/license/pictures/mdolphin/02_feiman.png
	* A src/sysres/license/pictures/mdolphin/03_progressbar.png
	* A src/sysres/license/pictures/mdolphin/04_progressbar-bk.png
	* A src/sysres/license/pictures/minigui
	* A src/sysres/license/pictures/minigui/00_minigui.png
	* A src/sysres/license/pictures/minigui/01_fmsoft.png
	* A src/sysres/license/pictures/minigui/02_feiman.png
	* A src/sysres/license/pictures/minigui/03_progressbar.png
	* A src/sysres/license/pictures/minigui/04_progressbar-bk.png
	* D src/sysres/license/c_files/00_minigui.dat.c
	* D src/sysres/license/c_files/01_fmsoft.dat.c
	* D src/sysres/license/c_files/02_feiman.dat.c
	* D src/sysres/license/c_files/03_progressbar.dat.c
	* D src/sysres/license/c_files/04_progressbar-bk.dat.c
	* D src/sysres/license/c_files/key.c
	* D src/sysres/license/c_files/_splash_inner_res.c
	* D src/sysres/license/pictures/00_minigui.png
	* D src/sysres/license/pictures/01_fmsoft.png
	* D src/sysres/license/pictures/02_feiman.png
	* D src/sysres/license/pictures/03_progressbar.png
	* D src/sysres/license/pictures/04_progressbar-bk.png

10/21: ENHANCEMENT #23: Add Intel CE3100 GAL based on GDL.(dongkai)
	* src/newgal/gdl/gdl_video.c
	* src/newgal/gdl/gdl_video.h

10/19: BUGFIXING #5158: Fixed bug of caret color error. (humingming)
	* src/control/edit_impl.h
	* src/control/edit.c

10/19: BUGFIXING #5083: Fixed bug of get_sub_bmp when bitmap has alpha
info. (houhh)
	* src/gui/lf_skin.c

10/19: BUGFIXING #5060: Fixed bug of SetAutoRepeatMessage of mainwin scroll.(houhh)
	* src/gui/keyboard.c

10/19: BUGFIXING #5157: Fixed bug of TranslateMessage multi-thread problem.(humingming)
	* src/gui/keyboard.c

10/18. BUGFIXING #4987: Fixed scrollbar refresh question when treeview size
changed.(xwyan)
	* src/ex_ctrl/treeeview.c

10/15: BUGFIXING #5140: Fixed bug of PAGEUP and PAGEDOWN cursor don't
move.(humingming)
	* src/textedit/mtextedit.c

10/15: BUGFIXING #4979: Fixed bug of textlayout_reLayout when last delete line
is only '\n'.(houhh)
	* src/textedit/mtextedit.c

10/15: BUGFIXING #?: Fixed a compiling issue when enable product id.
(wanzheng)
	* src/include/license.h

10/15: BUGFIXING #5139: Fixed the bug that textedit MSG_SETTEXT don't limit by
EM_LIMITTEXT set. (humingming)
	* src/textedit/mtextedit.c

10/15: BUGFIXING #4918: Fixed the bug that textedit count line overrange 1 when the
title end with '\n'. (humingming)
	* src/textedit/mtextedit.c

10/14: BUGFIXING #5109: Fixed the bug that __mg_update_window() and
_cb_refresh_znode() do not update control with WS_EX_CTRLASMAINWIN.(houhh)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop.c

10/14: BUGFIXING #4936: Fixed the bug that MiniGUI can't quit if close GVFB
window while splashing. (wanzheng)
	* src/ial/pcxvfbial.c

10/14: BUGFIXING #5112: Create private CDC when the control has
WS_EX_USEPRIVATECDC style. (ymwei)
	* src/gui/window.c

10/13: ENHANCEMENT #22: Modify all Makefile.am AM_CFLAGS to INCLUDES
for cross compile(hisi).(zcyuan)

10/13: BUGFIXING #?: Fixed an alignment issue of the QPF font engine. (by
Wang Yulong, commited by wanzheng)
	* src/font/qpf.h

10/12: BUGFIXING #5004: Fixed the bug that scrolled will reset nContWidth
when nVisibleWidth value changed.(houhh)
	* src/control/scrolled.c

10/11: CLEANUP #5: Merge the modifications on MLEdit control from mGNCS.
(wanzheng)
	* src/textedit/mtextedit.h
	* src/textedit/mtextedit.c

10/11: BUGFIXING #5117: Fixed the bug that combox edit's caret cannot lost
focus, add some comment for MSG_SETFOCUS/MSG_KILLFOCUS. (houhh)
	* src/gui/window.c
	* include/window.h

10/11: BUGFIXING #5116: Fixed the bug that scrollbar is not visible until
refresh by force. (wanzheng)
	* src/textedit/mtextedit.c

10/11: BUGFIXING #5115: Fixed the bug that set the copy_len too large to get
more that one line text when use EM_GETLINETEXT. (humingming)
	* src/textedit/mtextedit.c

09/30: BUGFIXING #?: Fixed the bug that the configure option
`--with-ttfcachesize' didn't work correctly. (wanzheng)
	* configure.in

09/29: TUNNING #10: Install CMake modules to $PREFIX/share. (wanzheng)
	* configure.in
	* Makefile.am
	* cmake/Makefile.am

09/29: ENHANCEMENT #24: Add textedit message EM_GETPARAGRAPHLENGTHINMCHAR,
EM_GETLINELENGTHINMCHAR, EM_GETLINETEXT and EM_GETLINELENGTH. (humingming)
	* src/textedit/mtextedit.c
	* src/textedit/mtextedit.h
	* include/ctrl/edit.h

09/29: BUGFIXING #?: Fix compiling error for mGNCS which use mtextedit.c
directly by copying mtextedit.c to its source tree. (wanzheng)
	* src/textedit/mtextedit.c

09/28: TUNNING #9: Adjust textedit the way of calculate title line content.
(humingming)
	* src/textedit/mtextedit.c
	* src/textedit/mtexteditbase.h
	* src/textedit/mtextedit.h

09/28: TUNNING #8: Remove warnings in auto.c. (ymwei)
	* src/ial/auto.c

09/28: BUGFIXING #?: Add -lpthread to minigui.pc if shadow or mlshadow GAL is
enabled. And modify CMake scripts to support GAL shadow. (wanzheng)
	* CMakeLists.txt
	* configure.in
	* src/newgal/shadow/CMakeLists.txt

09/27: BUGFIXING #?: Add missing files for `make dist'. (wanzheng)
	* clean_license.sh
	* configure.in
	* src/sysres/Makefile.am
	* src/sysres/license/c_files/Makefile.am
	* src/sysres/license/Makefile.am

09/27: BUGFIXING #5028: make mTextLayoutNode count memeber unsigned int to int.
(humingming)
	* src/textedit/mtextedit.h

09/27: ENHANCEMENT #23: Update mgetc.c by using the latest etc/MiniGUI.cfg.
(wanzheng)
	* src/ial/ial.c
	* src/newgal/newgal.c
	* src/sysres/mgetc.c

09/27: BUGFIXING #5028 make set caret position correct.(humingming)
	* src/textedit/mtextedit.c
	* src/textedit/mtexteditbase.h

09/26: BUGFIXING #?: make MSG_NEWCTRLINSTANCE return valid value.(xwyan)
	* src/kernel/desktop-comm.c(dskOnNewCtrlInstance)

09/26: BUGFIXING #5037: Tunning the scrollbar show/hide policy of textedit: 
auto show/hide scrollbar if ES_AUTOVSCROLL|ES_AUTOHSCROLL style is set,
otherwise always show/hide scrollbar according to WS_VSCROLL|WS_HSCROLL
styles. (wanzheng)
	* include/ctrl/edit.h
	* src/textedit/mtextedit.c

09/25. BUGFIXING #?:Fix the bug GetNextMainWindow return the other procs's hwnd
when call it. (maoxinghui)
	* src/kernel/desktop-procs.c

09/25. BUGFIXING #5026: Fix the bug of dskScrollMainWindow. (wangxubin)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop.c
	* src/kernel/desktop-procs.c

09/21. BUGFIXING #5027: Fix the bug when use ScrollWindow control margin can't
refresh. (humingming)
	* src/control/scrolled.h
	* src/textedit/mtextedit.c

09/21. CLEANUP #4: Recover the modification between 13487:13491. (wanzheng)
	* clean_license.sh
	* Makefile.am
	* src/control/scrollview.c
	* src/gui/window.c
	* src/include/license.h
	* src/include/zorder.h
	* src/kernel/desktop.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/kernel/zorder.c
	* src/misc/license.c
	* src/server/layer.c

09/21. BUGFIXING #?: To release RC2, revert to revision 13487, and fix 
a compiling error.  (wanzheng)
	* src/kernel/desktop-comm.c
	* src/kernel/zorder.c
	* src/kernel/desktop.c
	* src/kernel/desktop-procs.c
	* src/control/scrollview.c
	* src/include/zorder.h
	* src/include/license.h
	* src/gui/window.c
	* src/misc/license.c
	* src/server/layer.c
	* clean_license.sh
	* Makefile.am

09/21. TUNNING #7: Disable CPU Type verification if __TARGET_UNKNOWN__ is
defined. (wanzheng)
	* src/gui/window.c
	* src/include/license.h
	* src/kernel/zorder.c
	* src/misc/license.c

09/21. BUGFIXING #?: Fix bug of GetNextMainWindow. (wanzheng)
	* src/include/zorder.h
	* src/kernel/desktop.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/kernel/zorder.c
	* src/server/layer.c

09/21. TUNNING #6: Remove a compiling warning of scrollview. (wanzheng)
	* src/control/scrollview.c

09/20. ENHANCEMENT #22: Modify all Makefile.am to support 
make distcheck.(zcyuan)

09/20. BUGFIXING #4992: Change to call _update_content_view() in
MSG_SIZECHANGED, not in MSG_CSIZECHANGED.(houhh)
	* src/textedit/mtextedit.c

09/20. BUGFIXING #5025: Fixed mismatch bug of GetClientDC and ReleaseDC in
TreeView(set_item_text). (xwyan)
	* src/ex_ctrl/treeview.c

09/20. ENHANCEMENT #21: Add script to clean license for 'make dist'. (zouqizhi)
	* clean_license.sh

09/20. BUGFIXING #5024: Fix the bug when click the space, caret don't the
display on the last char position. (humingming)
	* src/textedit/mtextedit.c

09/20. BUGFIXING #4981: Find another way to solve this issue: don't flush in
setText() if the textedit have not painted before. (wanzheng)
	* src/textedit/mtextedit.c
	* src/textedit/mtextedit.h

09/20. BUGFIXING #?: Fix bug of screensaver protected mechanism, Change it
from window to zorder node.(houhh)
	* src/misc/license.c
	* src/kernel/desktop.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-proc.c

09/20. BUGFIXING #4992: Fix the bug when in MSG_CREATE or MSG_INITDIALOG send
message EM_GETLINECOUNT can not get the correct count. (humingming)
	* src/textedit/mtextedit.c

09/19. BUGFIXING #4981: Solve the flicker issue of the new textedit control
when enable WS_EX_AUTOSECONDARY_DC. (wanzheng)
	* src/textedit/mtextedit.c

09/17. ENHANCEMENT #20: Add new textedit msg: EM_SETCARETPOSBYLINE,
EM_GETCARETPOSBYLINE, EM_SETSELPOSBYLINE, EM_GETSELPOSBYLINE. (humingming)
	* src/textedit/mtextedit.c
	* src/textedit/mtexteditbase.h
	* src/textedit/mtextedit.h
	* include/ctrl/edit.h

09/17. BUGFIXING #?: Fixed a bug div 0. (dongjunjie)
	* src/gui/window.c

09/16. ENHANCEMENT #19: Add hi3560a newgal to CMakeLists.txt, and add hi3560a
cpuid check. (zouqizhi)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/misc/license.c
	* src/ial/remoteial/netial_server.c
	* src/ial/remoteial/Makefile
	* CMakeLists.txt
	* cmake_mgconfig.h.in
	* configure.in

09/14. BUGFIXING #4980: fixed the redraw problem of scrolled optimization.(humingming)
	* src/control/scrollview.c
	* src/control/scrolled.h
	* src/ex_ctrl/iconview.c

09/07. BUGFIXING #4980: fixed the bug when after delete scrollview item can't
refresh the control.(humingming)
	* src/control/scrollview.c

09/07. BUGFIXING #4976: fixed the problem fashion render draw scrollbar's thumb
framework bound.(humingming)
	* src/gui/window.c

09/07. BUGFIXING #4972: fixed the bug in record and replay input event.
(wangxubin)
	* src/ial/auto-protocol.h
	* src/ial/qvfb.c
	* src/ial/auto.c

09/03. BUGFIXING #4971: fixed the bug that crash when quit, and fixed the bug
that can't quit when APP doesn't handle MSG_CLOSE. (wanzheng)
	* src/gui/window.c
	* src/kernel/desktop-comm.c
	* src/kernel/init.c
	* src/kernel/init-lite.c
	* src/kernel/message.c
	* src/misc/license.c
	* src/server/server.c

09/02. BUGFIXING #4950: fixed the bug that the window's frame miss a pixel.
	* src/gui/lf_classic.c

09/02. ENHANCEMENT #18: add FindMiniGUI.cmake to find minigui with pkg-config
in cmake project (ZhaolinHu)
	* cmake/FindMiniGUI.cmake

09/01. BUGFIXING #4950: fixed the bug that scrollbar's left arrow miss a
point(maoxh)
	* src/gui/lf_classic.c

09/01. BUGFIXING #4968: fixed the bug of screensaver. When screensaver is
exit, the edit input force is lost, this is a bug.(WangXuBin)
	* src/misc/license.c

09/01. BUGFIXING #4967: fixed the bug of screensaver. If input method is
turn on, the screensaver is not disabled when user input the char.(WangXuBin)
	* src/kernel/desktop-comm.c
	* src/kernel/init.c
	* src/kernel/event.c
	* src/include/license.h
	* src/misc/license.c
	* src/ial/pcxvfbial.c
	* src/server/server.c

09/01. BUGFIXING #4969: fixed the bug of scrollbar thumb calculation. If the
maxPos and minPos is too large in LFSCROLLBARINFO struct, the barLen cannot keep the same proportion
with pageStep, and the barStart and curPos would not be the same proportion
when the thumb at the end of scrollbar(dongjunjie)
	* src/gui/window.c
	* src/text/mtextedit.c

09/01. BUGFIXING #4961: Deal with when _mgs_button_down_main_window was
reset, but there real has a mouse up message. (humingming)
	* src/kernel/desktop-comm.c

08/30. BUGFIXING #4936: Fixed the bug that crash when quiting. (wanzheng)
	* include/minigui.h
	* src/ial/ial.c
	* src/ial/pcxvfbial.c
	* src/include/internals.h
	* src/include/mgsock.h
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/kernel/event.c
	* src/kernel/init.c
	* src/kernel/init-lite.c
	* src/kernel/timer.c
	* src/misc/license.c
	* src/server/server.c

08/30. BUGFIXING #?: Make splash and screensave independent, and optimize the
policy when generate key. (wanzheng)
	* src/gui/window.c
	* src/include/license.h
	* src/kernel/desktop.c
	* src/kernel/event.c
	* src/kernel/message.c
	* src/kernel/zorder.c
	* src/sysres/license/c_files/00_minigui.dat.c
	* src/sysres/license/c_files/01_fmsoft.dat.c
	* src/sysres/license/c_files/02_feiman.dat.c
	* src/sysres/license/c_files/03_progressbar.dat.c
	* src/sysres/license/c_files/04_progressbar-bk.dat.c
	* src/sysres/license/c_files/key.c
	* src/sysres/license/c_files/_splash_inner_res.c
	* src/sysres/license/genkey.sh
	* src/sysres/license/runme.sh

08/30. TUNNING# 5 : Change the policy of timeout and close msg of the 
protected-screen window(houhh).
	* src/kernel/desktop-comm.c
	* src/kernel/init.c
	* src/misc/license.c

08/27. BUGFIXING#4954, Add the '\b' and DEL(ascii code 127) proccess in
MSG_CHAR(dongjunjie)
	* src/textedit/mtextedit.c

08/27. TUNNING# 4 : merge new change of komoxo scripteasy font engine, add
some font file, update the linux scripteasy.so(houhh).
	* src/font/scripteasy.c
	* src/font/se_minigui.h
	* src/font/palette.h
	* 3rd-party/scripteasy/test/*

08/27. BUGFIXING#4952: Test ReadOnly flags when call Ctrl+V, and translate the
case of text in mTextEditor_setText and mTextEditor_insertText when uppercase and
lowercase flags are set(dongjunjie)
	* src/textedit/mtextedit.c

08/26. BUGFIXING #?: Fix IDM_CLOSEALLWIN if system menu, and do not show 
screen procted window in system menu(houhh).
	* src/misc/license.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

08/26. CLEANUP #2: Remove warnings of new textedit implementation (ymwei).
	* src/textedit/mtextedit.c

08/25. TUNNING# 3 Restore komoxo scripteasy font engine support(houhh).
	* src/font/scripteasy.c
	* src/include/devfont.h
	* src/newgdi/gdi.c

08/25. BUGFIXING #?, add __mg_parsor check in mg_TerminateLWEvent(houhh).
	* kernel/event.c

08/25. BUGFIXING #4920, fix dskScrollWindow in _MGRM_PROCESS mode, reimplement
OffsetRegionEx API, restore control listmodel code(houhh).
	* src/control/listmodel.c
	* src/kernel/desktop-procs.c
	* src/newgdi/region.c

08/25. BUGFIXING #4906,#4918,#4937, #4923(dongjunjie)
	* src/textedit/mtextedit.c

08/25. BUGFIXING #4924,#4929,#4930, add the NCSS_TE_TITLE flags
support(dongjunjie)
	* src/textedit/mtextedit.c
	* src/textedit/mtextedit.h

08/25. BUGFIXING #4904,#4096,#4915,#4916,#4917,#4923,#4928 (dongjunjie)
	* src/textedit/mtexteditbase.h
	* src/textedit/mtextedit.h
	* src/textedit/mtextedit.c

08/24. BUGFIXING#? : function OffsetRegionEx When FreeClipRect, didnot remove
the cliprect from the list of region(dongjunjie)
	* src/newgdi/region.c

08/24. TUNNING #2: rename _MG_MINIMALGRAF to _MG_MINIMALGDI (wanzheng)
	* configure.in
	* src/include/dc.h
	* src/kernel/init-lite.c
	* src/newgal/video.c
	* src/newgdi/gdi.c
	* src/newgdi/region.c
	* src/sysres/mgetc.c

08/20. BUGFIXING#4920: Change Viewport of ScrollView before InvalidateRect
relative area(houhh).
	* src/control/listmodel.c

08/20. BUGFIXING#4907: Change SetFocusChild to send MSG_SETFOCUS/MSG_KILLFOCUS
with lParam=1 to parent window, and change parent window do not Send 
MSG_SETFOCUS/MSG_KILLFOCUS to children(houhh).
	* src/gui/window.c

08/19. ENHANCEMENT #17: merge CMakeLists.txt form dev-3-0-cmake (ZhaolinHu)
	* src/kernel/CMakeLists.txt
	* src/include/CMakeLists.txt
	* src/standalone/CMakeLists.txt
	* src/sysres/icon/CMakeLists.txt
	* src/sysres/font/CMakeLists.txt
	* src/sysres/CMakeLists.txt
	* src/sysres/cursor/CMakeLists.txt
	* src/sysres/bmp/CMakeLists.txt
	* src/textedit/CMakeLists.txt
	* src/misc/CMakeLists.txt
	* src/ex_ctrl/CMakeLists.txt
	* src/gal/CMakeLists.txt
	* src/font/CMakeLists.txt
	* src/server/CMakeLists.txt
	* src/newgal/pcxvfb/CMakeLists.txt
	* src/newgal/CMakeLists.txt
	* src/newgdi/CMakeLists.txt
	* src/CMakeLists.txt
	* CMakeLists.txt
	* include/common.h
	* cmake_mgconfig.h.in

08/19. BUGFIXING #?: Fix bug when click window cpation abort in thread mode
and watermark switch. (humingming)
	* src/kernel/desktop-comm.c
	* src/sysres/license/c_files/_splash_inner_res.c

08/19. ENHANCEMENT #16: Modify some configure.in marco, e.g: MG_MGEFFSUPPORT,
MGHAVE_NEWTEXTEDIT and so on. (humingming)
	* src/control/textedit.c
	* src/kernel/Makefile.am
	* src/sysres/Makefile.am
	* src/standalone/Makefile.am
	* src/textedit/mbtree.c
	* src/textedit/mwidget.c
	* src/textedit/mtextedit.c
	* src/textedit/mtextedit.h
	* src/misc/license.c
	* src/misc/Makefile.am
	* src/Makefile.am
	* src/newgal/video.c
	* src/newgdi/Makefile.am
	* configure.in


08/19. BUGFIXING #4903: Add a note in API description. (ymwei)
	* include/minigui.h

08/18. CLEANUP #1: Clean up the configure options. (ymwei)
	* configure.in:
		* mgeffsupport -> minimalgraf
		* disable old TEXTEDIT control by default
		* enbale new TEXTEDIT control by default
		* enable ES_TITLE style of new TEXTEDIT control by default
		* enable dummy and console IAL engines by default
		* enable dlcustom IAL engines by default
		* disable GPM mouse support by default
		* disable qvfb IAL/GAL engines by default
		* disable TREEVIEWRDR control by default

08/18. TUNNING #1: Disable product-id support by default. (wanzheng)
	* configure.in

08/18. ENHANCEMENT #15: Add license management system, and merge the modifications
for Windows and GUIBuilder from trunk.  (merge from dev-3-0-license[13111:13231],
by houhuihua, humingming, wangxubin, wanzheng)
	M       src/control/propsheet.c
	M       src/control/newtoolbar.c
	M       src/control/static.c
	M       src/kernel/init-lite.c
	M       src/kernel/desktop-comm.c
	M       src/kernel/init.c
	M       src/kernel/zorder.c
	M       src/kernel/desktop.c
	M       src/kernel/event.c
	M       src/kernel/message.c
	M       src/kernel/desktop-procs.c
	M       src/include/internals.h
	A  +    src/include/license.h
	M       src/include/ial.h
	M       src/gui/window.c
	A  +    src/sysres/license
	A  +    src/sysres/license/runme.sh
	A  +    src/sysres/license/c_files
	A  +    src/sysres/license/c_files/07_watermark-evaluation.dat.c
	A  +    src/sysres/license/c_files/03_progressbar.dat.c
	A  +    src/sysres/license/c_files/05_watermark-fmsoft.dat.c
	A  +    src/sysres/license/c_files/01_fmsoft.dat.c
	A  +    src/sysres/license/c_files/00_minigui.dat.c
	A  +    src/sysres/license/c_files/02_feiman.dat.c
	A  +    src/sysres/license/c_files/06_watermark-minigui.dat.c
	A  +    src/sysres/license/c_files/key.c
	A  +    src/sysres/license/c_files/04_progressbar-bk.dat.c
	A  +    src/sysres/license/c_files/_splash_inner_res.c
	A  +    src/sysres/license/cryptool
	A  +    src/sysres/license/pictures
	A  +    src/sysres/license/pictures/05_watermark-fmsoft.png
	A  +    src/sysres/license/pictures/01_fmsoft.png
	A  +    src/sysres/license/pictures/00_minigui.png
	A  +    src/sysres/license/pictures/02_feiman.png
	A  +    src/sysres/license/pictures/06_watermark-minigui.png
	A  +    src/sysres/license/pictures/04_progressbar-bk.png
	A  +    src/sysres/license/pictures/07_watermark-evaluation.png
	A  +    src/sysres/license/pictures/03_progressbar.png
	D       src/sysres/evaluation
	D       src/sysres/evaluation/_eva_inner_res.c
	D       src/sysres/evaluation/makefile.ng
	D       src/sysres/evaluation/evb_1.png.c
	D       src/sysres/evaluation/evb_2.png.c
	D       src/sysres/evaluation/evb_3.png.c
	D       src/sysres/evaluation/inner.sh
	D       src/sysres/evaluation/evaluation
	D       src/sysres/evaluation/evaluation/evb_1.png
	D       src/sysres/evaluation/evaluation/evb_2.png
	D       src/sysres/evaluation/evaluation/evb_3.png
	D       src/sysres/evaluation/evaluation/p_up.png
	D       src/sysres/evaluation/evaluation/up.png
	D       src/sysres/evaluation/evaluation/p_down.png
	D       src/sysres/evaluation/evaluation/down.png
	D       src/sysres/evaluation/p_up.png.c
	D       src/sysres/evaluation/up.png.c
	D       src/sysres/evaluation/Makefile.am
	D       src/sysres/evaluation/p_down.png.c
	D       src/sysres/evaluation/down.png.c
	D       src/sysres/evaluation/CMakeLists.txt
	M       src/sysres/Makefile.am
	M       src/sysres/incoreres.c
	M       src/standalone/standalone.c
	M       src/textedit/mtextedit.c
	D       src/misc/evaluation.c
	D       src/misc/product-id.c
	D       src/misc/product-id.h
	A  +    src/misc/license.c
	M       src/misc/systext.c
	M       src/misc/Makefile.am
	A  +    src/misc/rc4.c
	A  +    src/misc/rc4.h
	M       src/ex_ctrl/iconview.c
	M       src/ial/winial.c
	M       src/font/freetype2.c
	M       src/font/freetype2.h
	M       src/font/upf.c
	M       src/font/devfont.c
	M       src/server/server.c
	M       src/newgal/pcxvfb/pcxvfb-winfb.c
	M       src/newgal/pcxvfb/pcxvfb.h
	M       src/newgal/newgal.c
	M       src/newgal/video.c
	M       include/gdi.h
	M       include/window.h
	M       include/common.h
	M       configure.in

08/17. BUGFIXING #4894, Fixed the bug when select text close the ime window in
sledit control. (humingming)
	* src/control/edit.c

08/13. BUGFIXING #4897, Fixed the bug get end_node in
textlayout_relayout(dongjunjie)
	* src/texteditor/mtextedit.c

08/12. BUGFIXING #4850, Fixed Scrolled control flicker(houhh).
	* control/scrolled.h
	* control/scrolled.c

08/11. ENHANCEMENT $14 Add CMakeLists.txt to root file and src file for cmake
(ZhaolinHu)
	*	src/kernel/CMakeLists.txt
	*	src/control/CMakeLists.txt
	*	src/image/CMakeLists.txt
	*	src/include/CMakeLists.txt
	*	src/main/CMakeLists.txt
	*	src/gui/CMakeLists.txt
	*	src/mybmp/CMakeLists.txt
	*	src/standalone/CMakeLists.txt
	*	src/sysres/CMakeLists.txt
	*	src/textedit/CMakeLists.txt
	*	src/misc/CMakeLists.txt
	*	src/ex_ctrl/CMakeLists.txt
	*	src/gal/CMakeLists.txt
	*	src/gdi/CMakeLists.txt
	*	src/ial/CMakeLists.txt
	*	src/font/CMakeLists.txt
	*	src/server/CMakeLists.txt
	*	src/libc/CMakeLists.txt
	*	src/ime/CMakeLists.txt
	*	src/newgal/CMakeLists.txt
	*	src/newgdi/CMakeLists.txt
	*	src/CMakeLists.txt
	*	src/client/CMakeLists.txt
	*	CMakeLists.txt

*******************************************************************************
What's new in this branch (3.0.8 OR, 2010/05/06 ~ 2010/08/06)

08/10. BUGFIXING #4887 #4888 the bug of texteditor. the textlayout_relayout
has is not corrent.
	* src/textedit/mtextedit.c

08/10. BUGFIXING #4885 some veriables haven't been initialized before used
(ZhaolinHu)
	* src/newgdi/glyph.c

08/06. BUGFIXING #4879 fixed Cursor position not fit with the
font width bug when font with style FONT_WEIGHT_BOOK (XuBinWang)
	* src/newgdi/glyph.c

08/06. BUGFIXING #4872 didnot exclude the title text when
mTextEditor_insertText(dongjunjie)
	* src/textedit/mtextedit.c
	* src/textedit/mtexteditbase.h

08/06. BUGFIXING #4878 fixed upf bug when the font move in or out with 
style FONT_WEIGHT_SUBPIXEL (ZhaolinHu)
	* src/newgdi/glyph.c

08/06. BUGFIXING #4873 fixed draw dot matrix font bug when it scale with
style FONT_WEIGHT_REGULAR. (humingming)
	* src/newgid/glyph.c

08/05. BUGFIXING #4864 Treeview can not set item height.When font size is set 
to a big value, the layout is not well organized.  (zhaochengzhang)
	* src/ex_ctrl/treeview.c

08/04. BUGFIXING #4860: make convert uncompatible pixel format bitmap 
and dc correct. (humingming)
	* src/gui/lf_common.c

08/04. CLEANUP #? Fix some warning. (zouqizhi)
	* src/gui/dialog.c
	* src/textedit/mtextedit.c
	* src/ex_ctrl/treeview.c

08/04. ENHANCEMENT #13 Rename dynamic ial to 'dlcustom'. Add sample of
libiale_custom.so. (zouqizhi)
	* configure.in
	* src/ial/ial.c
	* src/ial/Makefile.am
	* src/ial/dynamic-ial.c
	* src/ial/dynamic-ial.h
	* src/ial/dlcustom/Makefile.am
	* src/ial/dlcustom/dlcustom.h
	* src/ial/dlcustom/dlcustom.c
	* src/ial/dlcustom/sample/Makefile
	* src/ial/dlcustom/sample/iale_custom.c
	* src/ial/dlcustom/sample/iale_custom.h

08/04. BUGFIXING #4850: Solve the flicker issue of ScrollView control by
shrink the clip rect. (wanzheng)
	* src/gui/window.c

08/03. BUGFIXING #4862 Fix function _glyph_move_to_pixel receives point value less
than zero from  _dc_ft2subpixel_scan_line (ZhaolinHu)
	* src/newgdi/glyph.c

08/03. ENHANCEMENT #12 merge treeview.c form rel-2-0-4, previous treeview.c had
moved to treeview_rdr.c (zouqizhi)
	* src/gui/ctrlclass.c
	* src/ex_ctrl/treeview_rdr.c
	* src/ex_ctrl/Makefile.am
	* src/ex_ctrl/treeview.c
	* include/ctrl/treeview.h
	* configure.in

08/03. BUGFIXING #4861 Fix bug of MBS2WCSEx that make an error occurred when
converting half of the mutil-bytes character.(dongkai)
	* src/font/textops.c

08/03. BUGFIXING #4866 Fix HFlipBitmap/VFlipBitmap flip error when bitmap have
alpha_mask info. (houhh)
	* src/newgdi/bitmap.c

07/28. BUGFIXING: region cause the minigui crash. CLIPRECT's next member can
be NULL, but many functions didnot check it when they use the code like 
"while(r1) { .... r1 = r1->next}" (dongjunjie)
	* src/newgdi/region.c

07/29. BUGFIXING: ScrollWindowEx and Texteditor, merge from
rel-3.0(dongjunjie)
	* src/kernel/desktop-comm.c
	* src/include/dc.h
	* src/gui/window.c
	* src/textedit/mtextedit.c
	* src/textedit/mtextedit.h

06/30. BUGFIXING: #4801 Fix a bug which introduce a absolute path check error
in Windows (dongkai).
	* src/font/devfont.c
	* src/misc/misc.c

05/20. BUGFIXING: #? new textedit selection bug (dongjunjie)
	* src/textedit/textedit.c

05/18. CLEANUP #10: resolve compiling warning. (wanzheng)
	* src/newgal/videomem-bucket.c

05/14. ENHANCEMENT #29: Merge diffrences from dev-3-2.
svn merge -r 12343:12884 minigui/branches/dev-3-2 (wanzheng)

05/14. CLEANUP #9: Merge diffrences from rel-3-0.
svn merge -r 12874:12913 minigui/branches/rel-3-0 (wanzheng)
	* src/kernel/desktop.c
	* src/gui/caret.c
	* src/gui/window.c
	* src/sysres/resource.c
	* src/textedit/object.c
	* src/textedit/textedit.c
	* src/textedit/object.h
	* src/misc/evaluation.c
	* src/server/request.c
	* src/newgal/sigma8654/sigma8654.c
	* src/newgdi/readbmp.c
	* include/gdi.h
	* include/minigui.h
	* include/window.h

05/07. CLEANUP #8: Merge diffrences from rel-3-0.
svn merge -r 12160:12874 minigui/branches/rel-3-0 (wanzheng)
	* configure.in
	* ee-scripts
	* etc/MiniGUI.cfg
	* examples/hello_world.c
	* examples/helloworld.c
	* examples/Makefile.am
	* examples/ws_ex_notdraggable.c
	* GNUmakefile
	* include/ctrl/textedit.h
	* include/minigui.h
	* include/window.h
	* make_tarball
	* README
	* se-scripts
	* src/client/client.c
	* src/control/bidiedit.c
	* src/control/button.c
	* src/control/edit.c
	* src/control/listbox.c
	* src/control/scrollbar.c
	* src/control/textedit.c
	* src/ex_ctrl/iconview.c
	* src/ex_ctrl/listview.c
	* src/font/bitmapfont.c
	* src/font/fontcache.c
	* src/font/freetype2.c
	* src/font/freetype2.h
	* src/font/freetype.c
	* src/font/sjisunimap.c
	* src/font/upf.c
	* src/font/utils/sjis-unicode.txt
	* src/font/utils/sjisunimap.c
	* src/gdi/gdi.c
	* src/gdi/text.c
	* src/gui/caret.c
	* src/gui/dialog.c
	* src/gui/lf_classic.c
	* src/gui/lf_skin.c
	* src/gui/menu.c
	* src/gui/window.c
	* src/ial/cisco_touchpad.c
	* src/ial/cisco_touchpad.h
	* src/ial/custom.h
	* src/ial/ial.c
	* src/ial/Makefile.am
	* src/ial/native/kbd_event.c
	* src/ial/native/kbd_tty.c
	* src/ial/native/native.c
	* src/ial/native/native.h
	* src/ial/netial/README
	* src/ial/pcxvfbial.c
	* src/ial/qvfb.c
	* src/ial/tslibial.c
	* src/include/bitmap.h
	* src/include/client.h
	* src/include/cursor.h
	* src/include/dc.h
	* src/include/drawsemop.h
	* src/include/ial.h
	* src/include/internals.h
	* src/include/mgsock.h
	* src/include/ourhdr.h
	* src/include/sharedres.h
	* src/include/zorder.h
	* src/kernel/cursor-sa.c
	* src/kernel/desktop.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/kernel/desktop-sa.c
	* src/kernel/init.c
	* src/kernel/init-lite.c
	* src/kernel/message.c
	* src/kernel/sharedres.c
	* src/kernel/timer.c
	* src/kernel/zorder.c
	* src/Makefile.am
	* src/misc/listenfd.c
	* src/misc/misc-win.c
	* src/mybmp/winbmp.c
	* src/newgal/blit_A.c
	* src/newgal/commlcd/ecos_mv6600.c
	* src/newgal/fbcon/fbvideo.c
	* src/newgal/Makefile.am
	* src/newgal/nexus/nexusvideo.c
	* src/newgal/nexus/nexusvideo_pri.c
	* src/newgal/pcxvfb/pcxvfb.c
	* src/newgal/qvfb/qvfb.c
	* src/newgal/surface.c
	* src/newgal/sysvideo.h
	* src/newgal/video.c
	* src/newgdi/bitmap.c
	* src/newgdi/gdi.c
	* src/newgdi/glyph.c
	* src/newgdi/miarc.c
	* src/newgdi/mispans.c
	* src/newgdi/miwideline.c
	* src/newgdi/pixel.c
	* src/newgdi/pixel_ops.c
	* src/newgdi/readbmp.c
	* src/newgdi/rotatebmp.c
	* src/newgdi/tabbedtextout.c
	* src/server/request.c
	* src/server/server.c
	* src/sysres/resmgr.c
	* src/textedit
	* src/textedit/btree.c
	* src/textedit/btree.h
	* src/textedit/Makefile.am
	* src/textedit/object.c
	* src/textedit/object.h
	* src/textedit/test
	* src/textedit/test/buffertest.c
	* src/textedit/test/editortest.c
	* src/textedit/test/guohua.jpg
	* src/textedit/test/Makefile
	* src/textedit/test/notebook
	* src/textedit/test/notebook/main.c
	* src/textedit/test/notebook/Makefile
	* src/textedit/test/notebook/MiniGUI.cfg.fbcon
	* src/textedit/test/notebook/notebook.h
	* src/textedit/test/notebook/notebook_res_cn.h
	* src/textedit/test/notebook/notebook_res_en.h
	* src/textedit/test/notebook/notebook_res_tw.h
	* src/textedit/test/notebook/res
	* src/textedit/test/notebook/res/Makefile
	* src/textedit/test/notebook/res/Makefile.am
	* src/textedit/test/notebook/res/Makefile.in
	* src/textedit/test/notebook/res/notebook.ico
	* src/textedit/test/taocp.txt
	* src/textedit/test/textedittest.c
	* src/textedit/test/treetest.c
	* src/textedit/texteditbase.h
	* src/textedit/textedit.c
	* src/textedit/textedit.h
	* Version
	* ve-scripts

04/27. TUNNING #12: rename src/ial/tslib.? to tslibial.? (wanzheng)
	* src/ial/ial.c
	* src/ial/Makefile.am
	* src/ial/tslibial.c
	* src/ial/tslibial.h

04/27. ENHANCEMENT #28: Add GAL for S3C6410 (wanzheng)
	* src/newgal/videomem-bucket.h
	* src/newgal/videomem-bucket.c
	* src/newgal/video.c
	* src/newgal/sysvideo.h
	* src/newgal/surface.c
	* src/newgal/s3c6410/Makefile.am
	* src/newgal/s3c6410/gal-s3c6410.h
	* src/newgal/s3c6410/gal-s3c6410.c
	* src/newgal/Makefile.am
	* configure.in

04/09. BUGFIXING #4541: Change bitmap->bmType to right flag in
InitBitmapPixelFormat(houhh).
	* src/newgdi/readbmp.c

03/15. BUGFIXING #4532: Merge from rel-3-0 (wanzheng)
	* src/ex_ctrl/listview.c

02/22. BUGFIXING #4507: Add function declaration for cbrt/hypot in misc.h, else will
be error assuming extern returning int.
(houhh)
	* src/inlcude/misc.h
	* src/newgdi/miarc.c
	* src/newgdi/miwideline.c

02/10. BUGFIXING $4478: Recheck the pcxvfbial engine, don't need set kbd_state
in get_key() when wait_event() and delete get_key(), add convert
up/down/left/right in keyboard_update().(houhh)
	* src/ial/pcxvfbial.c

02/09. BUGFIXING #? : fflash(stdout) in function Ping cause the  guibuilder hangup in MSWindows.
Only hanppend When guibuilder working with eclipse
	* src/mics/mics.c
	* src/mics/mics-dt.c
	* src/mics/mics-win.c (add)

02/05. BUGFIXING #4491: error handling of typedata for MFT_RADIOCHECK and
MFT_MARKCHECK type. (ymwei) (merged from rel-3-0, by wanzheng)
	* include/window.h
	* src/gui/menu.c

02/05. BUGFIXING #4348: Check whether a DC is HDC_SCREEN_SYS. (dongkai, ymwei)
(merged from rel-3-0, by houhh)
	* src/newgdi/bitmap.c
	* src/newgdi/coor.c
	* src/newgdi/map.c

02/05. BUGFIXING #4392: Fix bug of program crash cause of memory address
not alignment in implementation of FreeType cache.(dongkai)
(merged from rel-3-0, by houhh)
	* src/font/freetype2.h
	* src/font/fontcache.c

02/05. BUGFIXING $4478: Fix cursor up/down/left/right key, such as SCANCODE_CURSORUP
should be convert to SCANCODE_CURSORBLOCKUP.(houhh)
	* src/ial/pcxvfbial.c


02/05. BUGFIXING #4440: Fix a bug to cause crash when the program which based
minigui standalone to quit(dongkai).
	* src/kernel/init-lite.c


02/05. BUGFIXING #4416: Fix calc nblk error before __ttc_cache_create, it
must calc after blksize with 4 byte alignment.(houhh)
	* src/font/freetype2.c
	* src/font/freetype.c
	* src/font/fontcache.c

02/05. BUGFIXING #4393: Fixed error write of array wnd_lf_info[i].name[LEN_RENDERER_NAME+1] 
in AddWindowElementRenderer(), Must note the array len is LEN_RENDERER_NAME. (houhh)
	* src/gui/lf_manager.c

01/23. BUGFIXING #?: Fix the bug that doesn't use the specified pixel value
when _glyph_draw_pixel(). It was a fault caused by fixing bug #4342 (wanzheng)
	* src/newgdi/glyph.c

01/21. TUNNING #11: Modify the custom gal. MiniGUI will get
struct CUSTOMGAL_bootstrap from libcustomgal.so but not customgal.c.
	* src/newgal/Makefile.am
	* src/newgal/custom/customgal.c
	* src/newgal/custom/customgal.h
	* src/newgal/custom/Makefile.am
	* configure.in

01/21. ENHANCEMENT #27: To better support mStudio GUIBuilder, add this
function : Users can register the given function to be called at normal
process termination. (rlzheng) 
	* src/ial/pcxvfb.h
	* src/ial/pcxvfbial.c

01/19. BUGFIXING #4425: Fix a bug of pcxvfb ial. Clear rset before return from
wait_event(). (wanzheng, merge from rel-3-0)
	* src/ial/pcxvfbial.c

01/13 BUGFIXING #4349: Fix bug of edit control. when edit control is
created CENTER style does not work. (zhaochengzhang)
	* src/control/edit.c

01/11 BUGFIXING #4336/4347/4350: Fix bug of static control which creates flags 
in confusion, and fix two bugs brought in last attempt fix bug 4336.
	* src/control/static.c
	* include/ctrl/static.h

01/11 CLEANUP #7: Delete some branches which are not allowed to change the
button size.(rlzheng)
	* src/control/button.c

01/08 BUGFIXING #4345: Fix bug of transparent button click display.(rlzheng)
	* src/control/button.c

12/26. ENHANCEMENT #26: Add a new screen DC: HDC_SCREEN_SYS. This is a screen
DC used by MiniGUI internally in order to avoid using HDC_SCREEN. (ymwei)
(merge from branches/rel-3-0, by wanzheng)
	* include/gdi.h
	* src/include/dc.h
	* src/newgdi/gdi.c
	* src/gui/menu.c
	* src/kernel/cursor*.c
	* src/kernel/desktop*.c

12/25 BUGFIXING #4318: Add lock/unlock when get glyph advance/bbox for
freetype font engine, (houhh).
	* src/newgdi/glyph.c

12/25. BUGFIXING #4289: Fix bug of output BITMAP to incompatible target DC. 
(kaidong)
	* src/gui/lf_classic.c
	* src/gui/lf_skin.c
	* src/gui/lf_tiny.c
	* src/gui/lf_flat.c
	* src/gui/lf_common.c

12/24. BUGFIXING #4319: Fix bug of dereference a NULL Pointer in
function calc_we_metrics.
(kaidong)
	* src/gui/lf_skin.c

12/23. TUNNING #5: Add Some print message when read or load bitmap
error, such as png|jpeg support not open/file io error(houhh).
	* src/mybmp/mybmp.c
	* src/mybmp/jpeg.c
	* src/mybmp/png.c
	* src/newgdi/readbmp.c

12/23. BUGFIXING #4284: Tune the new implementation of UpdateWindow(). (ymwei)
	* src/gui/window.c
	* src/kernel/message.c (return HWND_NULL instead of 0 for
	kernel_CheckInvalidRegion function)

12/22. BUGFIXING #4294: Fix bug of transparent button control's text display.
(houhh)
	* src/control/button.c

12/18. BUGFIXING #4284: Fix bug of the new implementation of UpdateWindow().
(ymwei)
	* src/gui/window.c

12/16. TUNNING #4: Tune the implementation of UpdateWindow() to support
transparent control. (wanzheng)
	* src/gui/window.c

12/16. TUNNING #3: Tune the implementation of UpdateWindow. (ymwei)
	* src/kernel/message.c (make static msgCheckInvalidRegion to be extern
	function, and rename it to kernel_CheckInvalidRegion).
	* src/include/internals.h (declare kernel_CheckInvalidRegion)
	* src/gui/window.c

12/16. OPTIMIZATION #1: Use get_opened_file_size instead of get_file_size.
(ymwei)
	* src/include/devfont.h
	* src/font/qpf.c
	* src/font/rawbitmap.c
	* src/font/upf.c

12/15. TUNNING #6: Remove "ENHANCEMENT #4" and tune the devfont selection when
creating LOGFONT. (ymwei)
	* src/font/varbitmap.c
	* src/font/rawbitmap.c
	* src/font/qpf.c
	* src/font/upf.c
	* src/font/devfont.c

12/15. TUNNING #2: Tune the devfont selection when creating LOGFONT. (ymwei)
	* src/font/devfont.c

12/14. BUGFIXING #?: Fix memory leak in get_file_size.
	* src/include/devfont.h

12/14. CLEANUP #6: Add prefix (mg_) for TerminateAccel and InitAccel functions.
(ymwei)
	* src/include/accelkey.h
	* src/gui/accelkey.c
	* src/kernel/init-lite.c
	* src/kernel/init.c

12/14. BUGFIXING #?: Calling pthread_cancel if the calling thread is not self.
(ymwei)
	* src/kernel/event.c

12/09. MAINTENANCE #1: Remove built-in smoothtimes UPF font instead of two times
UPF fonts. (ymwei)
	* src/font/in-core/upf_times*.c
	* src/font/devfont.c
	* src/font/in-core/Makefile.am
	* configure.in

12/09. TUNNING #1: make the type of number of spClassName of WNDCLASS to be
const char*. (ymwei)
	* include/window.h

12/08. CLEANUP : resolved some compile warning. (zou)
	* src/gui/lf_classic.c
	* src/gui/lf_flat.c
	* src/gui/lf_skin.c
	* src/font/in-core/rbf_vgaoem_8x8.c
	* src/font/in-core/rbf_terminal_8x12.c
	* src/font/in-core/rbf_fixedsys_8x15.c
	* src/newgal/pcxvfb/pcxvfb.c

12/07. BUGFIXING #4083: fixed scrollbar's drag error in listbox control.
(xwyan, add comment by houhh)
	* src/control/listbox.c

12/05. BUGFIXING #?: Fix memory leak of unloading QPF and VBF fonts. (ymwei)
	* src/font/qpf.c
	* src/font/varbitmap.c

12/05. BUGFIXING #?: Fix memory leak of FT2 engine. (ymwei)
	* src/font/freetype2.c
	* src/font/freetype2.h (cleanup)

12/02. BUGFIXING #4084: fixed trackar's eraseflag of invalidaterect when
drag the track.(houhh)
	* src/control/trackbar.c

12/02. ENHANCEMENT #25: Add the new netial support
	* src/ial/netial/Makefile
	* src/ial/netial/netial_server.c
	* src/ial/netial/client/Makefile
	* src/ial/netial/client/netial.c  
	* src/ial/netial/client/netial_ctrlwin.c
	* src/ial/netial/client/netial_ctrlwin.h

11/30. ENHANCEMENT #3: use zorder instead of alpha hole in Nexus GAL.
(wanzheng)
	* src/newgal/nexus/nexusvideo_pri.c

11/29. BUGFIXING #?: Fix memory leak of timer and parsor threads. (ymwei via
valgrind)
	* src/kernel/init.c
	* src/kernel/timer.c
	* src/kernel/event.c

11/29. BUGFIXING #?: Fix memory leak of unloading UPF fonts. (ymwei via valgrind)
	* src/font/upf.c

11/29. BUGFIXING #?: Fix buffer overflow bug of _glyph_blend_pixel and 
_glyph_blend_pixels. (ymwei via valgrind)
	* src/newgdi/glyph.c

11/29. BUGFIXING #?: Fix double-free bug of del_devfont_from_list. (ymwei
via valgrind)
	* src/font/devfont.c

11/29. BUGFIXING #?: Add mg_remove_timers_by_msg_queue to remove the timers
related to a specific MSGQUEUE, and call this function when delete the
MSGQUEUE. (ymwei via valgrind)
	* src/include/timer.h
	* src/kernel/timer.c
	* src/kernel/message.c (mg_DestroyMsgQueue)

11/29. BUGFIXING #?: Check pointer to MSGQUEUE when posting message. (ymwei
via valgrind)
	* src/kernel/message.c

11/29. BUGFIXING #?: Set size to be zero first in functions of GetTextExtent
and so on. (ymwei via valgrind)
	* src/newgdi/textout.c
	* src/newgdi/tabbedtextout.c

11/28. BUGFIXING #?: Should not change the dest_alpha when doing fast
ARGB888->(A)RGB888 blending with pixel alpha. (ymwei)
	* src/newgal/blit_A.c (BlitRGBtoRGBPixelAlpha)

11/28. BUGFIXING #?: Buffer overflow of WCS2MBSEx and MBS2WCSEx. (ymwei via valgrind)
	* src/font/textops.c

11/26. ENHANCEMENT #24: Add sigma8654 GAL engine (zhaochengzhang) 
	* src/newgal/sigma8654/sigma8654.c
	* src/newgal/sigma8654/sigma8754.h
	* src/newgal/sigma8654/Makefile.am
	* src/newgal/sysvideo.h
	* src/newgal/Makefile.am
	* configure.in
11/26. BUGFIXING #?: do not create hardware surface in GAL_CreateRGBSurfaceFrom().
It's a workaround for the bug that the bitmap can't be displayed in mPeer. (wanzheng)
See also `10/15. ENHANCEMENT #28'
	* src/newgal/surface.c

11/26. ENHANCEMENT #2: add NexusPrivate_CreateMemDCFromPixels() to support BitBlt()
from the `render plane' of flash-lite to the DC of a control. (wanzheng)
	* src/newgal/nexus/*

11/20. BUGFIXING #?: add MG_RES_PATH macro to replace resinfo.(houhh)
	* src/font/freetype2.c

11/12. ENHANCEMENT #1: modify the implement of radio button and check button,
make it repaint caption only when the background was erased.(dongkai)
	* src/control/button.c

11/09. BUGFIXING #?: change the usage of DEVFONT's data member in freetype2
font engine.(houhh)
	* src/font/freetype2.c

*******************************************************************************
What's new in this version (3.0.4 OR, 2009/04/15 ~ 2009/10/31)

10/30. TUNNING #2: Use kernel version to determine the mmap argument on uClinux.
(ymwei)
	* src/newgal/fbcon/fbvideo.c

10/26. BUGFIXING #?: fix invalid pWin pointer operation after window 
is destroyed in wndHandleCustomHotspot(). (houhh)
	* src/gui/window.c

11/23. BUGFIXING #4085: Fix the status error in drawing the vertical scroll bar only.
	* src/gui/lf_flat.c
	* src/gui/lf_skin.c

10/22. BUGFIXIN #?: Fixed the bug cause coredump, in listview.c lvDefCompare
function : don't process the Null Pointer, and send them to strncmp
(dongjunjie)
	* src/ex_ctrl/listview.c

10/22. CLEANUP #3: Cleanup the warnings:
	* src/control/listbox.c
	* src/ex_ctrl/listview.c
	* src/gui/lf_skin.c
	* src/font/in-core/rbf_vgaoem_8x8.c
	* src/font/in-core/rbf_terminal_8x12.c
	* src/font/in-core/rbf_fixedsys_8x15.c
	* src/newgal/pcxvfb/pcxvfb.c

10/22. BUGFIXING #?: check the `speed' parameter of SetTimerEx(), set speed to
1 if speed < 1. (wanzheng)
	* src/kernel/timer.c

10/18. ENHANCEMENT #29: Add dynamic-ial module. (wanzheng)
	* src/ial/dynamic-ial.*

10/15. CLEANUP #: Merge diffrences from rel-3-0.
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/include/ctrlclass.h
	* src/include/internals.h
	* src/gui/window.c
	* src/gui/lf_skin.c
	* src/newgdi/gdi.c
	* include/gdi.h
	* include/window.h
	* include/fixedmath.h
	* etc/MiniGUI.cfg

10/15. ENHANCEMENT #28: Optimize for the PNG bitmap with pixel alpha.(wanzheng)
	[A] _PutBoxAlpha(): optimize for the ARGB32 format. (10X faster than the
	normal method)
	[B] GAL_CreateRGBSurfaceFrom(): Try to create a hardware surface,
	this can make the hardware acceleration work when we blit the bitmap
	onto the screen. (10X faster than [A])
	* src/newgal/surface.c

10/15. CLEANUP #2: Merge diffrences from the trunk.

10/12. ENHANCEMENT #27: Make NexusGAL support pixel alpha blending.
(wanzheng)
	* src/newgal/nexus/*

10/15. ENHANCMENT #?: Add two function for mstudio : SetWindowZOrder and
GetWindowZOrder. Used by GUI Builder, PropSheet recreate page and
StructPanel's MoveUp, MoveDown
	* src/gui/window.c
	* include/window.h

10/09. BUGFIXING #4040: fix scrollbar's thumb, keep up smallest size
when it is too small(houhh).
	* src/gui/lf_classic.c
	* src/gui/lf_skin.c
	* src/gui/lf_flat.c

10/09. BUGFIXING #?: fix update error of propsheet control 
when used WS_EX_AUTOSECONDARYDC(houhh).
	* src/gui/window.c

09/29. BUGFIXING #?: cann't release the capture window 
when control has been removed.(xwyan)
	* src/kernel/desktop-comm.c(dskOnRemoveCtrlInstance)

09/24. BUGFIXING #?: exclude the child control area
in update_secondary_dc(), it will be cause flicker and update 
black control background when used tranparent contorl in mainwin
with WS_EX_AUTOSECONDARYDC. (houhh)
	* src/gui/window.c

09/23. BUGFIXING #?: fix bug that _wndInvaliateRect() always erase background 
without regard to bEraseBkgnd.(wanzheng)
	* src/gui/window.c

09/21. CUSTOMIZATION #1: Add custom code for mstudio in
propsheet/newtoolbar/iconview/listview/static.(xwyan)
	* src/control/propsheet.c
	* src/control/newtoolbar.c
	* src/ex_ctrl/iconview.c
	* src/ex_ctrl/listview.c
	* src/control/static.c

09/19. BUGFIXING #?: fix refresh bug in treeview.(xwyan)
	* src/ex_ctrl/treeview.c

09/19. BUGFIXING #?: fix ft2 font engine when double pitch align. (houhh). 
	* src/font/freetype2.c

09/14. TUNNING #2: Modify the flat renderer implementation of control
(propsheet, listview, and newtoolbar).(xwyan)
	* src/control/propsheet.c
	* src/control/static.c
	* src/ex_ctrl/listview.c
	* include/window.h
	* src/control/newtoolbar_impl.h
	* src/gui/lf_classic.c
	* src/gui/lf_flat.c
	* etc/MiniGUI.cfg

09/15. ENHANCEMENT #23: improvement freetype2 font engine's speed(houhh). 
	* src/font/freetype2.c
	* src/font/freetype2.h
	* src/font/fontcache.c
	* configure.in

09/15. ENHANCEMENT #22: Add GetIMEPos()/SetIMEPos() API for set/get
IME window position; Add Set IME Window position when call 
SetCaretPos().(houhh)
	* src/server/request.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/include/client.h
	* src/include/internals.h
	* src/gui/window.c
	* src/gui/caret.c
	* include/window.h

09/14. TUNNING #1: Modify the flat renderer implementation of control
(propsheet, listview, and newtoolbar).(xwyan)
	* src/control/propsheet.c
	* src/control/static.c
	* src/ex_ctrl/listview.c
	* include/window.h
	* src/control/newtoolbar_impl.h
	* src/gui/lf_classic.c
	* src/gui/lf_flat.c
	* etc/MiniGUI.cfg

09/14. BUGFIXING #?: fix bug when use MoveWindow to move control and 
fPaint is FALSE; cleanup up old comments. (houhh)
	* src/gui/window.c

09/02. ENHANCEMENT #21: Add the LogicFont Support for res manager; Add the
PWD path(./) support for res manager; res manager try to find the resource
from PWD path firstly. (dongjunjie)
	* src/sysres/resmgr.c
	* src/sysres/resmgr.h
	* include/window.h

09/01. TUNNING #?: Tune the implementation of control transparence: 
InvalidateRect, UpdateWindow, and BeginPaint. (dongjunjie)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/include/ctrlclass.h
	* src/include/internals.h
	* src/gui/window.c

08/14. BUGFIXING #?: fix bug after add buf_dc for textedit, if user
change font, textedit's title and display will be error; fix display 
text error when used ttf font. (houhh)
	* src/control/textedit.c

08/11. MAINTENANCE #?: add miss MG_EXPORT definition for LockDCEx and fixdiv
function (chenlei)
	* include/fixedmath.h
	* include/gdi.h

08/10. ENHANCEMENT #20: add LFRDR_BTN_STATUS_INACTIVE flag used for
draw_caption_button(), it is not need to judge window's active 
state internal. (houhh)
	* src/gui/window.c
	* src/gui/lf_flat.c
	* incldue/window.h

08/07. BUGFIXING #?: fix the bug CreateWindowEx2 : CreateWindowEx2 send
MSG_NEWCTRLINSTANCE to HWND_DESKTOP after it send MSG_NCCREATE. If user want
calling GetDC in the MSG_NCCREATE, the function RestrictControlECRGNEx who 
called by GetDC will access the children member of the control's  parent. But
Control's parent's children member is NULL, it will cause the deap loop at
(src/newgdi/gdi.c:173) "while(TRUE) { if(pRoot->children ==
pParent->pParent->children) .... " , both the "pRoot->children" and
"pParent->pParent->children" are NULL , children have been not yet set!!
MSG_NEWCTRLINSTANCE must be called before all the functions who would be
access children member (dongjunjie)
	* src/gui/window.c

08/05. MAINTENANCE #5: Fix the error description of GetWindowClassInfo
function and WNDCLASS structure. (ymwei)
	* include/window.h

08/05. BUGFIXING #?: fix update_secondary_dc() error when updata the 
border area, it exclude error client area when window is control.(houhh)
	* src/gui/window.c

08/05. BUGFIXING #?: fix the flicker problem of textedit.(houhh)
	* src/control/textedit.c
	* src/control/textedit_impl.h
	* src/control/ctrlmisc.c

08/05. BUGFIXING #?: fix bug of propsheet with PSS_SCROLLABLE and initializing 
zero window size.(xwyan)
	* src/control/propsheet.c

08/05. BUGFIXING #?: fix negative client size in OnChangeSize. It should be 
adjust calc_we_area implementation in window renderer.(xwyan)
	* src/gui/window.c

08/03. ENHANCEMENT #21: Add JZ4740 IAL, the ial default close
	* src/ial/jz4740.c
	* src/ial/jz4740.h

07/31. BUGFIXING #?: fix bug of lvDrawHeader/lvDrawheaderCustom/alvDrawSubItem
in listview.(xwyan)
	* src/ex_ctrl/listview.c

07/31. BUGFIXING #?: fix draw_caption() when window have not  
closebox button(houhh).
	* src/gui/lf_classic.c
	* src/gui/lf_skin.c

07/30. ENHANCEMENT #20: Add evaluation info dialog(interval 5 minites) 
for EVALUATION version(houhh).
	* src/misc/evaluation.c

07/30. BUGFIXING #?: fix dskMoveWindow when hava none-regular top
window(houhh).
	* src/kernel/desktop.c

07/30. ENHANCEMENT #19: Add watermark for EVALUATION version.
(houhh)
	* src/misc/evaluation.c
	* src/kernel/desktop.c
	* src/kernel/init.c
	* src/kernel/init-lite.c
	* src/server/server.c
	* include/zorder.h

07/30 BUGFIXING #?: fix bug of delete_page in propsheet.(xwyan)
	* src/control/propsheet.c

07/30 ENHANCEMENT #19: add SetWindowMaskEx API for none regular window, then
can use alpha bitmap for generate mask rect(houhh).
	* src/gui/window.c
	* include/window.h

07/29 BUGFIXING #3820: fix bug of scrolled when MSG_SIZECHANGED : ignore the
size changed when window's RECT is 0
	* src/control/scrolled.c

07/29 BUGFIXING #3829: fix listbox's LBS_SBALWAY style(houhh).
	* src/gui/lf_classic.c
	* src/gui/lf_skin.c
	* src/gui/lf_flat.c
	* src/control/listbox.c

07/28. ENHANCEMENT #17: Add product-id (wanzheng)
	* src/misc/product-id.c
	* src/misc/product-id.h
	* src/misc/Makefile.am
	* configure.in

07/28. BUGFIXING #? : listview draw grid border
	* src/ext_ctrl/listview.c

07/28. ENHANCEMENT #18: Add watermark for EVALUATION version.
(houhh)
	* src/kernel/cursor.c

07/28. ENHANCEMENT #17: Add inner resource for EVALUATION version.
(houhh)
	* src/sysres/resource.c
	* src/sysres/evaluation/*.c
	* src/sysres/Makafile.am
	* configure.in

07/27. ENHANCEMENT #16: Add the top and bottom border for EVALUATION version.
(wanzheng)
	* src/include/ial.h
	* src/newgal/video.c
	* src/newgal/surface.c
	* src/newgdi/gdi.c
	* configure.in

07/27. BUGFIXING #?: TreeView Scrollbar cannot update when treeview size
changed. (xwyan)
	* src/ex_ctrl/treeview.c

07/27. BUGFIXING #?: Modify the WINDOW_ELEMENT_RENDERER 's on_set_rdr_info and
on_get_rdr_info's define: add the param WINDOW_ELEMENT_RENDERER *; changed the 
skin rendrer's implement, avoid use __mg_wnd_rdr_skin in its function's
directly. (dongjunjie)
	* include/window.h
	* src/gui/lf_manager.c
	* src/gui/lf_skin.c

07/23. BUGFIXING #?: Fix compiling error for MoWei ECOS platform. (wanzheng)
	* src/ial/qvfb.c
	* src/ial/auto.c

07/22. BUGFIXING #?: Change implementation of Str2Key to avoid error in some
arch. (weiym)
	* src/sysres/sysmgr.c

07/22. BUGFIXING #?: Alter the defination of `NULL' for c++, to fix compiling
error in c++ codes. (wanzheng)
	* include/common.h

07/20. BUGFIXING #?: scrollview didn't recalc the content X and content Y when
SIZECHANGED. (dongjunjie)
	* src/control/scrolled.c
	* src/control/listmodel.c
	* src/ex_ctrl/iconview.c

07/20. BUGFIXING #?: CreateWindowEx WS_EX_USEPARENTRDR, WS_EX_USEPARENTFONT
should get the information from parent window, but not from main window.
(dongjunjie)
	* src/gui/window.c

07/20. MAINTENANCE #3: Add 'mstudio' target name and build script for mStudio.
(weiym)
	* configure.in
	* build/buildlib-linux-pc-mstudio

07/20. BUGFIXING #?: WndRect didnot calc the offset of CTRLASMAINWINDOW
control. (xwyan)
	* src/newgdi/gdi.c

07/20. BUGFIXING #?: RegisterResFromMem load mem resource faild, it is
used error resource ext name. (houhh)
	* src/sysres/resource.c

07/19. ENHANCEMENT #13: Add acclerated NEWGAL driver for Silicon Motion
graphics card by using libpciaccess. (ymwei)
	* src/newgal/fbcon/fbvideo.h
	* src/newgal/fbcon/fbvideo.c
	* src/newgal/fbcon/compiler.h
	* src/newgal/fbcon/pciinfo.h
	* src/newgal/fbcon/pcivideo.[ch]
	* src/newgal/fbcon/pci_smi.[ch] (for SMI graphics card)
	* configure.in

07/17. ENHANCEMENT #12: Record keyboard & mouse events in qvfb IAL, and 
auto play them in auto IAL. (wanzheng)
	* src/ial/qvfb.c
	* src/ial/auto.c
	* src/ial/auto-protocol.h
	* src/ial/Makefile.am

07/17. BUGFIXING #3714: After deleting the control with WS_EX_CTRLASMAINWIN in 
window, clicking the non-client in window will causes coredump. (xwyan)
	* src/gui/window.c

07/14. BUGFIXING #?: treeview, cannot control a node is fold or unfold. (xwyan)
	* src/ext_ctrl/treeview.c

07/10. ENHANCEMENT #15: Record keyboard & mouse events in qvfb IAL, and auto play
them in auto IAL. (wanzheng)
	* src/ial/qvfb.c
	* src/ial/auto.c
	* src/ial/auto-protocol.h

07/09. BUGFIXING #?: double buffer, WndRect did't consider the MainWindow and
AsMainWnd control; wndNCDrawFrame didn't update the caption form Secondary DC
to RealDC. (dongjunjie)
	* src/gui/window.c 
	* src/newgdi/gdi.c

07/09. ENHANCEMENT #14: Fixed bug double free when minigui exit, 
caused by pcxvfb ExitGUISafely. (houhh)
	* src/kernel/desktop-comm.c
	* src/kernel/init.c
	* src/kernel/init-lite.c

07/09. ENHANCEMENT #13: add MG_CFG_PATH env for set MiniGUI.cfg
path.(houhh)
	* src/misc/misc.c

06/27. BUGFIXING #?: Change LockDCEx() API, return true
if LockDCEx() success, else return false.(houhh)
	* src/newgdi/gdi.c
	* include/gdi.h

06/26. BUGFIXING #?: delete the semicolon when define 
CreateCompatibleDC(). (houhh)
	* include/gdi.h

06/19. BUGFIXING #?: recheck if need to ExitGUISafely when read mouse_updae
error. (houhh)
	* src/ial/qvfb.c

06/19. MODIFICATION #1: move __mg_update_window() from client_IdleHandler4Client()
to DefaultSystemMsgHandler(), do not update window in PeekMessageEx() directly, 
send MSG_UPDATEWIN to topmost of notify queue. (houhh)
	* src/gui/window.c
	* src/kernel/message.c

06/19. BUGFIXING #?: modfiy client spell error. (houhh)
	* src/client/client.c
	* src/kernel/init-lite.c
	* src/include/internal.h

06/13. BUGFIXING #?: Error handlding of GAL_CalculateAlphaBlit. (ymwei)
	* src/newgal/blit_N.c
	* src/newgal/blit_A.c

06/13. BUGFIXING #?: icon and cursor run correctly on screen with alpha.
(ymwei)
	* src/kernel/cursor-procs.c
	* src/kernel/cursor.c
	* src/kernel/cursor-sa.c
	* src/newgdi/pixel_ops.h
	* src/newgdi/icon.c

06/13. ENHANCEMENT #12: Make screen supports alpha. (ymwei)
	* src/newgal/pcxvfb/pcxvfb.c
	* src/newgal/video.c

06/11. BUGFIXING #?: Change the piority of heap mutex for uC/OS-II. (ymwei)
	* rtos/ucos2_startup.c

06/10. BUGFIXING #?: error macro definition _MGUSE_OWN_FNPRINTF in common.h.
(ymwei)
	* include/common.h

06/01. BUGFIXING #?: Bad definition of BUTTON_L, BUTTON_R, and BUTTON_M.
(ymwei)
	* src/ial/native/native.h

05/27. BUGFIIXING #?: trackback twinkling. (dongjunjie)
	* src/control/trackbar.c

05/26. BUGFIXING #?: Fix a bug of disable menubar item in TrackMenuBar.(xwyan)
	* src/gui/menu.c

05/25. ENHANCEMENT #11: enhance FillBoxWithBitmap() when BITMAP hava itself
pixelformat and set BMP_TYPE_ALPHACHANNEL bmType.(houhh).
	* src/newgal/surface.c

05/25. BUGFIXING #?: fixed DrawTextEx2() error when nFormart is DT_RIGHT, it will
error then logfonf->mbc_devfont is NULL(houhh).
	* src/newgdi/bidi.c

05/25. BUGFIXING #?: fixed pc_xvfb engine use env defaultmode when 
user set MG_DEFAULTMODE(houhh).
	* src/newgal/pcxvbf/pcxvfb.c

05/23. BUGFIXING #3653: restrict the DC's max size when 
use CreateSecondaryDC(houhh).
	* src/newgdi/gdi.c

05/23. BUGFIXING #?: move the operation of DC member's memset to the top 
of dc_InitMemDCFrom function. In Ubuntu 8.10, it caused that the pointer
of span_context is NULL. (xwyan)
	* src/newgdi/gdi.c

05/23. ENHANCEMENT #10: Remove the Item bkground of Iconview, make the item
bkground same as control's bkground. (dongjunjie).
	* src/ex_ctrl/iconview.c

05/23. ENHANCEMENT #9: Add the Cell Grid support for listview. (dongjunjie)
	* src/ex_ctrl/listview.c
	* src/ex_ctrl/listview.h

05/22. BUGFIXING #?: avoid tooltip close the popuped menu when tooltip hide it
self. It call ShowWindow, which would close the popup menu. (dongjunjie)
	* src/control/ctrlmisc.c

05/22. BUGFIXING #?: implement Tooltip for NewToolbar Control. (dongjunjie)
	* src/control/newtoolbar.c
	* src/control/newtoolbar_impl.h

05/22. BUGFIXING #?: Fix the TimerProc in PeekMessageEx. When PeekMessageEx
find TIMER flag, and call TimerProc, if TimerProc call PostMessage, the posted
messesages would not be processed invalidate (dongjunjie)
	* src/kernel/message.c

05/19. MAINTENANCE #2: Restore old libtool scripts. (ymwei)
	* configure.in
	* autogen.sh
	* Makefile.am
	* ltmain.sh

05/16. BUGFIXING #3601: Fixed the CreateMemDCFromBitmap the pixel format's
bug. (dengkexi)
	* src/newgdi/gdi.c 

05/13. ENHANCEMENT #8: Intend to add CopyCursor function. (ymwei)
	* include/minigui.h

05/12. ENHANCEMENT #7: Intend to add ScrollWindowEx and GetWindowRegion
functions. (ymwei)
	* include/window.h

05/12. ENHANCEMENT #6: Intend to add WindowFromPoint, ChildWindowFromPointEx,
ChildWindowFromPoint, and AdjustWindowRectEx functions. (ymwei)
	* include/window.h

05/12. ENHANCEMENT #5: Intend to add InvalidateRegion, ValidateRect,
and ValidateRegion functions. (ymwei)
	* include/window.h

05/09. ENHANCEMENT #4: Implements SelectClipRegionEx and OffsetClipRegion
functions. (ymwei)
	* include/gdi.h
	* src/newgdi/clip.c

05/09. ENHANCEMENT #3: Implements SelectPalette and RealizePalette functions. (ymwei)
	* include/gdi.h
	* src/newgdi/palette.c

05/05. BUGFIXING #3596: Fixed bug of InvalidateRect. (tangjianbin)
	* src/gui/window.c

05/05. BUGFIXING #?: Fixed error advance in GetGlypBitmap() when logfont 
with FONT_WEIGHT_BOLD style.(houhh)
	* src/newgdi/glyph.c 

05/05. CLEANUP #1: Delete prototype of function CreateSubPrivateDC which is
not implemented.(hejian)
	* inclucde/gdi.h

05/04. ENHANCEMENT #2: Add DestroyPalette, ResizePalette, SetPaletteEntries,
GetNearestColor functions. (ymwei)
	* include/gdi.h
	* src/newgdi/palette.c

05/02. ENHANCEMENT #1: Add GetClipBox and GetClipRegion functions. (ymwei)
	* include/gdi.h
	* src/newgdi/clip.c

05/02. MAINTENANCE #1: Add pkgconfig support. (ymwei)
	* minigui.pc.in
	* configure.in
	* Makefile.am

04/19. BUGFIXING #?: Fix the bugs of structrue QPFMETRICS in file qpf.h.
Change "Uint8 reserved[3]" to "Uint8 reserved" in the structrue of
QPFMETRICS. This BUG makes qpf can not display text correctly. (hejian)
	* src/font/qpf.h

04/17. BUGFIXING #?: Make the content of directory 3rd-part included in the
distributed package only when sefspport if enabled. (hejian)
	* 3rd-party/scripteasy/Makefile.am

04/16. BUGFIXING #?: Fix the bugs in gdi.h for doxygen. (hejian).
	* include/gdi.h

*******************************************************************************
What's new in this version (3.0.2 OR, 2009/03/04 ~ 2009/04/13)

04/13. ENHANCEMENT #3: Add NEWGAL/IAL engines for Nexus (Bcm7405). (wanzheng).
	* configure.in
	* src/newgal/nexus/*
	* src/ial/nexus/*
	* src/include/client.h
	* src/client/client.c

04/13. BUGFIXING #3464: (dongjunjie)
	* src/gui/window.c

04/13. BUGFIXING #?: Make DrawGlyph can receive NULL pointer. (ymwei)
	* src/newgdi/glyph.c

04/13. MODIFICATION #3: fixed some warning, cleanup the treeview
code, delete ICON_FOLD/ICON_UNFOLD.
	* include/window.h
	* src/ex_ctrl/treeview.c
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c
	* src/gui/lf_skin.c

04/13. CLEANUP #12: Cleanup the configure scripts.
	* autogen.sh
	* configure.in
	* ltmain.sh

04/12. CLEANUP #11: move gui_GetIconFile and gui_LoadIconRes to lf_manager.c
	* src/include/internals.h
	* src/gui/lf_classic.c
	* src/gui/lf_manager.c

04/11. CLEANUP #10: undefine PACK_* macros in common.h for apps. (ymwei)
	* include/common.h

04/11. CLEANUP #9: Cleanup the Doxygen API description. (ymwei)
	* include/minigui.h
	* include/gdi.h
	* include/window.h
	* examples/*.c

04/09. MODIFICATION #2: restore the TVS_WITHICON style of treeview(houhh).
	* include/window.h
	* include/ctrl/treeview.h
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c
	* src/gui/lf_skin.c
	* src/ex_ctrl/treeview.c
	* src/ex_ctrl/treeview_impl.c
	* etc/MiniGUI.cfg

04/09. ENHANCEMENT #2: Add full implementation of GB18030 charset
support. (ymwei)
	* src/font/mapunitogb18030.c
	* src/font/charset.c

04/08. CLEANUP #8: Add compilation conditions to the following files.
(ymwei)
	* src/font/mapunitogbk.c
	* src/font/mapunitobig5.c

04/08. BUGFIXING #?: Check and cleanup the implementation of GB18030 charset. 
(ymwei)
	* src/font/charset.c

04/03. BUGFIXING #? avoid the dead loop in ShowScrollBar. (dongjunjie)
	* src/gui/window.c

04/01. BUGFIXING #? set logfont's scale value to 1 when call freetype's 
get_font_size(), else the scale of logfont will be wrong.(houhh)
	* src/font/freetype2.c.
	* src/font/freetype.c.

04/01. BUGFIXING #?: LockDC return the pointer of upper-left corner of the
requested rectangle, so don't need intersect with effective rectangle. (houhh)
	* src/newgdi/gdi.c
	* include/gdi.h

03/30. BUGFIXING #? ttf font with FONT_WEIGHT_SUBPIXEL style draw error; add
_dc_which_region_ban() call in _dc_ft2subpixel_scan_line(), else if the glyph
that is part visible  will not draw out.(houhh)
	* src/newgdi/glyph.c
	* src/font/freetype2.c.

03/26. BUGFIXING #?: Use semaphore instead of pthread mutex in NEWGAL Shadow
for MiniGUI-Processes. (ymwei)
	* src/newgal/shadow/shadow.c

03/28. CLEANUP #7: Cleanup implementation of CreateLogFont. (ymwei)
	* src/font/logfont.c

03/26. BUGFIXING #?: Fix bug of in-core smoothtimes upf font. (ymwei)
	* src/font/in-core/upf_smoothtimes_100_50.c

03/28. CLEANUP #6: Cleanup look and feel manager. (ymwei)
	* src/gui/lf_manager.c

03/26. CLEANUP #5: Cleanup strings of messages. (ymwei)
	* src/include/msgstr.h

03/26. BUGFIXING #?: Fix bug of create first system logical font. (ymwei)
	* src/font/devfont.c
	* src/font/logfont.c

03/26. CLEANUP #4: Cleanup FBCon and Shadow NEWGAL engines. (ymwei)
	* src/newgal/fbcon/fbvideo.[ch]
	* src/newgal/shadow/shadow_refresh*.c

03/26. BUGFIXING #?: Fix bug of Shadow NEWGAL engine. (ymwei)
	* src/newgal/shadow/shadow.c

03/26. BUGFIXING #3447: In ARM platform, alignment problem when program
running on MiniGUI-Threads. (tangjianbin)
	* src/include/zorder.h
	* src/include/client.h
	* src/kernel/zorder.c

03/25. CLEANUP #3: Restore declarations of GAL_AllocateFormat and
GAL_FreeFormat into src/include/newgal.h. (ymwei)
	* src/include/newgal.h

03/24. BUGFIXING #3444: when mpeer create control, the size of control is abnormal. 
so listbox's scroll infomation is error. and In RecalcScrollInfo function, the
conditon to judge scroll whether hide is error.(tangjianbin)
	* src/control/listbox.c 
	* src/gui/window.c
	* src/ex_ctrl/treeview.c

03/24. CLEANUP #2: remove the old Composite api used for mgplus 1.0.(houhh)
	* include/gdi.h
	* src/newgdi/gdi.c

03/23. CLEANUP #2: Cleanup the doxygen documentation. (ymwei)
	* include/*.h

03/23. MODIFICATION #1: Send dwAddData as the lParam of MSG_NCCREATE for
control. (ymwei)
	* src/gui/window.c

03/23. MODIFICATION #1: Change the WS_EX_AUTOPRIVATEDC to WS_EX_AUTOSECONDARYDC.(houhh).
	* include/window.h
	* include/gdi.h
	* src/newgdi/gdi.c
	* src/gui/window.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

03/21. BUGFIXING #?: fix bugs of UPF implementation. (ymwei)
	* src/font/upf.c
	* src/font/devfont.c

03/21. BUGFIXING #?: use MAP_SHARED instead of MAP_PRIVATE for qpf and upf
fonts. (ymwei)
	* src/font/qpf.c
	* src/font/upf.c

03/17. ENHANCEMENT #1: Add buildlib-linux-i386-xvfb shell to build directory for 
building of ADP(Application Developing Package) for PC linux. (hejian)

03/09. BUGFIXING #3402. If mouse move the scrollbar to the end, and then
release the left button, the scrollbar will draw error.(dengkexi)
	* src/control/scrolled.c

03/09. BUGFIXING #3416. when select all text and delete it, core dump In 
fashion LF or In mpeer.(tangjianbin)
	* src/control/textedit_impl.h

03/07. BUGFIXING 3418. fix bug of mpeer, the menu width compute
error.(tangjianbin)
	* src/gui/menu.c

03/07. BUGFIXING 3402. fix bug of mpeer and compute the pagestep.(dengkexi)
	* src/gui/window.c

03/05. BUGFIXING #?. fix bug of Hi3560 platform by chenlei.(tangjianbin)
	* src/newgal/hisi/hi3560_fbvideo.h
	* src/newgal/hisi/hi3560_fb.h
	* src/newgal/hisi/hi3560_fbvideo.c

03/05. BUGFIXING #?. Add API CreatePrivateSubDC() for mPeer, clean the output
message in DrawTextEx2().(houhh)
	* src/newgdi/drawtext.c
	* src/newgdi/gdi.c

03/04. BUGFIXING #?. In Hi3560 platform, font_InitIncoreFonts function core
dump when load upf font.(tangjianbin)
	* src/font/in-core/upf_smoothtimes_100_50.c
	* src/font/devfont.c

03/04. BUGFIXING #?. don't use LFRDR_3DBOX_FILLED flags to draw_3dbox,
when draw_push_buttom with classic LF.becase the WE_MAINC_THREED_BODY color
cover the WE_BGC_WINDOW color.(tangjianbin)
	* src/gui/lf_classic.c

03.03. CLEANUP #1: Change include/window.h for Doxygen.

*******************************************************************************
What's new in this version (3.0.1 OR, 2008/12/06 ~ 2009/03/02)

03/02. CLEANUP #7: copyright info of headers. (ymwei)

03/02. CLEANUP #6: README, Makefile.am, configure.in, and so on. (ymwei)

03/01. BUGFIXING #?: modify UnlockDC to judge the DC whether is visiable. 
(dengkexi)
	* src/newgdi/gdi.c

02/26. CLEANUP #5: modify some function comment for doxygen.(houhuihua).
	* include/gdi.h
	* src/gui/window.c

02/23. BUGFIXING #3374. fixed draw border error when border is negative.
(dengkexi)
	* src/gui/lf_class.c

02/20. BUGFIXING #3365. edit the color of menu background.(tangjianbin)
	* etc/MiniGUI.cfg
	* src/gui/menu.c

02/19. CLEANUP #4: update komoxo's libscripteasy.so.(houhuihua)
	* src/font/scripteasy.c
	* 3rd-party/scripteasy/Makefile.am
	* 3rd-party/scripteasy/libscripteasy.so

02/16. BUGFIXING #3344.(houhuihua)
	* src/newgal/video.c 

02/13. BUGFIXING #3341. fix bug 3341, when double clicked, need to 
determine whether in the head of listview.(tangjb)
	* src/ex_ctrl/listview.c

02/11. ENHANCEMENT #17: Add API SPtoLP and LPtoSP.(dengkexi)
	* include/gdi.h 

02/09. BUGFIXING #3325 3327 3330.fix the bug of keyboard layout.(tangjb)
	* src/gui/de-kmap.c
	* src/gui/es-cp850-kmap.c
	* src/gui/es-kmap.c
	* src/gui/fr-kmap.c

02/05. BUGFIXING #3298. fix the bug of Menubar.(tangjb)
	* src/gui/menu.c

02/03. BUGFIXING #3324 3325. fix the bug in KeyboardLayout of france
pc and German.(tangjb) 
	* src/gui/de-kmap.c
	* src/gui/fr-pc-kmap.c

02/02. BUGFIXING #3331. fix the bug of listview.(tangjb) 
	* src/ex_ctrl/listview.c

02/02. BUGFIXING #3322. fix the MACRO SS_WHITEFRAME interpret.(tangjb) 
	* include/ctrl/static.h

02/02. BUGFIXING #3321. fix the SetKeyboardLayout functure interpret.(tangjb) 
	* include/window.h

01/23. BUGFIXING #?. add Fashion render to MiniGUI.cfg(dengkexi) 
	* etc/MiniGUI.cfg

01/22. BUGFIXING #?. add 3rd-party/scripteasy/Makefile.am
	* 3rd-party/scripteasy/Makefile.am

01/20. ENHANCEMENT #16. add the komoxo's sef font module to
minigui.(houhuihua)
	* configure.in
	* src/Makefile.am
	* 3rd-party/scripteasy/Makefile.am
	* 3rd-party/scripteasy/test/sample.c

01/14. ENHANCEMENT #15. add 3rd-party/scripteasy for komoxo scripteasy font
surport. (houhuihua).
	* src/font/se_minigui.h
	* src/font/scripteasy.c
	* 3rd-party/scripteasy/font_table.c
	* 3rd-party/scripteasy/dejavu_sans_ttf.h
	* 3rd-party/scripteasy/fzxhgb_yh_ttf.h

01/13. CLEANUP #3. cleanup LockDCEX. (denkexi).
	* src/newgdi/gdi.c

01/13. BUGFIXING# ?: increase the surface->map->format_version in
GAL_MapSurface(), resolve two diffirent memdc will use same
surface->map->sw_data->blit func (houhuihua).
	* src/newgal/pixels.c

01/13. BUGFIXING #?. fixed bug of LockDC and LockDCEx. (ymwei)
	* src/newgdi/gdi.c

01/13. BUGFIXING #3309.(houhuihua).
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/gui/window.c

01/13. BUGFIXING #?, fixed the LockDCEx coor compute error.
	* src/newgdi/gdi.c

01/12. BUGFIXING #3299, set the window bkcolor and dialog's font and fgc
color(houhuihua).
	* src/gui/dialog.c
	* src/control/static.c
	* src/gui/lf_manager.c

01/12. BUGFIXING #3307 (tangjianbin) 
	* include/gdi.h

01/12. CLEANUP #2, Remove compilation warnings (ymwei)
	* src/kernel/desktop.c
	* src/newgdi/clip.c
	* src/control/listmodel.c
	* src/control/edit.c

01/08. BUGFIXING# 3304, FONT_WEIGHT_LIGHT/BOOK style disaply
question(houhuihua).
	* src/newgdi/glyph.c

01/08. BUGFIXING# 3293 (houhuihua), 
	* src/sysres/resource.c
	* src/sysres/incoreres.c

01/09. ENHANCEMENT #14 Add LVM_GETSELECTEDITEMRECT for Listview.
(dongjunjie)
	* include/ctrl/listview.h
	* src/ext_ctrl/listview.c

01/08. BUGFIXING##3292 3294 3298.(tangjianbin)
	* src/gui/lf_skin.c

12/29. BUGFIXING#?: fixed the MoveWindow to erase the change size window.
	* src/gui/window.c

12/25. BUGFIXING#?: small mistake ouput info "NEWGAL" as "NWEGAL".
	* src/newgal/blit.c
	* src/newgal/gamma.c
	* src/newgal/video.c

12/25. ENHANCEMENT #13: add ClientToWindow() and WindowToClient() API.(houhh)
	* include/window.h
	* src/gui/window.c

12/25. ENHANCEMENT #12:modify ON_UPDATE_SECONDARYDC, add one para main_update_rc rect
info for SecondaryDC's update_sec() callback.(houhh) 
	* include/gdi.h
	* src/gui/window.c

12/19. BUGFIXING #?: fixed AS MAINWIN Control's bug: when delete a control if
this control is a ASMINWIN control, it will not clear itself form its
MainWindow list: hFristCtrlAsMain (dongjunjie)
	* src/include/ctrlclass.h
	* src/gui/window.c

12/19. BUGFIXING #?:fixed the draw_progress can not erase the backgound.(dengkexi)
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c

12/18. ENHANCEMENT #11: when close qvfb or pc_xvfb, exit minigui app; add
comment for EndPaint()'s deal will privCDC(houhh).
	* src/gui/window.c
	* src/ial/pcxvfbial.c
	* src/ial/qvfb.c

12/18. CLEANUP #1: cleanup code SelectClipRect() and
dc_GenerateMemDCECRgn.(houhh).
	* src/newgdi/gdi.c
	* src/newgdi/clip.c

12/18. BUGFIXING #?:if user close pc_xvfb directly, can not use exit(0), else minigui 
can not exit safely.
	* src/ial/pcxvfbial.c

12/18. BUGFIXING #?:fixed the progressbar's coruscation, because of pbarOnNewPos
used InvalidateRect to erase the background.(dengkexi)
	* src/control/progressbar.c

12/08. CLEANUP #1: remove unused variables.
	* src/newgdi/glyph.c

12/08. BUGFIXING #?: _dc_draw_pixel_span_and_2: MAKELONG (MAKEWORD)
	* src/newgdi/gdi.c

*******************************************************************************
What's new in this version (3.0.1 RC5, 2008/08/01 ~ 2008/12/05)

12/05. BUGFIXING #?: TreeView message TVM_GETITEMINFO cannot get dwAddData:
	* src/ex_ctrl/treeview.c

12/05. ENHANCEMENT #10: enhance the clip process of memdc and screendc, uniform use
the lcrgn for process clip.(houhh).
	* src/include/dc.h
	* src/newgdi/clip.c
	* src/newgdi/gdi.c

12/03. BUGFIXING #?: pLogFont of desktop_win is assigned to NULL when 
init_desktop_win, so a window which has WS_EX_USEPARENTFONT style cann't 
get right value of pLogFont from dsk_win.(tangjb)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

12/02. BUGFIXING #?: bitmap_scaler adjust.(tangjb)
	* src/newgdi/bitmap.c

12/02. BUGFIXING #?: Restore the old erasebkgnd machine; Add
GetSecondaryClientDC/ReleaseSecondaryDC API for Secondary DC, enhance the
GetSecondaryDC API(houhh).
	* include/gdi.h
	* src/include/dc.h
	* src/gui/window.c
	* src/newgdi/gdi.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

12/01. CLEANUP #1: Remove compliation warnings.
	* src/gui/lf_flat.c
	* src/newgdi/bitmap.c

11/27. ENHANCEMENT #9: add GDCAP_AMASK to GetGDCCapability function. 
	* src/newgdi/gdi.c
	* include/gdi.h
	* src/include/newgal.h

11/27. BUGFIXING #?: the edges of right and bottom bitmap handled wrong 
in Biliner scaler ALG.
	* src/newgdi/bitmap.c

11/25. BUGFIXING #?: append the pallete's color memcpy action in SaveDC(),
modify the span_context save action in SaveDC().
	* /src/newgdi/gdi.c
	* /src/include/dc.h

11/24. MODIFICATION #4: add bitmap_scaler operation in function SaveDC, 
RestoreDC and GetSubDC.
	* /src/newgdi/gdi.c

11/24. BUGFIXING #?: get_linear_pt function can't compile when open -O2 option.
	* /src/newgdi/bitmap.c

11/20. MODIFICATION #3: cancel BitmapDDAScaler and BitmapDDAScaler2 to public API.
	* include/gdi.h
	* src/newgdi/bitmap.c

11/20. BUGFIXING #?: lost button up message when system is busy.
	* src/kernel/message.c: kernel_QueueMessage

11/20. MODIFICATION #2: delete GetPixelFormat function.
	* include/gdi.h
	* src/newgdi/gdi.c

11/20. MODIFICATION #1: add MG_EXPORT and GUIAPI prefix to pulic API declaration.
	* include/gdi.h

11/20. ENHANCEMENT #8: add Biliner scaler ALG function.
	* include/gdi.h
	* src/include/dc.h
	* src/newgdi/gdi.c
	* src/newgdi/bitmap.c

11/19. BUGFIXING #?: Auto and Random IAL engines can not work under
MiniGUI-Processes.
	* src/ial/auto.c
	* src/ial/random.c

11/13. BUGFIXING #?: bugs of 3-byte per pixel.
	* src/newgdi/bitmap.c

11/11: TUNNING #1: tune the __mg_os_time_delay implementation for VxWorks and
UNIX.
	* src/misc/nposix.c

11/10: BUGFIXING #?: PThread implementation of RTOSes:
	* pthread_setspecific
	* pthread_create for VxWorks.
	* POSIX semaphore for VxWorks.

*******************************************************************************
What's new in this version (3.0.1 RC4/3/2/1, 2008/08/01 ~ 2008/10/31)

10/30: BUGFIXING #3099: deal with itself's SyncMsg first before 
SendSyncMessage to other thread, because other thread maybe wait
for SyncMsg for you.
	* src/kernel/message.c

10/30: BUGFIXING #?: move pWin->fErase = FALSE before erase_bk,
because pWin->fErase maybe set TRUE when do the erase_bk(houhh).
	* src/gui/window.c

10/27: BUGFIXING #3079.(tangjianbin)
	* src/ex_ctrl/treeview.c

10/24: BUGFIXING #3099.(tangjianbin)
	* src/gui/window.c

10/23: BUGFIXING #?, control with WS_EX_ASCTRLMAINWIN style(such as combox), you
can not click it if outside the mainwin.(houhh)
	* src/gui/window.c

10/23: merge branches of dev-3-0-2, rename global variable and
function.(tangjianbin)

10/21: if used SecondaryDC, enhancement the control with WS_ASCTRLMAINWIN style 
to surpport SecondaryDC also, change draw_secondary_nc_area() paras. (houhh). 
	* src/gui/window.c
	* src/include/dc.h

10/03: BUGFIXING #3091, #3095, #3096 (houhh). 
	* src/gui/window.c
	* src/ex_ctrl/iconview.c

10/07: BUGFIXING #?: fix bug of 24bit in function BitmapDDAScaler. (xkwu)
	* src/newgdi/bitmap.c

10/06: BUGFIXING #3090, change ShowScrollBar() error.(houhh). 
	* src/gui/window.c

10/06: BUGFIXING #3089, WS_EX_CLIPCHILDREN style window not need
to Exclude transparent control area(houhh). 
	* src/gui/window.c

10/06: BUGFIXING 3073: fix RBF font's RBFINFO.(houhh)
	* src/font/rawbitmap.h
	* src/font/in-core/rbf_fixedsys_8x15.c
	* src/font/in-core/rbf_terminal_8x12.c
	* src/font/in-core/rbf_vgaoem_8x8.c

09/26: BUGFIXING 3094: 
	* src/kernel/init.c

09/26: BUGFIXING 3073: fix ShowCursor() in MiniGUI-Thread error.(houhh)
	* src/kernel/cursor.c

09/26: BUGFIXING 3084: Fix bug of set_window_element_data.(xwyan)
	* src/gui/lf_manager.c

09/25: BUGFIXING 3080&3083: Fix bug of calc_vscroll_area and
calc_we_area.(xwyan)
	* src/gui/lf_skin.c

09/22: BUGFIXING 3071: make_charpos_visible() for edit with ES_PASSWORD
style, fix calc cursor position error.(houhh)
	* src/font/edit.c

09/17: BUGFIXING: Add TerminateIncoreFonts() for IncoreFont
memory leak. (houhh)
	* src/font/devfont.c
	* src/include/devfont.h

09/11: ENHANCEMENT #7: Color composition with alpha. (xkwu)
	* src/newgal/surface.c
	* src/newgal/blit_A.c

09/11: OPTIMIZATION #3: The implementation of SetWindowRegion and
SetWindowMask for MiniGUI-Processes runtime mode.
	* include/minigui.h: Add ClientRequestEx function. 
	* src/include/zorder.h
	* src/include/client.h
	* src/kernel/desktop.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/client/client.c
	* src/server/request.c
	* src/gui/window.c

09/11: ENHANCEMENT #6: Add IAL engine for TSLib.
	* configure.in
	* src/ial/ial.c
	* src/ial/tslib.c
	* src/ial/tslib.h

09/05: BUGFIXING #3025.(ymwei)
	* src/font/freetype2.c
	* src/newgdi/glyph.c

09/05: BUGFIXING #3029.(xwyan)
	* src/font/fontname.c
	* src/font/devfont.c
	* src/font/logfont.c
	* include/gdi.h

09/05: BUGFIXING #3028.
	* src/newgal/blit.h

09/04: BUGFIXING #?: Fix the bug of InvalidateRect(), transparent
control in WS_EX_AUTOPRIVATEDC style window, paint to dc direct,
change it to buffer memdc.

09/04. BUGFIXING #2979:Tune the implementation of transparent style. 
(xwyan)
	* src/ex_ctrl/animation.c

09/04. BUGFIXING #3023:(xwyan)
	* src/font/devfont.c

09/04. BUGFIXING #3018: Fix a bug for getting mouse status in 
GetKeyStatus().(xwyan)
	* include/customial.h
	* src/kernel/event.c
	* src/ial/*.c

09/04. BUGFIXING #3017: According to matched device font, change
the logfont properties of type, family, charset and size in 
gdiCreateLogFont.(xwyan)
	* src/font/logfont.c

09/04: BUGFIXING#: set update_rc in BeginPaint is change, set it 
after SelectClipRegion(), update_rc maybe change after Select opt.

09/03: TUNNING #13: Add transparent support for CTRL_STATIC with
SS_GROUPBOX.(xwyan)
	* src/control/static.c

09/02: BUGFIXING #3013: 
	* src/sysres/font/_font_inner_res.c

09/01: ENHANCEMENT #5: Add an incore UPF font: smooth times 
	* src/font/in-core/upf_smoothtimes_100_50.c
	* src/font/devfont.c

09/01: BUGFIXING #3005/3008/3009/3011:
	* src/font/logfont.c
	* src/newgdi/glyph.c

09/01: BUGFIXING #?:function _rotate_scale_flip_coordinates in file
rotatebmp.c may cause overflow in fixed multiply operate.This BUG is found in
iphone like DEMO running on iPAQ.
	* src/newgdi/rotatebmp.c

09/01: BUGFIXING #?:fixmul function maybe overflow when use long type variable
to contain the result of multiply operator.So ,change the long type variable
to unsigned long type.
	* src/misc/math.c

09/01: ENHANCEMENT #4: Define ON_UPDPRVDC_DEFAULT and ON_UPDPRVDC_DONOTHING
for the callback procedure for the private DC update.
	* include/gdi.h
	* src/newgdi/gdi.c
	* src/gui/window.c

08/31: BUGFIXING #?: handling of WS_EX_TRANSPARENT and WS_EX_CLIPCHILDREN style.
	* src/gui/window.c

08/31: BUGFIXING #?: endless loop of fixdiv. Move the implementation of fixmul
and fixdiv into src/misc/math.c.
	* include/fixedmath.c
	* src/misc/math.c

08/31: BUGFIXING #?: change bmpfont def_glyph's width/height to 0.

08/31: BUGFIXING #?: Remove mask rect records if a client quit.
	* src/kernel/desktop.c
	* src/kernel/desktop-procs.c

08/30: BUGFIXING #?: Redefine MAX_SYS_REQID to the correct value.
	* include/minigui.h

08/30: TUNNING #12: Rename RetrivePrivateDC to GetPrivateDC.
	* include/gdi.h
	* src/newgdi/gdi.c

08/30: BUGFIXING #?: DeletePrivateDC when call SetPrivateDC (hwnd,
HDC_SCREEN)
	* src/newgdi/gdi.c

08/30: TUNNING #11: Redefine HDC_INVALID to 0xFFFFFFFF
	* include/gdi.h

08/30: ENHANCEMENT #3: Add new item for GetGDCapability: GDCAP_PITCH
	* include/gdi.h
	* src/newgdi/gdi.c

08/30: BUGFIXING #?: SetWindowRegion
	* src/gui/window.c

08/30: ENHANCEMENT #2: Add new IAL engine for iPAQ H5400.
	* src/ial/ipaq-h5400.h
	* src/ial/ipaq-h5400.c

08/29: BUGFIXING:  if --disable-cursor, mginit can not update auto(qvfb),
(ShowCursorForGDI).
	* src/kernel/cursor-procs.c 

08/29: TUNNING #10: Change the default resource installation path to
/usr/local/share
	* etc/MiniGUI.cfg

08/28: BUGFIXING #2997: Fix a bug of erasing background problem.(xwyan)
	* src/ex_ctrl/monthcalendar.c

08/28: BUGFIXING #3003: (xwyan)
	* src/gui/window.c

08/27: BUGFIXING #3004:
	* src/newgdi/glyph.c

08/27: BUGFIXING #3001:
	* src/control/textedit.c

08/27: BUGFIXING #2984: Fix a bug of tvDrawItem in treeview control.(xwyan)
	* src/ex_ctrl/treeview.c

08/27: BUGFIXING #3000:
	* src/newgdi/glyph.c

08/27: BUGFIXING #2996: Tune ToolTipWin without border/frame.(xwyan)
	* src/control/ctrlmisc.c

08/26: ENHANCEMENT #9: Add RGB2Pixels, RGBA2Pixels, Pixel2RGBs, and Pixel2RGBAs
functions. Define RGB2Pixel, RGBA2Pixel, Pixel2RGB, Pixel2RGBA to be inline
functions to the above new functions.
	* include/gdi.h
	* src/newgdi/pixel.c

08/26: BUGFIXING #?: Handle special color depth like 18-bpp:
	* src/newgal/blit.c
	* src/include/dc.h

08/26: OPTIMIZATION #2: Using runlength to optimize regular glyph output.
	* src/newgdi/glyph.c

08/26: BUGFIXING #2981: Fix IS_VSCROLL_VISIBLE and 
IS_HSCROLL_VISIBLE macro error. (xwyan)
	* src/gui/lf_common.h

08/26: BUGFIXING #2993
	* src/newgdi/glyph.c

08/26: TUNNING #9: Rename the help icon name.
	* etc/MiniGUI.cfg

08/27: BUGFIXING #:uniform rule of processing scrollbar.(xwyan)
	* src/control/listbox.c
	* src/control/scrolled.c
	* src/control/textedit.c
	* src/gui/window.c lf_classic.c lf_flat.c lf_skin.c

08/26: TUNNING #8: Move the implementation of ToolTipWin from mGUtils to
MiniGUI core:
	* include/control/ctrlhelper.h
	* src/control/ctrlmisc.c
	* src/ex_ctrl/coolbar.c

08/26: TUNNING #7: Add prompt information to start mginit first.
	* src/kernel/init-lite.c

08/26: BUGFIXING #2991: Use GetDC for desktop instead of CreatePrivateDC.
	* src/kernel/desktop-procs.c

08/26: TUNNING #6: Define _LITE_VERSION and _STAND_ALONE for back-compatibility.
	* configure.in

08/26: BUGFIXING #2985: Scrollbar position error in treeview.(xwyan)
	* src/ex_ctrl/treeview.c

08/26: BUGFIXING #2980: Process Backspace in combobox with CS_AUTOSPIN.(xwyan)
	* src/control/combobox.c

08/25: BUGFIXING #?: decoding of images for special depth:
	* src/mybmp/mybmp.c

08/25: BUGFIXING #?: Crash of TextEdit:
	* src/newgdi/scrollview.c

08/25: BUGFIXING #2986
	* src/newgdi/glyph.c

08/25: TUNNING #5: Remove the seperator of system menu.
	* src/gui/menu.c

08/25: TUNNING #4: Tune the text position of AboutDialog.
	* src/misc/about.c

08/25: BUGFIXING: Fix a bug _gdi_draw_one_glyph, which not process
alExtra.(xwyan)
	* src/newgdi/glyph.c

08/25: BUGFIXING #2886: Fix a hilite bug of menu.(xwyan)
	* src/gui/menu.c (mnu_scroll_menu, cursor_block_up)

08/25: BUGFIXING #2864: Fix a bug of calc_thumb_area(barLen error).(xwyan)
	* src/gui/lf_classic.c
	* src/gui/lf_flat.c
	* src/gui/lf_skin.c

08/24: ENHANCEMENT #1: Add a new method for FONTOPS: get_char_type to return
the glyph type the devfont can give us.
	* src/include/devfont.h
	* src/font/*.c

08/24: OPTIMIZATION #1: glyph render routines:
	* src/newgdi/glyph.c

08/22: Fix bug of incorrect caret and tune the implementation of BeginPaint
and EndPaint.
	* src/include/internals.c
	* src/gui/window.c

08/22: Add API RGB2Pixels and RGBA2Pixels
	* src/newgdi/pixel.c
	* include/gdi.h

08/22: BUGFIXING #2972: Fix a bug of mnuGetMenuBarRect.(xwyan)
	* src/gui/menu.c

08/22: BUGFIXING #2889: Fix a bug of caret problem of textedit without 
ES_AUTOWRAP style.(xwyan)
	* src/newgdi/tabbedtextout.c (GetTabbedTextExtent)

08/22: BUGFIXING #?: Use BytesPerPixel instead of BitsPerPixel to create
private alpha pixel format (to support special color depth like 18-bpp).
	* src/newgdi/bitmap.c
	* src/newgdi/attr.c
	* src/newgdi/gdi.c

08/22: CLEANUP #10: Clean up the incore cursor data definition.
	* src/sysres/cursor/cursors.c
	* src/sysres/incoreres.c

08/22: CLEANUP #9: Make the incore-font data empty.
	* src/sysres/font/*.c

08/22: CLEANUP #8: Make the default font configuration simple.
	* etc/MiniGUI.cfg

08/22: BUGFIXING #2798. (tangjianbin)
	* src/font/freetype2.c

08/22: BUGFIXING. Compile error, with freetype2.c:'ttf_ops' undeclared.(tangjianbin)
	* src/font/freetype2.c

08/21: TUNNING #4: Add some default incore RBF and VBF.
	* configure.in
	* src/font/rawbitmap.c
	* src/font/varbitmap.c
	* src/newgdi/gdi.c
	* src/in-core/*

08/21: CLEANUP #7: Declar set_window_element_data in element.h:
	* src/include/element.h

08/21: Merge branches dev-3-0-1 to trunk.(xwyan)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop.c
	* src/include/ctrlclass.h
	* src/include/internals.h
	* src/include/dc.h
	* src/gui/window.c
	* src/ex_ctrl/listview.c
	* src/newgdi/gdi.c
	* src/newgdi/clip.c
	* include/gdi.h
	* include/window.h

08/21: BUGFIXING #2971. (tangjianbin)
	* src/sysres/resmgr.c

08/21: TUNNING #3: According to the resource-manager rebuilding , 
Change the resource registiering and loading for lf_skin.(wangjian)
	* src/gui/lf_manager.c 
	* src/gui/window.c 
	* src/gui/lf_skin.c 
	* src/sysres/resource.c 
	* include/window.h

08/21: CLEANUP #6. Delete useless file.(tangjianbin)
	* src/sysres/bmp/Makefile.in
	* src/sysres/cursor/Makefile.in
	* src/sysres/icon/Makefile.in
	* src/sysres/font/Makefile.in

08/20: BUGFIXING #2899. (tangjianbin)
	* src/gui/lf_skin.c

08/20: BUGFIXING #2913: CreateMemDCFromMyBitmap should return HDC_INVALID when 
the color depth is less than 8.
	* src/newgdi/gdi.c
	* include/gdi.h

08/19: CLEANUP #5: ext/control is needless, useful code in src/ex_ctrl (tangjianbin)
	* ext/control

08/19: BUGFIXING #2893. (tangjianbin)
	* src/ex_ctrl/monthcalendar.c

08/15: CLEANUP #4: Cleanup the obsolete IME status code.
	* include/window.h

08/15: BUGFIXING #?: Fix error handling for MSG_IME_SETTARGET message.
	* src/kernel/desktop-comm.c

08/15: TUNNING #5: Move InitRendererSystemIcon and TermRendererSystemIcon from
internals.h to window.h
	* include/window.h
	* src/include/internals.h

08/15: TUNNING #4: Recover DisabledTextOutEx function. (weiym)
	* include/ctrl/ctrlhelper.c
	* src/control/ctrlmisc.c

08/14: BUGFIXING #2901/2905. (weiym)
	* src/control/textedit.c

08/14: TUNNING #3: Move Fashion LFRDR to mGPlus. (weiym)
	* configure.in
	* src/gui/lf_manager.c
	* src/gui/Makefile.am

08/14: CLEANUP #3: Cleanup all error output information. (weiym)

08/14: TUNNING #2: Enable all local charset support by default except
GB18030 (weiym):
	* configure.in

08/14: BUGFIXING #2767 (weiym):
	* configure.in

08/14: BUGFIXING #2851 (weiym):
	* src/newgdi/attr.c

08/14: BUGFIXING #2806: Remove reference to SYSBMP_LOGO and SYSBMP_IMECTRLBTN (weiym):
	* include/window.h
	* src/misc/about.c

08/14: CLEANUP #2: Remove Tiny LFRDR:
	* configure.in
	* src/gui/lf_manager.c
	* src/gui/Makefile.am

08/14: CLEANUP #1: Cleanup the window style definitions (weiym).
	* include/window.h

08/14: TUNNING #1: Enable usage of WS_EX_NOPARENTNOFITY (weiym).
	* include/window.h
	* src/control/ctrlmisc.c

*******************************************************************************
What's new in this version(3.0.0, 2008/06/01 ~ 2008/07/31)

07/21. houhh bugfixed for independent scrollbar for window.  
	* src/gui/window.c

07/08. Add the auto scaling for radio button and checkbox button. And fixed
the wrong config of mgetc.c about fashion LF in incore res mode (dongjunjie)
	* src/gui/lf_classic.c
	* src/gui/lf_tiny.c
	* src/gui/lf_flat.c
	* src/gui/lf_fashion.c
	* src/gui/lf_skin.c
	* src/sysres/mgetc.c
	* src/server/server.c
	* src/newgdi/bitmap.c
	* include/gdi.h
	* etc/MiniGUI.cfg


What's new in this version (2.2.1, 2008/01/01 ~ 2008/03/31):

0708. For bug 2860. (lfzhang) configure about incore resource .
	* src/sysres/mgetc.c

07/02. Ajust the postions of InitGDI and InitSystemRes in InitGUI, for the
core dump when pLogFont of HDC_SCREEN is used. (wangxuguang)
	* src/kernel/init-lite.c

06/30. Adjust the postion of fuction TerminateDesktop, for the core dump when
a window closing in standalone. (wangjian)
	* src/kernel/init-lite.c

06/30. Fixed a bug of standalone---bug2850. (wangjian)
	* src/kernel/desktop-comm.c

06/27. Fixed a bug of combobox causing core dump (dongjunjie)
	* src/control/combobox.c

06/26. Whe a main window has WS_DLGFRAME style, it should not be resizable.
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c
	* src/gui/lf_skin.c
	* src/gui/lf_tiny.c

06/25. Modify SkinLF draw border, make it can fill full border
bitmap.(lfzhang)
	* src/gui/lf_skin.c

06/25. DialogBoxIndirectParamEx: if hOwner is a control, DialogBox should get
its main window and disable the mainwindow.
	* src/gui/dialog.c

06/19. SLEdit Control: if you click a sledit and get a new caret pos, that its
selection pos doest not change
	* src/newgal/edit.c

06/18. ENHANCEMENT #8: For the alpha problem for BitBlt in JZ4740.(wangjian)
	* src/newgal/surface.c
	* src/newgal/video.c
	* src/newgal/blit.c
	* src/newgal/blit_A.c

06/18. For bug 2801. (dongjunjie) Invalidate Caret Showing of SLEdit Control
	* src/control/edit.c

06/18. For bug 2827. (dongjunjie) A Modal Dialog Owner can revcieve mouse
message when its Mode Dialog is showing.
	* src/gui/window.c

06/18. For bug 2809. (dongjunjie) A Control With WS_EX_CTRLASMAINWIN is
outsid the main window will not receive the mouse message.
	* src/gui/window.c
	* src/include/internals.h
	* src/include/ctrlclass.h

06/18. For bug 2802. (dongjunjie) twice creating controls for
CreateMainWindowIndirectParamEx
	* src/gui/dialog.c

06/18. For bug 2820.(wangjian)
	* src/gui/window.c

06/13. For the directdraw invalid rect more wide than screen.(dengkexi)
	* src/newgdi/gdi.c

06/12. For the Alpha lossing problem in JZ4730/4740.(wangjian)
	* src/newgal/surface.c

06/04. Modify SetDefaultWindowElementRenderer API about
__mg_def_renderer.(lfzhang)
	* src/gui/lf_manager.c

06/04. Modify incore resource skin-arrows.c.(lfzhang)
	* src/sysres/skin-arrows.c

06/04. BUGFIXING #2769 : Fix incore resource core dump.(lzhang)
	* src/sysres/mgetc.c
	* src/gui/lf-skin.c

05/29. BUGFIXING #2774 : Fix a bug for bidicontrol.(liupeng)
	* src/control/bidiedit.c

05/28. BUGFIXING #2775 : Fix a bug for non-regular window.(wangjian)
	* src/kernel/desktop-procs.c
	* src/kernel/desktop-comm.c

05/22. Modified skin-bkgnd.png to skin-bkgnd.bmp, so modify lf_skin.c &
etc/MiniGUI.cfg.(lfzhang)
	* src/gui/lf_skin.c
	* etc/MiniGUI.cfg

05/21. BUGFIXING #2763 : Fix part of a bug for textedit.(wangjian)
	* src/control/textedit.c

05/19. Modify skin-bkgnd.png to skin-bkgnd.bmp, so modify incore resource.
(lfzhang)
	* src/sysres/skin-bkgnd.c

05/16. BUGFIXING #2765 : Fix a bug of freetype2. (wangxuguang)	
	* src/font/freetype2.c

05/15. BUGFIXING #2761 : Fix a bug about judging for mouse postion.(liupeng)
	* src/kernel/desktop.c

05/13. BUGFIXING #2742 : Fix a bug of bidiedit control.(liupeng)
	* src/control/bidiedit.c

05/09. BUGFIXING #2723 : Fix a bug for bitblt.(wangjian)
	* src/newgdi/bitmap.c

05/09. BUGFIXING #2730 : Add vowel support in bidiedit. (wangxuguang)	
	* include/gdi.h
	* src/newgdi/bidi.c
	* src/newgdi/drawtext.h
	* src/newgdi/textout.c

05/09. BUGFIXING #2750 : Fix a bug for scrollbar control.(wangjian)
	* src/gui/window.c
	* src/gui/lf_skin.c

05/08. BUGFIXING #2713 : FIx a bug about draw arabic vowal.(wangxuguang)
	* src/newgdi/bidi.c
	* src/newgdi/textout.c

05/07. BUGFIXING #2741 : Fix a bug of bidiedit control.(liupeng)
	* src/control/bidiedit.c

05/07. BUGFIXING #2735 : Fix a bug of bidiedit control.(liupeng)
	* src/control/bidiedit.c

05/06. BUGFIXING #2726 : Fix a bug of bidiedit control.(liupeng)
	* src/control/bidiedit.c

05/05. BUGFIXING #2689 : Fixa bug about erasebkgnd.(lfzhang)
	* sr/gui/lf_skin.c

05/05. BUGFIXING #2676 : Fix a bug about incore configure.(wangjian)
	* src/sysres/mgetc.c
	* include/minigui.h

05/05. BUGFIXING #2696 : Fix a bug about changing window size.(wangjian)
	* src/gui/window.c

04/30. BUGFIXING #2704 : Fix a bug about cursor.(wangjian)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

04/30. BUGFIXING #2711 : Fix bugs in SetWindowMask.(zhounuohua)
	* src/gui/window.c

04/30. BUGFIXING #2710 : Fix a bug about non-regular window.(wangjian)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

04/29. BUGFIXING #2706 : Fix bugs about caption button.(zhounuohua)
	* src/gui/window.c

04/28.BUGFIXING #2693:Support vertical slider of trackbar.
Add incore resource file of trackbar vertical slider.
(lfzhang)
	* src/gui/lf_skin.c
	* etc/MiniGUI.cfg
	* src/sysres/skin-tbslider-v.c
	* src/sysres/skin-res.c
	* src/sysres/Makefile.am
	* include/window.h

04/25. BUGFIXING #2690, 2698 : Fix bugs about non-regular window.(wangjian)
	* src/gui/window.c
	* src/kernel/desktop.c

04/25.Modify incore resource file of skin-bkgnd.png, and Makefile.am.
(lfzhang)
	* src/sysres/skin-bkgnd.c
	* src/sysres/Makefile.am
	* etc/Minigui.cfg

04/24. Add incore resource files of skin LF
(lfzhang)
	* src/sysres/skin-res.c
	* src/sysres/skin-arrows-shell.c
	* src/sysres/skin-arrows.c
	* src/sysres/skin-bborder.c
	* src/sysres/skin-bkgnd.c
	* src/sysres/skin-caption.c
	* src/sysres/skin-checkbtn.c
	* src/sysres/skin-cpn-btn.c
	* src/sysres/skin-header.c
	* src/sysres/skin-lborder.c
	* src/sysres/skin-pb-hchunk.c
	* src/sysres/skin-pb-htrack.c
	* src/sysres/skin-pb-vchunk.c
	* src/sysres/skin-pb-vtrack.c
	* src/sysres/skin-pushbtn.c
	* src/sysres/skin-radiobtn.c
	* src/sysres/skin-rborder.c
	* src/sysres/skin-sb-arrows.c
	* src/sysres/skin-sb-hshaft.c
	* src/sysres/skin-sb-hthumb.c
	* src/sysres/skin-sb-vshaft.c
	* src/sysres/skin-sb-vthumb.c
	* src/sysres/skin-tab.c
	* src/sysres/skin-tb-horz.c
	* src/sysres/skin-tb-slider.c
	* src/sysres/skin-tb-vert.c
	* src/sysres/skin-tborder.c
	* src/sysres/skin-tree.c

04/24.Modify initialize function about skin LF, and any name of resource.
(lfzhang)
	* srs/gui/lf_skin.c
	* etc/Minigui.cfg

04/08. BUGFIXING #2495 : Fix hit test of window with tiny style.
(zhounuohua)
	* src/gui/lf_tiny.c

04/01. BUGFIXING : Fix a bug of qvfb and  pcxvfb about MSG_KEYLONGPRESS.
(wangxuguang)
	* src/ial/qvfb.c
	* src/ial/pcxvfbial.c

03/31. BUGFIXING #2646: Add macro control for flat resource.(xwyan)
	* src/sysres/resource.c

03/31. BUGFIXING #2643: Cleanup Makefile.(xwyan)
	* src/include/Makefile.am
	* src/font/Makefile.am
	* src/newgdi/Makefile.am

03/28. EXCHANGEMENT: optimize FillPolygon fill.(houhh)
1.add PolygonGeneratorEx enhancement.
2.change PolygonGenerator to macro for compatible.
	* gdi.h
	* src/newgdi/polygon.h
	* src/newgdi/polygon.c

03/27. Add destroying mutex lock in rtos_xvfb ial.(liupeng)
	* src/ial/rtos_xvfb.c

03/21. Modify drawing method of caption, caption button, border in skin
LF.(xwyan)
	* src/gui/lf_skin.c
	* src/gui/lf_manager.c

03/21. BUGFIXING : Add default glyph in bitmap font.(liupeng)
	* src/font/bitmapfont.c

03/20. Merge dev-2-2-1 to trunk. (xwyan)

03/18. BUGFIXING #1374: Fix FillPolygon.(tangjianbin)
	* src/newgdi/polygon.h
	* src/newgdi/polygon.c

03/14. BUGFIXING #2624: Fix SET_DEVFONT_SCALE and GET_DEVFONT_SCALE.(zhounuohua)
	* src/include/devfont.h

03/10. BUGFIXING #2533: Fix SHADOW_SetVideoMode. (lfzhang)
	* src/gui/newgal/shadow/shadow.c

03/06. BUGFIXING #2546: Fix SetWindowCaption. (zhounuohua)
	* src/gui/window.c

03/05. BUGFIXING #2535: Fix bug. (wangjian)
	* src/kernel/desktop-procs.c

03/05. BUGFIXING #2611: Fix wrong path of pc_xvfb. (zhounuohua)
	* src/sysres/mgetc-pc.c

03/05. BUGFIXING #2523: Change function to draw the caption. (dengkexi)
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c
	* src/gui/lf_flat.c

03/04. BUGFIXING #2523: Fix caption title draw. (dengkexi)
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c
	* src/gui/lf_flat.c

03/04. BUGFIXING #2569 & 2567 & 2561: clip region of caption bar. (zhounuohua)
	* src/gui/menu.c

03/04. BUGFIXING #2599: propsheet show erro. (dengkexi)
	* src/control/propsheet.c

02/19. BUGFIXING #2530: show caption button. (zhounuohua)
	* src/gui/window.c

02/18. BUGFIXING #2574: Fix a bug of fontConvertFontType.(xwyan)
	* src/font/fontname.c
	* include/gdi.h

02/18. BUGFIXING #2557: Tune the positon of some parameters
declaration.(xwyan)
	* src/control/button.c
	* src/gui/lf_manager.c
	* makefile.ng
	* src/newgal/makefile.ng

02/18. BUGFIXING #2571: Add macro __NOUNIX__ to limit the function of
loading qpf font dynamically. (xwyan)
	* src/font/qpf.h devfont.c

02/02. BUGFIXING #2542: Tune the matching for ISO8859-1 charset. (weiym)
	* src/font/charset.c

02/02. BUGFIXING #2566: Cleanup macro name. (xwyan)
	* src/font/rawbitmap.c

01/31. BUGFIXING #2536: Fix a bug of srvSetActiveWindow in 
MiniGUI-Processes. (xwyan)
	* src/kernel/desktop-procs.c

01/30. BUGFIXING #2552: Fix a bug of FONT_WEIGHT_ALL. (xwyan)
	* src/font/fontname.c

01/30. BUGFIXING #2549: Cleanup shadow engine. (xwyan)
	* src/newgal/shadow/shadow.c

01/30. BUGFIXING #2550 & 2520 & 2551: Cleanup configure.in. (xwyan)
	* configure.in

01/24. BUGFIXING #2527: Fix a bug of WS_EX_USEPARENTRDR. (xwyan)
	* src/gui/window.c

01/24. BUGFIXING #2521: Fix drawing menubar item. (zhounuohua)
	* src/font/menu.c

01/24. BUGFIXING #2524: Fix freetype compiling error. (xwyan)
	* src/font/freetype.[ch]

01/24. BUGFIXING #2470: Incorrect rendering of BOOK/LIGHT style.(liupeng)
	* src/newgdi/drawtext.c

01/23. BUGFIXING #2517: Fix bug about loading and destroying dynamic font.
(xwyan)
	* include/gdi.h
	* src/font/qpf.[ch] freetype.[ch] freetype2.[ch] devfont.c
	* src/include/devfont.h

01/23. BUGFIXING #2491: Fix bug about pcxvfb in standalone. (wangjian)
	* src/ial/pcxvfbial.c
	* src/newgal/pcxvfb/pcxvfb.c

01/23. BUGFIXING #2504: Fix bug about desktop in procs. (wangjian)
	* src/kernel/desktop-procs.c

01/22. BUGFIXING #2514: Compiling error with "--enable-eucjpsupport" opening.
(liupeng)
	* src/font/charset.c

01/22. BUGFIXING #2481: truncation caption string if it is too
long.(wangxuguang)	
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c
	* src/gui/lf_flat.c					  

01/21. BUGFIXING #2495 & 2496 & 2497 & 2501: Fix tiny scrollbar. (zhounuohua)
	* src/gui/lf_flat.c

01/21. BUGFIXING #2465: Cleanup metrics of caption button. (wangxuguang)	
	* include/window.h
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c
	* src/gui/lf_flat.c
	* src/gui/lf_tiny.c

01/21. BUGFIXING #2506: Cleanup flat incore resource file.(xwyan)
	* src/sysres/flat-xxx-btn.c

01/21. BUGFIXING #2500: Cleanup mlshadow engine file.(xwyan)
	* etc/MiniGUI.cfg mvfb.cfg
	* src/newgal/mlshadow/mlshadow-xxx.c

01/17. TUNNING:	Get some font properties from "FONTS and FONTBOUNDINGBOX" in
bdf file. (wangxuguang)
	* src/font/utils/bdf2vbf.c				   

01/16. BUGFIXING #2488: Fix the bug for pc_xvfb error print.(wangjian)
	* /src/newgal/pcxvfb/pcxvfb.c

01/16. BUGFIXING #2464 & 2487: Fix the bug about cap_btn and combobox.(wangjian)
	* src/gui/lf_classic.c
	* src/gui/lf_fashion.c
	* src/gui/lf_flat.c
	* src/gui/lf_tiny.c
	* src/control/combobox.c

01/15. BUGFIXING #2466: Fix the separator in menubar.(zhounuohua)
	* src/gui/menu.c

01/14. BUGFIXING #2473: Cleanup system resource file.(xwyan)
	* src/sysres/ classic-check-btn.c classic-radio-btn.c
				fashion-check-btn.c fashion-radio-btn.c
				flat-check-btn.c flat-radio-btn.c
				tiny-pic-custom.c

01/14. BUGFIXING #2455: Cleanup configuration file.(xwyan)
	* etc/MiniGUI.cfg mvfb.cfg

01/14. BUGFIXING #2467: Cleanup dist file.(xwyan)
	* src/font/Makefile.am

01/11. BUGFIXING #2468: Fix cfg file error of pc_xvfb.(wangjian)
	* etc/MiniGUI.cfg

01/11. BUGFIXING #2460: Core dump on bitmapfont.(liupeng)
	* src/font/bitmapfont.c

01/10. BUGFIXING #2461: Fix return error of strcasecmp and strncasecmp.(xwyan)
	* src/misc/nposix.c

01/09. BUGFIXING #2482: Fix return error of SetDefaultWindowElementRenderer.
(wangxuguang)
	* src/gui/lf_manager.c

01/09. BUGFIXING #2454: Fix compiling error of auto ial.(xwyan)
	* src/ial/auto.c

What's new in this version (2.2.0, 2007/09/01 ~ 2007/12/31):
01/09. Create the branch for MiniGUI Version 2.2.1: dev-2-2-1.(xwyan)


12/29. Merge dev-2-2 to trunk. (xwyan)

12/26. Cleanup all source codes. (xwyan)

12/10. Implement hilite and disable status of control button. (wangxuguang)
	* Modify src/control/button.c
	* Modify include/ctrl/button.h

11/27. ENHANCEMENT #7: Direct return in function 
wndTrackMenuBarOnMouseMove which has been replaced by renderer. (zhounuohua)
	* return in function wndTrackMenuBarOnMouseMove
			* src/gui/window.c

11/26. ENHANCEMENT #7: Initialize renderer in CreateMainWindowEx,
CreateWindowEx2, CreateMainWindowIndirectParamEx, 
DialogBoxIndirectParamEx. (zhounuohua)
	* Modify CreateMainWindowEx, CreateWindowEx2, DestroyWindow
	* Add set_window_renderer, set_control_renderer
			* src/gui/window.c
	* Modify CreateMainWindowIndirectParamEx, DialogBoxIndirectParamEx.
			* src/gui/dialog.c
	* Modify HiliteMenuBarItem parameter flag meaning.
	* Add LFRDR_MENUITEMOFFY_MIN 
			* include/window.h
	* Delete redundant hiliteFlag in struct MENUBAR
			* src/include/menu.h

11/22. BUGFIXING: Fix a bug: When LineTo vertical line, the bottommost point
can not be setted. (wangxuguang)
	* src/newgdi/pixel_ops.c

10/29. ENHANCEMENT #6: Add PCXVFB NEWGAL engine. (xgwang, wangjian)
	* Add Qt_xVFB engine & Mg_xVFB engine
			* Add src/newgal/pcxvfb/pcxvfb.h
			* Add src/newgal/pcxvfb/pcxvfb.c
			* Add src/newgal/pcxvfb/Makefile.am
			* Modify src/newgal/Makefile.am
			* Add src/ial/pcxvfb.h
			* Add src/ial/pcxvfbial.c
			* Modify src/ial/Makefile.am
	* Add Win_xVFB engine
			* Add src/newgal/pcxvfb/pcxvfb-winfb.h
			* Add src/newgal/pcxvfb/pcxvfb-winfb.c
			* Modify src/newgal/pcxvfb/pcxvfb.h
			* Modify src/newgal/pcxvfb/pcxvfb.c
			* Modify src/ial/pcxvfb.h
			* Modify src/ial/pcxvfbial.c
			* Modify build/config-win32.h
			* Modify build/minigui-win32.dsp
			* Modify src/sysres/mgetc.c
			* Modify src/sysres/mgetc-win32.c

10/23. ENHANCEMENT #5: Add MLSHADOW engine support in procs version
	* Modify include/minigui.h
	* Modify src/include/client.h
	* Modify src/server/request.c
	* Modify src/newgal/mlshadow/mlshadow.c
	* Modify src/newgal/mlshadow/mlshadow.h

10/19. ENHANCEMENT #4: Add RTOS XVFB NEWGAL engine and RTOS XVFB IAL 
egine. (liupeng, wangxuguang)
	    * Add RTOS XVFB gal engine.
	        * src/newgal/rtos_xvfb/rtos_xvfb.c
	        * src/newgal/rtos_xvfb/rtos_xvfb.h
	        * src/newgal/rtos_xvfb/Makefile.am
	        * src/newgal/Makefile.am
	    * Add RTOS XVFB ial engine.
	        * src/ial/rtos_xvfb.c
	        * src/ial/rtos_xvfb.h
	        * src/ial/Makefile.am
	    * Add --enable-rtos_xvfb in configure
	        * configure.in

10/08. ENHANCEMENT #3: Add support process mode for Shadow engine. (alexwang, lfzhang) 
	* Add src/newgal/shadow_refresh.c
	* Modify src/newgal/shadow.c
	* Modify src/newgal/shadow.h
	* Modify src/newgal/qvfb/qvfb.c
	* Modify src/ial/ial.c
	* Modify src/include/ial.h

09/25. ENHANCEMENT #2: Add support for bitmap font. (liupeng)
	* Add src/font/bitmapfont.h
	* Add src/font/bitmapfont.c
	* Modify src/font/Makefile.am
	* Modify devfont.c and add DelSBDevFont, DelMBDevFont
	* Modify include/gdi.h and add CreateBMPDevFont, AddGlyphsToBMPFont,
	  DestroyBMPFont.
	* Modify src/font/freetyp2.c FONTOPS
	* Modify src/font/freetype.c FONTOPS
	* Modify src/font/qpf.c FONTOPS
	* Modify src/font/rawbitmap.c FONTOPS
	* Modify src/font/ty1.c FONTOPS
	* Modify src/font/varbitmap.c FONTOPS	

09/25. ENHANCEMENT #1: delete an API function & change the ops.(xgwang, wangjian)
	* Delete the API function GetDesktopPopupMenu.
	* Change the structure DESKTOPOPS and the default ops.
		* include/minigui.h 
		* src/kernel/desktop-comm.c
		* src/kernel/desktop-procs.c

09/20. ENHANCEMENT #1: delete some API functions .(xgwang, wangjian)
	* Delete CustomizeDesktopMenuFunc, CustomDesktopCommandFunc function 
	  pointer type.
	* Delete CustomDesktopCommand, CustomizeDesktopMenu global variables.
		* include/minigui.h									   
	* Delete CustomizeDesktopMenuDefault, CustomDesktopCommandDefault
	  functions.
	  	* src/kernel/desktop-comm.c   
	  	* src/kernel/desktop-procs.c   

09/20. ENHANCEMENT #1: enhancement desktop window external api.(xgwang,
wangjian)
	* Add SetCustomDesktopOperationSet, GetDesktopPopupMenu and
	DesktopUpdateAllWindow functions.
	* Add desktop operation set structure DESKTOPOPS.
	* Add desktop mouse and keyboad message. 
		* include/minigui.h 
		* include/window.h
		* src/kernel/desktop-comm.c
		* src/kernel/desktop-procs.c

*******************************************************************************
What's new in this version (2.0.4/1.6.10, 2006/07/01 ~ 2007/11/30):
09/11. Create the branch for MiniGUI Version 2.2: dev-2-2.

11/27. ENHANCEMENT #24: Add GetSubDC function.
	* include/gdi.h
	* src/newgdi/gdi.c.

11/27. ENHANCEMENT #23: Add GetWindowIcon/SetWindowIcon functions.
	* include/window.h
	* src/gui/window.c.

11/27. BUGFIXING #2424: When drawing focus rect of the pushbutton in fashion
window style, the content is drawn twice.
	* src/control/button.c.

11/27. BUGFIXING #2423: Calling LineTo to draw vertical line, but the end-point
is not drawn.
	* src/newgdi/pixel_ops.c.

11/20. CLEANUP
	* src/kernel/init.c (Error step++ before calling InitFixStr.)
	* src/libc/malloc.c (Delete not used code.)

11/16. TUNNING/ENHANCEMENT #16: Support for loading font dynamically in MiniGUI 
incore mode and tune the DestroyDynamicDevFont function prototype.(xwyan)
	* include/gdi.h
	* src/font/devfont.[ch]
	* src/font/qpf.[ch]
	* src/font/freetype.[ch]
	* src/font/freetype2.[ch]

11/16. TUNNING: Add SCANCODE_KEYPADENTER to dialog and controls.
	* src/control/simedit.c
	* src/control/combobox.c
	* src/control/button.c
	* src/control/ctrlmisc.c
	* src/control/listbox.c
	* src/control/edit.c
	* src/gui/dialog.c
	* ext/control/treeview.c

11/16. BUGFIXING/BUG #2421: Optimize drag message process of Skin UI. (xwyan)
	* ext/skin/cmdbutton.c
	* ext/skin/chkbutton.c
	* ext/skin/slider.c

11/16. BUGFIXING/BUG #2418/2419: Fix some bugs of disable and reset cursor 
clipping in ClipCursor. (xwyan)
	* src/kernel/cursor-procs.c
	* src/kernel/cursor-sa.c
	* src/kernel/cursor.c

11/16. BUGFIXING/BUG #2417: Fix a bug of no initializing variable:cliprc in
GetClipCursor. (xwyan)
	* src/kernel/cursor-procs.c
	* src/kernel/cursor-sa.c
	* src/kernel/cursor.c

11/16. BUGFIXING/BUG #2420: Fix a return value error when process keyboard 
operation in modal dialog. (xwyan)
	* src/gui/dialog.c

11/14. TUNNING: When use SetPenType for no PT_SOLID, add default dash if no
calling SetPenDashes. (xwyan)
	* src/newgdi/attr.c

11/13. TUNNING: Do not use time function and <time.h> for uC/OS-II.
	* include/common.h
	* src/misc/nposix.c

11/07. ENHANCEMENT #22: Suport Hisi3510 IAL and NEWGAL. (Libo Jiao)
	* src/ial/ial.c
	* src/newgal/hisi/hi3510_fbvideo.c
	* src/newgal/hisi/hi3510_fbvideo.h

11/06. OPTIMIZATION: change supporting to freetype2 subpixel
	* src/newgdi/drawtext.c

11/02. TUNNING: Replace IDI_APPLICATION with IDI_INFORMATION. (xwyan)
	* ext/mywin/mywindow.c

11/02. BUGFIXING/BUG #: A bug in MoveWindow and IsWindowVisible: error in
checking control's visibility.
	* src/gui/window.c

11/01. BUGFIXING/BUG #2355/ENHANCEMENT #20: Fix a bug of FillBox using not
BT_SOLID brush.(xwyan)
	* src/newgdi/bitmap.c

10/30. BUGFIXING/BUG #2332/ENHANCEMENT #16: Fix a bug when it uses error 
filename or device font name to load device font dynamically. (xwyan)
	* src/font/freetype.c
	* src/font/freetype2.c

10/30. BUGFIXING/BUG #2348: Add SetCursor to reset default desktop cursor when
it happens MSG_MOUSEMOVE.(xwyan)
	* src/kernel/desktop-comm.c

10/27. BUGFIXING/BUG #: Fix a bug of CreateCompatibleDCEx: bad assignments of
DC attributes.
	* src/newgdi/gdi.c

10/27. ENHANCEMENT #21: New API: CreateSubMemDC function.
	* src/newgdi/gdi.c
	* include/gdi.h

10/26. BUGFIXING/BUG #2340/ENHANCEMENT #8: Not return conved_wcs_len when
error of WCS2MBSEx. (xwyan)
	* src/font/textops.c

10/26. BUGFIXING/BUG #2339: Fix a bug of RestoreDC. (xwyan)
	* src/newgdi/gdi.c

10/25. BUGFIXING/BUG #2333: Fix a bug of edit when setting text using vector 
font. (xwyan)
	* src/control/edit.c
	* src/font/freetype.c

10/25. BUGFIXING/BUG #2334: bad implementation of FS_WEIGHT_BOOK log font style.
	* src/newgdi/attr.c

10/25. BUGFIXING/BUG #: bad implementation of FS_WEIGHT_BOOK log font style.
	* src/newgdi/attr.c

10/25. OPTIMIZATION/ENHANCEMENT #19: (xwyan)
	* src/include/control/listbox_impl.h
	* src/control/listbox.c

10/25. CLEANUP: cleanup error messages in InitGUI and remove errorlog.c file.
	* src/kernel/init-lite.c
	* src/kernel/init.c
	* src/include/ourhdr.h
	* src/misc/errorlog.c (deleted)
	* src/client/client.c
	* src/server/client.c, server.c

10/25. BUGFIXING/BUG 2331: bad error handling when creating system log fonts.
	* src/font/sysfont.c

10/24. ENHANCEMENT #20: Enhance FillBox to support no-solid brush.
	* src/include/bitmap.h
	* src/newgdi/bitmap.c
	* src/newgdi/pixel_ops.c
	* src/newgdi/pixel_ops.h

10/24. TUNNING: Update the in-core cursor resource. (xwyan) 
	* src/sysres/cursors.c

10/24. BUGFIXING/BUG #2329: mginit can not handle client request when calling
HavePendingMessage.
	* Tunning the response of client request to the front of the message 
	queue process.
		* src/server/server.c

10/24. BUGFIXING/BUG #2330: Tunning the implementation of EM_GETPARAGRAPHTEXT.
(xwyan)
	* include/ctrl/edit.h
	* src/control/textedit.c

10/24. ENHANCEMENT #16: (xwyan)
	* Add DestroyDynamicDevFont to destroy device font loaded dynamically 
	from file.
		* include/gdi.h
		* src/font/devfont.c
		* src/font/freetype.[ch]
		* src/font/freetype2.[ch]
		* src/font/qpf.[ch]

10/23. TUNNING: Tune timeout value for MiniGUI-Processes client.
	* src/client/client.c

10/23. BUGFIXING/BUG #2324/CLEANUP: Update the in-core qpf fonts.
	* src/font/qpf.c
	* src/font/qpf-*-*.c

10/22. BUGFIXING/BUG #2323: (xwyan)
	* Tunning the implementation of CreateLogFontIndirect.
		* src/font/logfont.c

10/22. BUGFIXING/BUG #2322: Change the default control background color
in fashion style. (xwyan)
	* etc/MiniGUI-fashion.cfg
	* src/sysres/syscfg.c

10/22. BUGFIXING: Fix memory leak of TermFreeTypeFonts, TermIncoreQPFonts 
and TermQPFonts.(xwyan)
	* Add relationship member to DEVFONT structure. 
	* Add DelRelatedDevFont to delete related device fonts when delete a
	device font.
		* src/font/devfont.c
		* src/font/freetype.[ch]
		* src/font/qpf.c
		* src/include/devfont.h
		* include/gdi.h

10/19. BUGFIXING/BUG #2321: Fix a null pointer bug of LoadDevFontFromFile.(xwyan)
	* src/font/devfont.c

10/18. BUGFIXING: Fix memory leak of new_instance and delete_instance 
in freetype2 engine.(xwyan)
	* src/font/freetype2.c

10/17. BUGFIXING: Fix memory leak of TerminateDesktop.(xwyan)
	* Free desktop message queue: __mg_dsk_msg_queue.
		* src/kernel/desktop-comm.c

10/17. BUGFIXING: Fix memory leak of TerminateScreenDC.(xwyan)
	* Free allocated alpha_pixel_format.
		* src/newgdi/gdi.c

10/17. BUGFIXING: Fix memory leak using GetStockBitmap.(xwyan)
	* Add TerminateStockBitmap to free available StockBitmaps memory in 
	  TerminateSystemRes or TerminateDesktop.
		* src/sysres/resource.c
		* src/kernel/desktop-procs.c

10/16. BUGFIXING/BUG #2317/ENHANCEMENT #19: Add LBS_MOUSEFOLLOW flag to limit
the function of changing selected item when move mouse. (xwyan) 
	* src/control/listbox.c
	* src/control/combobox.c
	* include/ctrl/listbox.h

10/15. BUGFIXING/BUG #2259: Post MSG_SETCURSOR message when message is 
MSG_DT_MOUSEMOVE in DefaultDTMouseMsgHandler.(xwyan)
	* src/gui/window.c

10/11. TUNNING: Add ShowOpenDialog support for win32.(xwyan)
	* src/ext/mywins/newfiledlg.c
	* ext/include/newfiledlg.h
	* include/common.h minigui.h
	* src/misc/systext.c
	* build/config-win32.h minigui-win32.dsp

10/11. TUNNING: Tune monthcalendar support for win32.(xwyan)
	* src/ext/control/monthcalendar.c

10/11. BUGFIXING/BUG #2275/ENHANCEMENT #7:
	* Use round-robin MSGQUEUE.FirstTimerSlot instead of calling
	__mg_move_timer_last:
		* src/include/internals.h
		* src/kernel/message.c
	* Remove __mg_get_timer_slot and __mg_move_timer_last functions:
		* src/include/timer.h
		* src/kernel/timer.c

10/11. BUGFIXING/BUG #2293: enhance code to check the validation of the video 
mode string.
	* Add GAL_ParseVideoMode function:
		* src/include/newgal.h
		* src/newgal.c
	* Use GAL_ParseVideoMode function to parse the video mode string:
		* src/newgal.c
		* src/newgal/mlshadow/mlshadow.c

10/11. BUGFIXING/ENHANCEMENT #9: Modify mlsEnableSlaveScreen's set flag bug. 
Fix MLSHADOW_DeleteDevice's NULL pointer exceptional bug.(houhh)
	* src/newgal/mlshadow/mlshadow.c
	* src/newgal/mlshadow/mlsahdow.h

10/11. OPTIMIZATION/ENHANCEMENT #9: Change UpdateSurfaceRects() and 
refresh_surface() method, save the surface's update rect to mlshadow_node
struct (add one struct member updaterect).(houhh)
	* src/newgal/mlshadow/mlshadow.c
	* src/newgal/mlshadow/mlsahdow.h

09/28. BUGFIXING/BUG #2270: Fix bug of RotateScaledBitmap. (xwyan)
	* Tune the method to check valid DC region.
		* src/newgdi/rotatebmp.c

09/28. CLEANUP/ENHANCEMENT #8: Add check for UTF-16 charset for TabbedTextOut,
TabbedTextOutEx, GetTabbedTextExtent, and DrawTextEx2 funcionts.
	* src/newgdi/text.c

09/28. BUGFIXING/BUG #2222/ENHANCEMENT #8: Fix bug of __mg_substrlen and
__mg_strnchr.
	* src/font/textops.c

09/28. BUGFIXING/BUG #2245/ENHANCEMENT #7: Fix a bug of KillTimer.
	* src/kernel/timer.c

09/28. BUGFIXING/BUG #2245/ENHANCEMENT #7: Fix a bug of KillTimer.
	* src/kernel/timer.c

09/27. TUNNING: Tune hh2440 ial engine. (dengdongdong)
	* Save max_x and min_x when mouse_getxy is called.
		* src/ial/hh2440.c

09/27. BUGFIXING/BUG #2244: A foolish bug of ScrollWindow:
	* Duplicated assignment: rcInvalid = rcMove;
		* src/kernel/desktop-comm.c
		* src/kernel/desktop-procs.c

09/27. BUGFIXING/BUG #2243/OPTIMIZATION #6: Fix race-condition for assignment of __mg_desktop.
	* Only for MiniGUI-Threads:
		* src/kernel/desktop-ths.c
		* src/kernel/desktop-comm.c

09/28. BUGFIXING/BUG #2242: Fix bug of CheckCapturedMouseMessage, and make it
as an inline function.
		* src/kernel/message.c

09/27. BUGFIXING: Fix lost mouse messages after captured.
	* Add CheckCapturedMouseMessage function to check the mouse messsage.
		* src/kernel/message.c

09/26. TUNNING: Add UTF-16 support for qpt incore font. (lbjiao)
	* src/font/incore/qpfqpf-helvetica-10.c
	* qpf-micro-4.c
	* qpf-song-16.c

09/20. BUGFIXING: Fix some bugs for __TARGET_MDGESKTOP__.(lbjiao)
	* src/gui/window.c
	* src/font/qpf.c

09/18. TUNNING: tune cursors with in-core mode using macro
__TARGET_MGDESKTOP__. (lbjiao)
	* src/sysres/cursors.c

09/18. TUNNING: Tune CreateMainWindow using macro __TARGET_MGDESKTOP__.(lbjiao)
	* src/gui/window.c

09/17. EXCHANGEMENT #9: Add UpdateSurfaceRect member to GAL_VideoDevice struct.
	* src/newgal/mlshadow/mlshadow.c
	* src/newgal/video.c
	* src/newgal/systemvideo.h

09/17. CLEANUP: Cleanup sysres using macro __TARGET_MGDESKTOP__ in in-core mode.
(xwyan)
	* src/sysres/mgetc-pc.c
	* src/sysres/mgetc.c

09/17. BUGFIXING: Fix a bug of InitListView.(xwyan)
	* ext/mywins/newfiledlg.c

09/12. TUNNING: Tune HH2440 IAL engine.
	* src/ial/hh2440.c

09/12. MODIFICATION: change GAL_CalculateBlit() if src surface and dst surface
is same, do not surppot alpha and color_key blit.
	* src/newgal/blit.c

09/12. CLEANUP: Cleanup MLShadow engine; still have problems.
	* src/newgal/mlshadow/mlshadow.c
	* src/newgal/mlshadow/mlshadow.h

09/12. BUGFIXING: Fix a bug of scrollbar when setting width.(jpzhang)
	* src/gui/window.c

09/12. CLEANUP: Cleanup the tarball files: (xwyan)
	* make_tarball
	* configs/config.h
	* configs/defconfig
	* configs/feature.in
	* configs/Configure.help

09/10. ENHANCEMENT #9: MLShadow NEWGAL engine.
	* src/newgal/mlshadow/*
	* src/newgal/sysvideo.h
	* src/newgal/video.c
	* src/newgal/surface.c
	* src/newgdi/gdi.c
	* configure.in

09/07. BUGFIXING: Fix a display bug of skin slider with SI_NRMSLIDER_VERT style.
(xwyan)
	* ext/skin/slider.c

09/06. BUGFIXING: Fix a display bug of skin slider with SI_NRMSLIDER_VERT and
SI_NRMSLIDER_STATIC style.(xwyan)
	* ext/skin/slider.c

08/31. BUGFIXING: Fix a bug of refreshing caret position when MoveWindow 
happens on textedit control.(xwyan)
	* src/control/textedit.c

08/31. CLEANUP: Cleanup the tarball files: (xwyan)
	* include/ctrl/edit.h
	* mark_tarball
	* Doxyfile

08/29. CLEANUP: Cleanup the tarball files: (xwyan)
	* rtos/nucleus_startup.c 
	* rtos/threadx_startup.c 
	* rtos/ucos2_startup.c
	* rtos/vxworks_startup.c 
	* rtos/psos_startup.c
	* src/control/textedit.c
	* build/config-ose-mx21.h 
		* config-ucosii-s3c44b0x.h
		* example_ads_prj_ucos2.tar.gz
		* minigui_ads_prj_nucleus.tar.gz
		* minigui_ads_prj_threadx.tar.gz
		* minigui_ads_prj_ucos2.tar.gz
	* src/misc/misc.c 
		* nposix.c
	* src/libc/nucleus_pprivate.h 
		* nucleus_pthread.c
		* ucos2_pthread.c 
		* threadx_pthread.c
		* vxworks_pthread.c
	* include/common.h
	* src/sysres/mgetc.c
	* src/newgal/commlcd/ose_mx21.c

08/29. TUNNING: Use #define instead of typedef for uchar, ushort, ulong,
u_char, u_short, u_int, u_long.
	* src/gui/linux_types.h

08/24. ENHANCEMENT #8: Add support for eCos Linux synthetic target.
		* modify QVFB GAL engine and IAL engine to support eCos Linux target.
			* src/include/ial.h
			* src/newgal/qvfb/qvfb.c
			* src/ial/qvfb.c
		* Add #include <stdio.h> in the following files to avoid compiler
		happy:
			* src/gui/caret.c
			* src/gui/window.c
			* src/gui/element.c
			* src/gui/linux_types.h

08/24. MODIFICATION: Redefine the return value type of GetMessage to be BOOL.
		* include/window.h

08/24. MODIFICATION: Define GetMessage and PeekMessage as inline functions.
		* src/kernel/message.c
		* include/window.h

08/24. TUNNING/ENHANCEMENT #7: Support for timer callback procedure.
	* Make the timer proc re-enterable:
		* src/kernel/message.c
		* src/kernel/timer.c

08/24. OPTIMIZATION #6: Use thread specific data to save message queue for GUI
thread instead of hash table (MiniGUI-Threads).
		* src/inclue/internals.h
		* src/kernel/init.c
		* src/kernel/message.c
		* src/kernel/desktop-ths.c
		* src/kernel/desktop-comm.c
		* src/kernel/timer.c
		* src/gui/window.c
		* Delete file src/kernel/hash.c
		* Delete file src/include/hash.h

08/24. OPTIMIZATION #5: Add a semaphore object for sync_message in message queue
in order to avoid creating a new semaphore object when calling SendSyncMessage
if the calling thread is a GUI thread (MiniGUI-Threads).
		* src/inclue/internals.h
		* src/kernel/message.c
		* src/kernel/desktop-ths.c

08/24. CLEANUP: Move some initialization code from DesktopMain to InitGUI
(MiniGUI-Threads).
	* src/kernel/init.c

08/23. CLEANUP: Add const to string arguments for MyWins API.
	* ext/include/mywindows.h
	* ext/mywins/mywindows.c

08/23. TUNNING: Add strncasecmp implementation when not defined
HAVE_STRNCASECMP.
	* configure.in
	* include/common.h
	* src/misc/nposix.c

08/23. MODIFICATION/ENHANCEMENT #20: Tune the implementation of GetSysText.
	* Add GetSysTextInUTF8 function to ruturn the localized system text array
	in UTF-8 encode.
		* include/minigui.h
		* src/misc/systext.c

08/23. MODIFICATION: Change the return value type of KillTimer.
	* The return value type of KillTimer changed from BOOL to int, the number
	of actually killed timers. However, this modification would not break the 
	backforward compatibility.
		* include/window.h
		* src/kernel/timer.c

08/23. MODIFICATION/ENHANCEMENT #7: Change the prototype of TIMERPROC.
	* The return value type of a TIMERPROC changed from void to BOOL. If a 
	TIMERPROC returns FALSE, MiniGUI will kill the timer automatically.
		* include/window.h
		* src/kernel/message.c
		* src/kernel/timer.c

08/23. MODIFICATION/ENHANCEMENT #20: Tune the implementation of GetSysText.
(xwyan)
	* Add UTF8 encodeing of the GB2312, GBK, GB18030 and BIG5 system text.
		* include/minigui.h
		* src/misc/systext.c

08/21. ENHANCEMENT #28: Add GetOriginalMousePosition function to get the 
original mouse position for _MISC_MOUSECALIBRATE.
	* include/minigui.h
	* src/include/ial.h
	* src/ial/ial.c

08/21. MODIFICATION: Add subdriver of Shadow engine for eCos.
	* src/shadow/ecos_generic.c

08/21. MODIFICATION: Change internal structure definition of CommLCD and 
Shadow engines.
	* lcd_info -> commlcd_info
		* src/commlcd/*.[ch]
	* lcd_info -> shadowlcd_info
		* src/shadow/*.[ch]

08/20. MODIFICATION: Cleanup the COMMLCD GAL engine and COMM IAL engine.
	* Rename external COMMLCD driver operations:
		* drv_lcd_int -> __commlcd_drv_init
		* drv_lcd_getinfo -> __commlcd_drv_getinfo
		* drv_lcd_release -> __commlcd_drv_release
		* drv_lcd_setclut ->  __commlcd_drv_setclut
	* Add two COMM IAL engine operations:
		* new operation int __comminput_init (void)
		* new operation void __comminput_deinit (void);
	* Renamve the following COMM IAL engine operations:
		* comm_ts_getdata -> __comminput_ts_getdata
		* comm_kb_getdata -> __comminput_kb_getdata
		* comm_wait_for_input -> __comminput_wait_for_input
	* Move code for VxWorks and ThreadX to <os>_startup.c:
		* src/ial/comminput.c
		* src/ial/Makefile.am
		* Rename src/newgal/commlcd/unknown.c to extern.c

08/20. CLEANUP: Cleanup the release files:
	* configure.in
	* GNUmakefile
	* build/*.h
	* make_tarball
	* Version
	* README

08/20. Merge rel-2-0-3-psos.

08/20. CLEANUP: Redefine errnos for MiniGUI's own POSIX Threads.
	* include/common.h

08/20. ENHANCEMENT #27: Universal startup API for all RTOSes.
	* Cleanup the startup code for RTOSes.
		* Delete include/mgdrv-ucosii.c
		* Delete include/nucleus_kbdrv.c
		* Delete include/threadx_kbdrv.c
		* Add rtos/Makefile.am
		* Add rtos/nucleus_startup.c
		* Add rtos/psos_startup.c
		* Add rtos/threadx_startup.c
		* Add rtos/ucos2_startup.c
		* Add rtos/vxworks_startup.c
		* Modify include/Makefile.am
		* Modify configure.in

08/19. ENHANCEMENT #27: Universal startup API for all RTOSes.
	* Define init_minigui_malloc for MiniGUI's own malloc system.
	* Define init_minigui_printf for MiniGUI's own stdio system.
	* Define start_minigui_pthread for MiniGUI's own POSIX Threads system.
		* include/common.h
		* src/libc/malloc.c
		* src/libc/defdev.c
		* include/psos_pthread.h
		* src/libc/psos_pthread.c
		* include/ucos2_pthread.h
		* src/libc/ucos2_pthread.c
		* include/threadx_pthread.h
		* src/libc/threadx_pthread.c
		* include/vxworks_pthread.h
		* src/libc/vxworks_pthread.c
		* include/nucleus_pthread.h
		* src/libc/nucleus_pthread.c

08/18. ENHANCEMENT #26: POSIX Threads for pSOS.
	* Initial version of psos_pthread.c
		* include/psos.h
		* include/psos_pthread.h
		* src/libc/psos_pprivate.h
		* src/libc/psos_pprivate.c
		* src/libc/psos_pthread.c

05/31. ENHANCEMENT #26: POSIX Threads for pSOS.
	* Initial version of psos_sem.c and psos_mutex.c
		* src/libc/psos_pprivate.h
		* src/libc/psos_sem.c
		* src/libc/psos_mutex.c

05/31. MODIFICATION: Cleanup the PThreads implementation for all OSes.
	* Use pthread_mutexattr_setprotocol/getprotocol functions instead 
	of pthread_mutexattr_setpriorityinherit/getpriorityinherit functions.
		* include/*_pthread.h
		* include/*_semphore.h
		* src/libc/*.[ch]

05/28. ENHANCEMENT #26: POSIX Threads for pSOS.
	* Add initial version of psos.h.
		* include/psos.h (This file will not release for MiniGUI-VAR)

05/16. ENHANCEMENT #25: Support for running MiniGUI-Standalone on RTOSes:
		* src/kernel/timer.c
		* src/standalone/standalone.c

08/14. BUGFIXING: Fix a bug of OpenFileDialog.(xwyan)
	* ext/mywin/filedlg.c

08/14. ENHANCEMENT #20: Tune the implementation of GetSysText.(xwyan)
	* include/minigui.h
	* src/gui/dialog.c
	* src/gui/menu.c
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c
	* src/misc/systext.c
	* ext/mywins/mywindows.c
	* ext/mywins/newfiledlg.c
	* ext/mywins/colordlg.c
	* ext/mywins/filedlg.c
	* ext/mywins/helpwin.c

08/10. BUGFIXING: Fix bug of cursor creation (only affect 32-bpp with alpha).
	* src/kernel/cursor.c
	* src/kernel/cursor-sa.c
	* src/kernel/cursor-procs.c

08/09. ENHANCEMENT #24: MBSTOWCSEx and WCSTOMBSEx
	* Enhance MBCSTOWCSEx and WCSTOMBSEx to return the length of converted 
	character.
		* include/gdi.h
		* src/font/textops.c

07/31. BUGFIXING/ENHANCEMENT #19: Fix bugs of listbox. (xwyan) 
	* src/control/listbox.c

07/27. ENHANCEMENT #11: Support for FreeType2.
	* Add cache manager support for FreeType2. (xwyan) 
		* src/font/freetype2.c freetype2.h

07/26. BUGFIXING: Fix a bug of control with WS_TABSTOP style. (xwyan) 
	* src/gui/dialog.c

07/25. BUGFIXING: Fix portential memory leak of InitSysFont. (xwyan) 
	* src/font/sysfont.c

07/20. ENHANCEMENT #23: Add the implementation of gbk_conv_from_uc32 
and big5_conv_from_uc32 to support converting unicode to big5 and gbk.
	* src/font/big5unimap.c
	* src/font/mapunitobig5.c
	* src/font/gbkunimap.c
	* src/font/mapunitogbk.c 
	* src/font/Makefile.am
	* src/font/charset.c

07/20. BUGFIXING: Optimize dskScrollMainWindow. (xwyan)
	* src/kernel/desktop-comm.c

07/20. ENHANCEMENT #22: Add OffsetRegionEx to offset invalid region in 
specified client area. (xwyan)
	* src/newgdi/region.c
	* include/gdi.h
CLEANUP: Add const to string arguments for MyWins API.
	* ext/include/mywindows.h

07/19. OPTIMIZATION #4: Optimize DrawTextEx2. (xwyan)
	* src/newgdi/text.c

07/18. ENHANCEMENT #21: Support for zero window size. (xgwang)
	* Modify the display of window, when the size of window is zero.
	* src/font/window.c

07/17. ENHANCEMENT #16: Loading font dynamically. (xgwang)
	* Add the function to load freetype1 and qpf library dynamically.
		* src/font/freetype.h
		* src/font/freetype.c
		* src/font/qpf.h
		* src/font/qpf.c

07/17. OPTIMIZATION #4: Tune the implementation of DrawTextEx2 and 
txtGetOneLine. (xwyan) 
	* src/newgdi/text.c

07/17. ENHANCEMENT #20: Modify the definition of GetSysText and implementation 
of newfiledlg, filedlg and mywindows control.(xwyan) 
	* ext/mywin/newfiledlg.c filedlg.c mywindows.c
	* src/misc/systext.c
	* include/minigui.h

07/10. ENHANCEMENT #19: Add the function of changing selected item when 
move mouse, no implementation for LBS_MULTIPLESEL style.(xwyan)
	* src/control/listbox.c

07/05. TUNNING: Tune the implementation of TerminateScreenDC.(xwyan)
	* Limit the calling of FillBox only for the server.
		* src/newgdi/gdi.c: 

07/05. ENHANCEMENT #18: Add floating point support for win32.(xwyan)
	* include/common.h

07/05. BUGFIXING: Fix a bug of __mg_reset_desktop_capture_info.(xwyan)
	* src/kernel/desktop-comm.c

07/04. BUGFIXING: Fix a bug of set_cell_value and 
GridCellTypeNumber_draw_content.(xwyan)
	* ext/control/gridview.c
	* ext/control/gridviewcelltype.c

07/03. ENHANCEMENT #17: Add hi3510 IAL engine, hi3510 and hi3560 NEWGAL
engines.(xwyan)
	* configure.in
	* make_tarball
	* build/ buildlib-linux-hi3510
	* include/ minigui.h
	* configs/ config.in, defconfig, Configure.help, feature.in
	* src/ial/ Makefile.am, hi3510.c, hi3510.h
	* src/newgal/ Makefile.am, video.c, sysvideo.h
	* src/newgal/hisi Makefile.am, hi3510_fbvideo.c, hi3560_fbvideo.c, 
		  pix_array.c, tde.c, hi3510_fb.h, hi3510_fbvideo.h, hi3560_fb.h, 
		  hi3560_fbvideo.h, hi_tde.h, tde_reg.h

07/03. TUNNING: Add VxWork IAL option in make_tarball.(lbjiao)
	* configs/defconfig
	* configs/config.in
	* make_tarball

06/28. BUGFIXING: Fix an endless loop bug of utf8_pos_first_char, when charset 
encoding mismatch.(xwyan)
	* src/font/charset.c

06/28. BUGFIXING: Fix a bug of utf8_len_first_char.(xwyan)
	* Add the support for ascii character processing.
		* src/font/charset.c 

06/27. MODIFICATION: Update the logical font setting way of listbox control.
(xwyan)
	* src/control/listbox.c
	* src/include/control/listbox_impl.h

06/19. ENHANCEMENT #16: Loading font dynamically.
	* Add functions to load freetype2 library dynamically. (xgwang)
		* src/font/freetype2.c
		* include/gdi.h

06/19. BUGFIXING: Fix a bug of put_one_char. (xwyan)
	* src/newgdi/drawtext.c
	* src/font/qpf.c

06/18. BUGFIXING: Fix a deadlock bug of read/write client socket. (xwyan)
	* include/minigui.h
	* src/client/client.c

06/07. TUNNING: Use getpagesize instead of PAGE_SIZE.
	* src/newgal/fbcon/fbvideo.c

06/07. TUNNING: Tune the implementation of __mg_os_time_delay on eCos. (xwyan)
	* src/misc/nposix.c

06/06. TUNNING: Add __attribute__((packed)) to all structures used by PinYin 
IME module.
	* src/ime/pinyin.h

06/06. TUNNING: Make ime_gb2312_pinyin option to be disabled defaultly.
	* configure.in

06/06. CLEANUP: Cleanup the mgetc.c and mgetc-*.c file to ignore the duplicated
includes.
	* src/sysres/mgetc.c
	* src/sysres/mgetc-*.c

06/06. ENHANCEMENT #16: Add custom IAL engine for customer's board in order to 
avoid modification an existing IAL engine.
	* configure.in
	* src/ial/ial.c
	* src/ial/custom.[ch]

05/31. BUGFIXING: Fix a bug of put_one_char advances is ignored when bits is 
NULL.
	* src/newgdi/drawtext.c

05/31. ENHANCEMENT #15: Enhance ListBox to support disabled item and bold item.
	* include/ctrl/listbox.h
	* src/control/listbox.c
	* src/include/ctrl/listbox_impl.h

05/28. ENHANCEMENT #11: Support for FreeType2.
	* Add the support for FONT_OTHER_LCDPORTRAITKERN and FONT_OTHER_LCDPORTRAIT.
	(xwyan)
		* include/gdi.h
		* src/font/fontname.c

05/28. TUNNING: Rename src/kernel/cursor-lite.c to src/kernel/cursor-procs.c
	* modify make_tarball to reserve *-lite.c files in src/kernel/.

05/28. ENHANCEMENT #14: Merge the support for vxworks (PowerPC) with WinML2.0 
from patch-1-6.(xwyan)
	* src/gui/linux_types.h
	* src/sysres/mgetc-ppc.c
	* src/sysres/mgetc.c
	* src/sysres/mgetc-wifi.c
	* build/config-vxworks-ppc.h
	* build/rules-ppc.vxworks
	* src/newgal/commlcd/vxworks-ppc.c
	* src/newgal/commlcd/Makefile.am
	* src/ial/vxppc_input.c
	* src/ial/Makefile.am

05/24. BUGFIXING: Fix bug in __mg_init_jpg in order to call InitMyBitmapSL and 
CleanupMyBitmapSL functions without calling LoadMyBitmapSL when loading JPEG 
file.
	* src/mybmp/jpeg.c 

05/24. BUGFIXING/ENHANCEMENT #11: Fix bug to handle memdc for subpixel.
	* src/newgdi/drawtext.c 

05/23. BUGFIXING: Fix memory leak bug of PaintImageEx and StretchPaintImageEx.
	* src/newgdi/readbmp.c 

05/21. ENHANCEMENT #11: Support for FreeType2.
	* Tune text smoothing interface implementation and data struct definition.
		* Add ft2SetLcdFilter function to set the filter of FT2.
			* include/gdi.h
		* Remove the mg_smooth_flag, mg_smooth_mode variables.
			* src/newgdi/drawtext.c
		* Add ft_lcd_filter member in FTINSTANCEINFO.
			* src/font/freetype2.[ch]

05/18. MODIFICATION: Modify the API description of create_skin_main_window and
create_skin_main_window_ex:
	* ext/include/skin.h
	* ext/skin/skin.c

05/16. ENHANCEMENT #8: Support for UTF-16LE and UTF-16BE charsets/encodings.
	* Change the definition of Uchar32 to 'int'.
		* include/gdi.h

05/16. ENHANCEMENT #11: Support for FreeType2.
	* Add conditional compilation for _FT2_SUPPORT:
		* src/newgdi/drawtext.c

05/16. MODIFICATION: Change the type of __mg_csrimgsize and __mg_csrimgpitch 
to be "unsigned int".
	* src/include/internals.h
	* src/kernel/cursor-lite.c

05/16. CLEANUP: Remove the type for GetDCAttr and SetDCAttr:
	* include/gdi.h

05/17. MODIFICATION: Change local variable index to _index.
	* src/font/fontname.c
	* ext/mywins/newfiledlg.c

05/17. MODIFICATION: MGETC global variable to __mg_get_mgetc
	* src/misc/misc.c

05/17. ENHANCEMENT #13: Support for Blackfin537.
	* Merging the support of Blackfin537 from rel-2-0-3-c33l05 branch.
		* N build/buildlib-uclinux-bf537
		* N src/sysres/mgetc-bfin.c
		* configure.in
		* src/ial/ial.c
		* src/sysres/mgetc.c
	* handle mmap args for __TARGET_BLACKFIN__
		* src/newgal/fbcon/fbvideo.c: 

05/16. ENHANCEMENT #12: Support for C33
	* Added files:
		* build/buildlib-uclinux-c33l05
		* src/ial/c33l05.[ch]
		* src/newgal/commlcd/axlinux_c33l05.[ch]
		* src/sysres/mgetc-axlinux.c
	* Add snprintf and __modsi3 for __TARGET_C33L05__
		* src/misc/nposix.c

05/12. ENHANCEMENT #11: Support for FreeType2.
	* Add the whole support for freetype2 and subpixel smoothing.(xwyan)
		* configure.in
		* src/newgdi/gdi.c
		* src/newgdi/text.c
		* src/newgdi/drawtext.c
		* src/newgdi/drawtext.h
		* src/include/devfont.h
		* src/font/devfont.c
		* src/font/freetype.c
		* src/font/freetype2.c
		* src/font/freetype2.h
		* src/sysres/mgetc.c

05/10. BUGFIXING/ENHANCEMENT #9: Fix a bug of RestoreDC to release memdc's ecrgn first.
	* src/newgdi/gdi.c

04/05. MODIFICATION: Enhance scancode_table to add the space support.(xwyan)
	* src/ial/vxi386_input.c

03/15. ENHANCEMENT #11: Support for FreeType2.
	* Add macro _FT2_SUPPORT for the support of FreeType2.(xwyan)
		* configure.in
		* src/sysres/mgetc.c
		* src/newgdi/gdi.c
		* src/include/devfont.h
		* src/font/devfont.c freetype.c freetype2.c

03/06. BUGFIXING: Change the implementation of SARG in own_vfnprintf.(xwyan)
	* libc/vfnprintf.c

03/05. ENHANCEMENT #10: Add "figueroa" IAL engine for D2 FiguerOA. (lbjiao)
	*  Added files:
		* src/ial/figueroa.c
		* src/ial/figueroa.h
		* build/buildlib-linux-figueroa
	*  Modified files:
		* configure.in
		* make_tarball
		* configs/config.in
		* configs/Configure.help
		* configs/defconfig,
		* configs/feature.in
		* build/Makefile.am
		* src/ial/Makefile.am
		* src/ial/ial.c

03/05. BUGFIXING: Fix a bug of teNodeDel.(xwyan)
	* src/control/textedit.c

03/02. BUGFIXING: Fix a bug of treat_longpress.(xwyan)
	* src/kernel/event.c

01/29. ENHANCEMENT #9: Add SaveDC and RestoreDC functions.
	* include/gdi.h
	* src/newgdi/gdi.c

01/29. ENHANCEMENT #8: Support for UTF-16LE and UTF-16BE charsets/encodings.
	* Add __mg_strlen, __mg_strnchr, and __mg_substrlen to handle UTF-16 text.
		* src/font/textops.c
		* src/newgdi/text.c

01/29. ENHANCEMENT #8: Support for UTF-16LE and UTF-16BE charsets/encodings.
	* Tune the implementation of the following functions to support UTF-16:
		* GetTabbedTextExtent, TabbedTextOut, GetTabbedTextExtentPoint
			* src/newgdi/drawtext.c
			* src/newgdi/text.c

01/28. ENHANCEMENT #8: Support for UTF-16LE and UTF-16BE charsets/encodings.
	* Add char_type method for CHARSETOPS.
		* include/gdi.h
		* src/font/charset.c

01/27. MODIFICATION: Clean the full screen when terminating MiniGUI.
	* src/kernel/init.c
	* src/newgdi/gdi.c

01/27. BUGFIXING: Bugs in implementation of UTF-8.
	* Fix bugs in pos_first_char and len_first_substr methods for UTF-8.
	* Fix bugs in the get_next_word method of UTF-8.
		* src/font/charset.c

01/27. ENHANCEMENT #8: Support for UTF-16LE and UTF-16BE charsets/encodings.
	* Change the conv_to_uc16 and conv_from_uc16 of CHARSETOPS to conv_to_uc32
	and conv_from_uc32 respectively.
	* Implementes pos_first_char and len_first_substr methods for UTF-8 and
	UTF-16.
	* Cleanup the get_next_word method of UTF-8, UTF-16 charset.
	* Remove the bytes_per_char property of CHARSETOPS.
		* include/gdi.h
		* src/font/charset.c
		* src/font/testops.c

01/12. BUGFIXING: Fix a bug of GetGlyphBitmap function.
	* Reset advance_x and advance_y to zero.
		* src/font/logfont.c

01/12. ENHANCEMENT #7: Support for timer callback procedure.
	* Tune implementation of timer.
		* Move the latest expired timer to be the last one in the queue in order
		that another timer can be treated.
		* Change the size of TimerMask in the message queue to 32-bit.
			* src/include/internals.h
			* src/include/timer.h
			* src/kernel/timer.c
			* src/kernel/message.c

01/11. ENHANCEMENT #8: Enhance the interface of the following functions to 
handle the different size of wide char:
	* MB2WC -> MB2WCEx, WC2MB -> WC2MBEx, MBS2WCS -> MBS2WCSEx, and WCS2MBS ->
	WCS2MBSEx.
		* include/gdi.h
		* src/font/textops.c

01/11. ENHANCEMENT #7: Support for timer callback procedure.
	* SetTimer -> SetTimerEx, ResetTimer -> ResetTimerEx.
	* Use GetThreadInfo to get the message queue intead of window handl.
	* Check timer messages before invalidate region of windows.
		* include/window.h
		* src/include/timer.h
		* src/kernel/timer.c
		* src/kernel/message.c

01/09. OPTIMIZATION #3: Optimize _dc_draw_hline_clip and _dc_fill_hline_clip:
	* src/newgdi/pixel_ops.c

01/09. BUGFIXING: Fix a bug of PolygonGenerator when the polygon is very large.
	* You should make sure the vertices of the polygon to be closed so that
	  PolygonIsMonotoneVertical can work correctly. However, the no-closed
	  polygon can be treated as a general polygon.
		* src/newgdi/polygon.h
		* src/newgdi/polygon.c

01/09. OPTIMIZATION #2: Optimize txtGetOneLine to decrease the calculation.
	* src/newgdi/text.c

01/09. BUGFIXING: Fix the bug when display combobox control in a main window 
with WS_EX_TOPMOST style (only in MiniGUI-Threads and MiniGUI-Standalone).
	* src/kernel/desktop-comm.c

01/08. ENHANCEMENT #6: Operating Z-node from the server of MiniGUI-Processes.
	* Implementation of the following functions for MiniGUI-Processes:
		* ServerGetNextZNode, ServerGetZNodeInfo, and ServerDoZNodeOperation.
			* src/server/layer.c
		* ON_ZNODE_OPERATION, OnZNodeOperation
			* src/kernel/desktop-procs.c
			* include/minigui.h

12/26. ENHANCEMENT #6: Operating Z-node from the server of MiniGUI-Processes.
	* Add the prototypes of the following functions for MiniGUI-Processes:
		* ServerGetNextZNode, ServerGetZNodeInfo, and ServerDoZNodeOperation.
			* include/minigui.h

12/26. ENHANCEMENT #6: Operating Z-node from the server of MiniGUI-Processes.
	* Add the prototypes of the following functions for MiniGUI-Processes:
		* ServerGetNextZNode, ServerGetZNodeInfo, and ServerDoZNodeOperation.
		* ON_ZNODE_OPERATION, OnZNodeOperation
			* include/minigui.h

12/18. BUGFIXING: Use setjmp to handle the errors from the libjpg and libpng.
	* src/mybmp/jpeg.c
	* src/mybmp/png.c

12/12. OPTIMIZATION #1: Optimize GAL_BlitCopy by using the x86 ASM when 
BitBlt called.(xwyan)
	* src/newgal/blit.c

12/05. BUGFIXING: Fix a bug about colordlg, when change color.(xgwang)
	* ext/mywins/colordlg.c

11/22. BUGFIXING: Fix a bug of ShowOpenDialog. When save a file, it doesn't 
provide the function whether the file exist or not.(xwyan)
	* Add internal function implementation FileExistDlg.
	* ext/mywins/newfiledlg.c 

11/20. MODIFICATION: Add getpt function check.(xwyan)
	* configure.in

11/20. BUGFIXING: Fix a bug of layer_op.(xwyan)
	* src/server/request.c

10/24. MODIFICATION: Use 1980/01/01 00:00:00 to return the default local time 
for __mg_os_localtime.
	* src/misc/nposix.c

10/24. MODIFICATION: Use HAVE_TIME, HAVE_MKTIME, and HAVE_LOCALTIME to define 
__mg_os_time, __mg_os_mktime, and __mg_os_localtime functions.
	* configure.in
	* src/misc/nposix.c

10/24. MODIFICATION: Add internal function __mg_os_get_random_seed () to return 
a seed for srand.
	* src/include/misc.h
	* src/misc/nposix.c
	* src/newgdi/readbmp.c
	* src/ial/random.c

10/08. Fix a bug of checking window style for WS_HSCROLL and WS_VSCROLL:
	* src/gui/window.c

09/30. BUGFIXING: Fix a bug of KeyMessageHandler. Add the support for 
MSG_DT_KEYLONGPRESS and MSG_DT_KEYALWAYSPRESS. (xwyan)
	* include/window.h
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

09/29. ENHANCEMENT #5: Merge EM8620 IAL engine from patch-1-6 branch.

09/29. ENHANCEMENT #4: Merge EM86GFX NEWGAL engine from patch-1-6 branch. 

09/29. CLEANUP: Tune the debug messages of NEWGAL engines.
	* src/newgal/dummy/nullvideo.c
	* src/newgal/shadow/shadowvideo.c
	* src/newgal/qvfb/qvfb.c
	* src/newgal/wvfb/wvfb.c
	* src/newgal/fbcon/fbvideo.c
	* src/newgal/dfb/dfbvideo.c
	* src/newgal/commlcd/commlcd.c
	* src/newgal/em85xxosd/em85xxosd.c
	* src/newgal/em85xxyuv/em85xxyuv.c

09/28. BUGFIXING: Fix a bug of MSG_MOUSEACTIVE in DefaultPostMsgHandler.(xwyan)
	* src/gui/window.c

09/26. ENHANCEMENT #3: Add the support for WS_EX_DLGHIDE style of dialog. 
The style can be used to not show dialog immediately after dialog 
is created.(xwyan)
	* src/gui/dialog.c

09/20. CLEANUP: Add debug messages for InitSlaveScreen.
	* src/newgal/video.c

09/17. CLEANUP: Update EM85xx OSD engine.
	* src/newgal/em85xxosd/em85xxosd.c

09/17. ENHANCEMENT #2: Add NEWGAL engine for em85xx YUV.

08/21. TUNNING: Tune the interface specification of IsWindowVisible. (xwyan)
	* include/window.h

08/21. BUGFIXING: Fix a bug of MSG_GETNEXTMAINWIN. (xwyan)
	* src/kernel/desktop-comm.c

08/21. TUNNING: Tune the declaration and implementation of GetMenuItemInfo,
SetMenuItemInfo, InsertMenuItem. (xwyan)
	* include/window.h
	* src/gui/menu.c

08/18. TUNNING: Tune the "dwStyle" parameter declaration of MessageBox. (xwyan)
	* include/window.h

08/17. BUGFIXING: Fix a bug about newtoolbar. (xwyan)
	* src/control/newtoolbar.c

08/17. BUGFIXING: Reset the clip region of the private client DC when calling 
EndPaint.
	* src/gui/window.c

08/17. TUNNING: Tune edit control to send notification code of EN_UPDATE 
(instead of EN_CHANGE) when the content of the control changed by sending 
MSG_SETTEXT to it.
	* include/ctrl/edit.h
	* src/control/simedit.c
	* src/control/edit.c
	* src/control/textedit.c

08/17. BUGFIXING: Fix a bug of GetLayerInfo (MiniGUI-Processes).
	* src/client/client.c

08/17. TUNNING: Tune JoinLayer to disable the duplicated calls to this function.
	* src/client/client.c

08/14. BUGFIXING: Fix a bug of losing MSG_KILLFOCUS when hide a main window.
(xwyan)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

08/14. TUNNING: Tune implementation of dskUpdateGCRInfoOnHideMainWin and
srvHideWindow. (xwyan)
	* src/kernel/desktop-comm.c
	* src/kernel/desktop-procs.c

08/14. TUNNING: Tune implementation of EM_LIMITTEXT about sledit control.(xwyan)
	* src/control/edit.c

08/03. BUGFIXING: Fix a bug of dc_GenerateECRgn to recalc DevRC of DC before 
generating the effective clipping region.
	* src/newgdi/gdi.c

08/03. ENHANCEMENT #1: Add WindowFromDC function
	* include/gdi.h
	* src/newgdi/gdi.c

07/14. BUGFIXING: Fix a bug about TrackBar when use EnableWindow(hwnd, FALSE).
(xgwang)
	* src/control/tracbar.c

*******************************************************************************
What's new in this version (2.0.3/1.6.9, 2005/11/01 ~ 2006/06/30):

06/24. Redefine the set_width and spacing type of logical font to flip and
other. (ymwei)
	* Add FONT_FLIP_HORZ, FONT_FLIP_VERT, FONT_FLIP_HORZVERT styles for flip type.
	* Add FONT_OTHER_AUTOSCALE and FONT_OTHER_TTFNOCACHE styles for other type.
	* Add FONT_OTHER_TTFKERN and FONT_OTHER_TTFNOCACHEKERN styles for other type.
	* Treat all old set_width types and spacing types to null type.
	* Autoscale will work only when FONT_OTHER_AUTOSCALE specified.
	* include/gdi.h
	* src/font/fontname.c logfont.c, freetype.c, qpf.c, varbitmap.c, rawbitmap.c

06/24. Delete codes related with pushbutton and pushedbutton in fashion 
style and incore mode.(xwyan)
	* etc/*.cfg
	* include/window.h
	* src/sysres/resource.c
	* src/control/button.c
	* src/sysres/pushbutton-phone-bmp.c (delete)

06/22. Fix memory leak of init_bitmap_from_mybmp.(xwyan)
	* src/newgdi/readbmp.c

06/22. Add pthread, dirent library and header files for win32.(xwyan)
	* include/win32_pthread.h
	* include/win32_semaphore.h
	* include/win32_sched.h
	* include/win32_dirent.h
	* build/pthreadVC1.dll pthreadVC1.lib
	* build/dirent.dll dirent.lib

06/22. Add new project package and delete old package for ucos-ii.(xwyan)
	* make_tarball
	* minigui_ads_prj_ucos2.tar.gz
	* example_ads_prj_ucos2.tar.gz
	* minigui_ads_prj_ucos2.rar
	* example_ads_prj_ucos2.rar

06/21. Rename the global variable __mg_dsk_msgs to __mg_dsk_msg_queue. (ymwei)
	* src/include/internals.h
	* src/kernel/desktop-*.c
	* src/kernel/message.c
	* src/gui/window.c
	* src/standalone/standalone.c

06/21. Rename the global variable sg_FreeClipRectList in src/newgdi/gdi.c to
__mg_FreeClipRectList. (ymwei)
	* src/newgdi/gdi.c
	* src/newgdi/region.c

06/13. Fix a bug of menu when use MFT_SEPARATOR type menu bar, the submenu of
MENUITEMINFO is not NULL.(xgwang)
	* src/gui/menu.c

06/12. Fix a bug of menu when draw MFT_SEPARATOR type menu bar.(xgwang) 
	* src/gui/menu.c

06/12. Use alpha to handle the transparence of PNG image. (ymwei)
	* src/mybmp/png.c.

06/12. Tune PostQuitMessage to work when the window has been destroyed.
(ymwei)
	* src/kernel/message.c.

06/11. Cleanup the script make_tarball to make sure to empty the files 
related to MiniGUI-Processes for non-Linux OSes. (ymwei)
	* make_tarball.

06/11. Move calling of init_string_res function in ext/mywins/newfiledlg.c to 
InitNewOpenFileBox function. (ymwei)
	* ext/mywins/newfiledlg.c.

06/11. Cleanup the header files. (ymwei)
	* Remove version number from the header files:
	* include/*.[ch].
	* include/ctrl/*.h.
	* ext/include/*.h.
	* ext/include/ext/*.h.

06/09. Fix a bug of ListView for header refresh when drag last column.(lbjiao)
	* src/ext/listview.c

06/09. Fix a bug of TreeView for scrollbar when unfold node.(lbjiao)
	* src/ext/treeview.c

06/06. Fix bugs of IAL engine for DirectFB. (qzlong)
	* src/ial/dfb.c.

06/06. Reset children's private CDCs after moving a window. (ymwei)
	* src/gui/window.c (MoveWindow, BeginPaint, EndPaint).

06/05. Fix the value of sb_height when use incoreres style.(cuiwei)
	* src/sysres/syscfg.c

06/05. Move the position of text in a button.(xgwang) 	
	* src/control/button.c

06/05. Fix a bug of te_unselect_all.(xwyan)
	* src/control/textedit.c

06/05. Fix a bug of update global control when move the main window. (ymwei)
	* We should invalidate the main window's region which is covered by the
	global control. (src/kernel/desktop-procs.c).

06/05. Fix a bug of maitaining of age of zorder node. (ymwei)
	* Do not reset the age to zero when hide a window
	(src/kernel/desktop-procs.c).

06/05. Fix a bug of the calculation of the rect of global control. (ymwei) 
	* Use dskClientToScreen instead of dskWindowToScreen 
	(src/kernel/desktop-procs.c, src/kernel/desktop-comm.c).

05/31. Tune the cursor shape of TextEdit control.(xwyan)
	* src/control/textedit.c

05/29. Fix a bug about drag thumb of TreeView control.(lbjiao)
	* ext/control/treeview.c

05/29. Fix a bug about scroll window of GridView control.(lbjiao)
	* ext/control/gridview.c
	* ext/control/gridviewcelltype.c

05/29. Tune the implementation of myWinHelpMessage.(xwyan)
	* mywins/helpwin.c

05/29. Fix two bugs about slider of skin(SI_TYPE_NRMSLIDER).(xwyan)
	* ext/skin/slider.c

05/26. Add support of EN_SELCHANGED and EN_CONTCHANGED about 
TextEdit control.(xwyan)
	* src/control/textedit.c
	* src/include/control/textedit_impl.h
	* include/ctrl/edit.h

05/25. Add support of EN_SELCHANGED and EN_CONTCHANGED about 
sledit control.(xgwang)
	* include/ctrl/edit.h
	* src/include/control/edit_impl.h
	* src/control/edit.c

05/25. Add support of CBN_CLICKED.(lbjiao)
	* include/ctrl/combobox.h
	* src/control/combobox.c

05/24. Add support of EN_GETLIMITTEXT.(xwyan)
	* include/ctrl/edit.h
	* src/control/textedit.c

05/24. Add the support of OSE.(xwyan)
	* build/rules-mx21.ose
	* build/config-ose-mx21.h
	* src/newgal/commlcd/  ose-mx21.c makefile.ng
	* src/misc/nposix.c
	* include/ial.h include/ose_semaphore.h
	* src/libc/ose_sem.c
	* src/sysres/ mgetc-ose-mx21.c mgetc.c Makefile.am

05/22. Fix a bug about Combobox control.(lbjiao)
	* src/control/combobox.c (MSG_CREATE)

05/22. Fix a bug  about GridView control.(lbjiao)
	* ext/control/gridview.c (update_row_col_end_xy())

05/22. Fix some bugs about GridView control.(lbjiao)
	* ext/control/gridview.c
	* ext/control/gridviewcelltype.c

05/18. Fix some bugs about GridView control.(lbjiao)
	* ext/control/gridview.c
	* ext/control/gridviewcelltype.c

05/15 Fix a bug about refresh of window when not use WS_BORDER or use
WS_THINFRAME.(xgwang) 
	* src/gui/window.c

05/15. Fix some bugs about GridView control.(lbjiao)
	* ext/control/gridview.c (GRIDM_SETCOLWIDTH, GRIDM_SETROWHEIGHT,
	GRIDM_GETCOLWIDTH, GRIDM_GETROWHEIGHT)

05/12. Fix a bug about Animation Control.(cuiwei)
	* ext/control/animation.c (ANM_STOPPLAY)

05/12. Modify LoadSystemCursor function.(xgwang)
	* src/sysres/resource.c

05/12. Add some incore ressources of MiniGUI.(xgwang)
	* src/sysres/fold-icon-flat.c
	* src/sysres/icons-flat.c
	* src/sysres/unfold-icon-flat.c

05/12. Update some incore resources of MiniGUI.(xgwang) 
	* src/sysres/bmp-3d.c
	* src/sysres/bmp-phone.c
	* src/sysres/button-3d.c
	* src/sysres/button-phone.c
	* src/sysres/cursor.c
	* src/sysres/downarrow-3d-bmp.c
	* src/sysres/downarrow-phone-bmp.c
	* src/sysres/icons-3d.c
	* src/sysres/leftrightarrow-3d-bmp.c
	* src/sysres/leftrightarrow-phone-bmp.c
	* src/sysres/pushbutton-phone-bmp.c
	* src/sysres/spinbox-3d.c
	* src/sysres/spinbox-phone.c
	* src/sysres/syscfg.c
	* src/sysres/trackbar-phone-bmp.c
	* src/sysres/updown-arrow-3d.c
	* src/sysres/updown-arrow-phone.c

05/12. Fix a bug about IconView Control.(lbjiao)
	* ext/control/iconview.c (case IVM_SETITEMSIZE)

05/11. Fix some bugs about TreeView Control.(lbjiao)
	* ext/control/treeview.c (TreeViewCtrlProc())

05/10. Fix some bugs about TreeView Control.(lbjiao)
	* ext/control/treeview.c (tvInitTVData())
	* ext/control/treeview.c (tvSetVScrollInfo())
	* ext/control/treeview.c (set_item_text())
	* ext/control/treeview.c (TreeViewCtrlProc())

05/09. Fix some bugs about Cool-Bar control.(cuiwei)
	* ext/control/coolbr.c         

05/09. Fix some bugs about MonthCalendar control.(cuiwei) 
	* ext/control/monthcalendar.c

05/09. Add global variable __mg_def_proc for user to change default window 
processes(DefaultMainWinProc, DefaultDialogProc, DefaultControlProc).(xwyan)
	* include/window.h
	* src/gui/dialog.c src/gui/window.c
	* src/kernel/init.c src/kernel/init-lite.c

05/08. Modify the position of control in the filedialog.(xgwang)
	* ext/myfiledlg.c

05/08. Fix a bug of listbox. (lbjiao)
	* include/ctrl/listbox.h

04/30. Modify the fashion style button.(xgwang)
	* src/control/button.c

04/30. Modify the color design of fashion window style of MiniGUI.(xgwang)
	* src/control/button.c
	* etc/MiniGUI-fashion.cfg

04/30.fix a bug of spinbox when spinbox will generate SPN_REACHMAX notification 
code.(xgwang)
	* ext/control/spinbox.c

04/29. Fix some bugs of scrollview. (lbjiao)
	* src/control/scrollview.c
	* src/control/listmodel.c

04/28. Fix a bug of scrollwnd. (lbjiao)
	* src/control/scrolled.c

04/28. Fix some bugs of combobox. (lbjiao)
	* src/control/combobox.c

04/21. Fix a bug of TrackBar when set the minimum and maximum positons.(xgwang)
	* src/control/trackbar.c

04/21. Fix a bug of TrackBar when used border style.(xgwang)
	* src/control/trackbar.c

04/21. Fix a bug of TrackBar when trackbar will generate TBN_CHANGE
notification codes(xgwang)
	* src/control/trackbar.c

04/20. Fix a bug of lstSelectItem. (xwyan) 
	* src/control/listbox.c

04/20. Tune the implementation of SetMenu. (xwyan)
	* src/gui/menu.c

04/20. Add the support of ES_NOHIDESEL when medit lost focus.(xwyan) 
	* src/control/textedit.c

04/20. Tune EN_CLICKED. When edit control receives MSG_LBUTTONUP, 
a EN_CLICKED notification code will be sent to parent window.(xwyan)
	* src/control/textedit.c
	* src/control/edit.c
	* src/control/simedit.c

04/20. Move ETCSECTION and ETC_S structure in misc.h to minigui.h.(xwyan)
	* include/minigui.h
	* src/include/misc.h

04/19. add a function of 256 color icon load from file and memory.(xgwang) 
	* include/gdi.h
	* src/newgdi/icon.c

04/19. Fix a bug of button when used fashion style.(xgwang)	
	* src/control/button.c

04/18. Tune the underline of struckoutline of text.
	* draw_text_lines (src/newgdi/drawtext.c)

04/18. Fix a bug of put_one_char (forgetting to add bold).
	* put_one_char (src/newgdi/drawtext.c)

04/18. Modify minimum configuration options and scripts.(xwyan)
	* etc/MiniGUI-min.cfg
	* build/buildlib-min

04/17. Fix some bugs of menu (xgwang)
	* src/gui/menu.c

04/17. Fix a bug of Listbox. (lbjiao)
	* src/control/listbox.c

04/14. Add new logical font styles: FS_FLIP_HORZ, FS_FLIP_VERT, and
FS_FLIP_HORZVERT to control the flipping of font.
	* include/gdi.c.
	* src/font/fontname.c.
	* src/newgdi/drawtext.c.

04/14. Tune the implementation of FS_WEIGHT_LIGHT.
	* src/newgdi/drawtext.c.

04/14. Merge MiniGUI V1.6.9 vxWorks5.4 POSIX implementation to current 
version.(xwyan)
	* src/libc/vxworks_mutex.c
	* src/libc/vxworks_pprivate.h
	* src/libc/vxworks_pthread.c
	* src/libc/vxworks_sem.c
	* src/libc/Makefile.am
	* include/vxworks_pthread.h
	* include/vxworks_semaphore.h  

04/14. Delete the method of DEVFONT get_str_width.
	* include/gdi.h
	* src/font/rawbitmap.c
	* src/font/varbitmap.c
	* src/font/qpf.c
	* src/font/freetype.c
	* src/font/type1.c

04/13. Enhance of the implementation of scancode_table.(xwyan)
	* src/ial/vxi386_input.c

04/13. Modify the color design of classic window style of MiniGUI.(xgwang)
	* ext/control/monthcalendar.c
	* ext/control/treeview.c
	* ext/control/listview.c
	* ext/control/icoview.c
	* ext/mywins/mywindows.c
	* src/control/ctrmisc.c
	* include/window.h 
	* etc/MiniGUI-classic.cfg

04/13. Fix a bug of ListBox. (lbjiao)
	* src/control/listbox.c

04/10. Fix a bug of SetValueToEtcFile.(xwyan)
	* src/misc/misc.c

04/10. Fix some bugs of button, edit, dialog and menu.(xgwang)
	* src/gui/dialog.c
	* src/control/button.c
	* src/control/edit.c
	* src/gui/menu.c

04/07. Fix a bug about MB_WHICH_BMP style of menubutton.(xwyan)
	* src/control/menubutton.c

04/03. Fix some bugs of textedit.(xwyan)
	* src/control/textedit.c

04/03. Fix a bug of scrolled_refresh_rect.(xwyan)
	* src/control/scrolled.c

03/31. Modify the color design of flat window style of MiniGUI.(xgwang)
	* src/gui/window.c
	* src/gui/menu.c
	* src/control/button.c
	* ext/mywins/mywindows.c
	* ext/control/monthcalendar.c 
	* etc/MiniGUI-flat.cfg

03/28. Change the definition of MENUITEMINFO struct and enhance the
implementation of menu item with type of MFT_BITMAP.
	* include/common.h (Add a new error code ERR_INVALID_ARGS).
	* include/window.h
	* src/include/menu.c
	* src/gui/menu.c
	* src/control/menubutton.c
	* Note that the MFT_BITMAP type's definition has been changed to include
	  the hilited BITMAP objects. Please use typedata to define the normal
	  bitmap object, use uncheckedbmp to define the hilited bitmap object,
	  and use checkedbmp to define the checked bitmap object.

03/28. Enhance the implementation of InitMainWinMetrics to support 
incore mode.(xwyan)
	* src/kernel/desktop.c
	* src/kernel/desktop-sa.c
	* src/kernel/desktop-procs.c
	* src/kernel/desktop-ths.c
	* src/sysres/sysres.c

03/28. Add menu scroll function while the height of menu is more than 
screen.(xgwang)
	* src/include/menu.h
	* src/gui/menu.c

03/25. Add truetype fonts definition for incore resource mode:
	* src/sysres/mgetc.c
	* src/newgdi/gdi.c

03/25. Fix a bug of DrawText when using TTF font. Do not use 
devfont->get_str_width anymore.
	* txtGetWidthOfNextWord (src/newgdi/text.c).

03/23. Add two new styles PSS_SCROLLABLE and PSS_BOTTOM for PropertySheet
control. (cuiwei)	
	* src/control/propsheet.c
	* src/include/control/propsheet_impl.h
	* include/ctrl/propsheet.h

03/22. Add WS_BORDER | CBS_EDITNOBORDER style to ComboBox in ShowOpenDialog. 
(lbjiao)
	* src/ext/mywins/newfiledlg.c

03/21. Fix a bug about refresh of GridView. (lbjiao)
	* src/ext/gridview.c

03/21. Use alpha pixel to render gray glyph bitmap when background mode is
BM_TRANSPARENT.
	* src/include/dc.c
	* src/newgdi/drawtext.c
	* src/newgdi/attr.c
	* src/newgdi/gdi.c

03/20. Move SelectFont and GetCurFont to attr.c.
	* src/font/logfont.c
	* src/newgdi/attr.c

03/20. Enhance font glyph rendering to use Alpha pixel for FS_WEIGHT_BOOK.
	* src/include/dc.h
	* src/newgdi/drawtext.c
	* src/newgdi/gdi.c

03/20. Fix a bug of QPF font rendering.
	* src/font/qpf.c

03/19. Add implementation for FS_WEIGHT_LIGHT to inflate the glyph one pixel 
with the background pixel.
	* src/newgdi/drawtext.c

03/19. Remove old GAL/GDI options and SVGA IAL engine option from configure.in.

03/19. Add SetNullFocus function to set the active child to be null.
	* include/window.h
	* src/gui/window.c

03/17. Enhance refresh function of Gridview control. (lbjiao)
	* src/ext/gridview_impl.h add member drag_x, drag_y, ContX, ContY and 
		commend member is_mouse_down, is_drag in struct tagGridViewData
	* src/ext/gridview.c (add update_viewport function and Tune 
		gridview_set_content, update_row_col_size, resize_row_mouse_down, 
		resize_row_mouse_up, resize_row_mouse_move, resize_col_mouse_down, 
		resize_col_mouse_up, resize_col_mouse_move, MSG_LBUTTONDBLCLK, 
		MSG_LBUTTONDOWN, MSG_KEYDOWN, GRIDM_ADDCOLUMN, GRIDM_DELCOLUMN,		
		GRIDM_ADDROW, GRIDM_DELROW, GRIDM_SETCOLWIDTH, GRIDM_SETROWHEIGHT)	

03/14. Change the incore Song GB2312 font with fmsong-12-gb2312.bin.
	* src/font/in-core/song-12-gb2312.c

03/13. Tune default text alignment style of button control.(xgwang)
	* src/control/button.c
	* default text alignment style is DT_LEFT | DT_VCENTER 

03/13. Enhance refresh function of sledit control.(xgwang)
	* src/control/edit.c (add internal functions del_refresh,input_char_refresh,
		calc_charpos_cx, get_caretpos_x, set_edit_caret_pos). 

03/13. Enhance TextEdit control to add support of EM_LIMITTEXT.(xwyan)
	* src/control/textedit.c (Tune txtAddNode, txtDelNode, teInitData,
		textedit_destroy, teOnChar, textdoc_insert_string_ex, 
		insert_string)
	* src/include/control/textedit_impl.h (add member hardLimit and curlen in 
		PTEDATA structure)

03/10. Enhance ListBox control to add support of horizontal scroll.(lbjiao)
	* Add itemLeft, itemWidth and itemMaxWidth in struct tagLISTBOXDATA
	* Add lstGetItemWidth,lstGetMaxWidth,lstSetHScrollInfo and lstSetScrollInfo
		function in src/control/listbox.c
	* Tune lstResetListBoxContent, lstOnDarwSListBoxItems, lstCalcParams,
		change_scrollbar, lstSetVScrollInfo, ListBoxCtrlProc.

03/09. Fix a bug of OpenFileDialogEx, about filename display position.(xwyan)
	* ext/mywins/filedlg.c

03/09. Enhance Button control (Radio Button) to optimize the redraw.(cuiwei)
	* src/control/button.c

03/08  Fix a bug about MSG_SIZECHANGING	message of Button control (cuiwei).
	* src/control/button.c

03/08  Enhance MenuButton control (cuiwei).  
	* src/control/menubutton.c

03/08  Fix a bug about the system button of the captionbar (cuiwei).
	* src/gui/window.c   

03/08. Enhance TextEdit control to optimize the redraw.
	* src/include/control/text.h
	* src/include/control/textedit_impl.h
	* src/include/control/listmodel.h
	* src/include/control/scrollview_impl.h
	* src/control/listmodel.c
	* src/control/textedit.c

03/08. Fix a bug of DrawText.
	* Check the line_width > maxwidth after a new char
	(txtGetOneLine function, src/newgdi/text.c).

03/05. Fix a bug about caret handling of TextEdit.
	* Always change the caret position before redraw the control
	(src/control/textedit.c).

03/05. Fix a bug of incore system bitmaps (src/sysres).
	* remove bmps-3d-ecos.c and bmps-flat-ecos.c files.
	* remove old background bmp data (bmps-3d.c, bmps-phone.c, and
	bmps-flat.c).
	* Define BITMAPINFO_VALUES to 6 (mgetc.c).

03/05. Add complete incore cursors data.
	* src/kernel/mgetc.c
	* src/sysres/cursors.c
	* src/sysres/resources.c

03/04. Fix a bug of mouse pointer refresh (MiniGUI-Processes) when no pointer
specified. 
	* src/kernel/cursor-lite.c

03/04. Fix a bug of EUC-KR support.
	* Use wrong data type for ucs_code (ksc5601_0_conv_to_uc16,
	src/font/charset.c).
	* Update euckr_to_ucs map table (src/font/euckrunimap.c).

03/03. Fix a bug of caret blink when the control has WS_EX_TRANSPARENT style.
	* Do not restore the caret in BeginPaint if the window has
	WS_EX_TRANSPARENT style (src/gui/window.c).
	* Force to call GetCaretBitmaps in EndPaint and force the caret show in
	EndPaint (src/gui/window.c).

03/03. Add caption setting support of phone style.(xwyan)
	* include/window.h (add macro STOCKBMP_CAPTION)
	* src/gui/window.c (setting bmp_caption)
	* src/sysres/resource.c (tune StockBitmaps[]) 
	* add files src/sysres/my_caption.c 

03/02.Add support of slave screen and merge slave-screen branch.(xwyan,cuiwei)
	* Related files:
		* include/gdi.h
		* src/kernel init.c init-lite.c cursor.c cursor-sa.c cursor-lite.c
		* src/newgal blit.c surface.c video.c
		* src/newgdi bitmap.c clip.c palette.c gdi.c
		* src/include internals.h cursor.h dc.h newgal.h

	* Tune ShowCursorForGDI, dc_InitScreenDC, GAL_Surface, InitScreenDC,
		   BitBlt.
	* src/newgdi/gdi.c (implementations of InitSlaveScreen and 
			TerminateSlaveScreen).
	* src/newgal/video.c (implementations of GAL_GetVideo, Slave_*)

02/28. Enhance JPEG file loading to support data from camera.
	* Check special signature before JFIF and Exif (src/mybmp/jpeg.c).

02/28. Fix a bug of GetGlyphBitmap.
	* Duplicated call of get_char_advance (src/font/logfong.c).

02/26. Fix a bug of SetActiveWindow.
	* Do not send messages to old active window, the server should do this
	work (src/gui/window.c).

02/26. Fix a bug of NC button release handling.
	* src/gui/window.c

02/26. New mouse handling routines for MiniGUI-Threads.
	* src/kernel/desktop-comm.c.
	* src/gui/window.c.

02/25. Only use SIGALARM for MiniGUI-Processes and MiniGUI-Standalone on
Linux and uClinux OSes:
	* Remove config option timer_unit_is_10ms (configure.in).
	* Rename get_timer_hwnd and get_timer_id to add __mg_ prefix
	(src/include/timer.h, src/kernel/message.c).
	* Cleanup src/kernel/timer.c.

02/24. Tune __mg_check_dirty_znode:
	* Add has_dirty flag in MGClient struct (include/minigui.h,
	src/server/client.c).
	* Only call __mg_check_dirty_znode when the client has dirty znodes
	(src/kernel/desktop-procs.c, src/server/request.c).
	* Decrease the timeout value of client to 20ms (src/client/client.c).

02/24. Merge some enhancements and bug fixs from patch-1-6:
	* TYPE_WINTODEL (src/include/internals.h).
	* DestroyMainWindow (src/gui/window.c).
	* EndDialog (src/gui/dialog.c).
	* ThrowAwayMessages (src/kernel/message.c).
	* PeekMessageEx (src/kernel/message.c, include/window.h).
	* Skin (ext/include/skin.h, ext/skin/skin.c).

02/22. Fix a bug of GetMatchedSBDevFont to prevent returning a NULL sbc_devfont object.
	* src/font/devfont.c

02/22. Tune desktop menu. (cuiwei)
	* Do not display the global control in the desktop menu (src/kernel/desktop-procs.c)
	* Use itemdata to store the pointer to the main window
	(src/kernel/desktop-comm.c)

02/22. Merge dev-2-0-3 branch.(xwyan)
	* ChangeLog
	* configure.in
	* src/gui/window.c 
	* src/ial/qvfb.c 
	* src/mybmp/gif.c 
	* include 		gdi.h window.h
	* src/include   internals.h server.h client.h
	* src/font  	Makefile.am fontcache.c fontname.c freetype.h freetype.c 
	* src/kernel 	desktop-comm.c desktop-procs.c systext.c
	* src/newgdi 	Makefile.am rotatebmp.c advapi.c midc.h readbmp.c text.c
	* src/server  	layer.c request.c

02/21. Tune window update of clients. (xgwang)
	* include/server.h (new internal function __mg_check_dirty_znode)
	* src/server/request.c (check the dirty znode of one client after handling
			"i am live" request.
	* src/kernel/desktop-procs.c (implementation of __mg_check_dirty_znode)

02/21. Enhance desktop menu to include the captions of main window. (cuiwei)
	* include/window.h (new desktop message MSG_CHANGECAPTION)
	* src/include/client.h (new ZORDERNODE operation
			ID_ZOOP_CHANGECAPTION)
	* src/kernel/desktop-procs.c
	* src/gui/window.c (message MSG_SETTEXT)

02/21. Add NEWGDI function TextOutOmitted. (cuiwei)
	* include/gdi.h
	* src/newgdi/text.c

02/16. Update MiniGUI for uCos-II building project and example's project 
and fix building errors. (xwyan)
	* build/minigui_ads_prj_ucos2.zip
	* build/example_ads_prj_ucos2.zip
	* src/kernel/desktop-comm.c

02/16. Tune SetServerTopmostLayer to not refresh the desktop when there is no
any client. (xwyan)
	* src/server/layer.c

02/14. Enhance TTF support to cache the rendering of TTF glyphs. (cuiwei)
	* configure.in (macros _TTF_CACHE_SUPPORT, _TTF_CACHE_SIZE, _MAX_TTF_CACHE)
	* src/font/freetype.c
	* new file src/font/fontcache.c

01/26. Add rotating, fliping, stretching or shrinking a bitmap object
functions. (xwyan)
	* src/newgdi/rotatebmp.c
	* include/gdi.h

01/25. Fix bug of GIF loading when GIF is interlaced. (xgwang)
	* src/mybmp/gif.c

01/24. Add RoundRect function. (yangyan)
	* include/gdi.h
	* src/newgdi/advapi.c

01/23. Add message MSG_CSIZECHANGED to notification the size change of client
area. (xgwang)
	* include/window.h
	* src/gui/window.c

01/23. Add StretchPaintImage, StretchPaintImageFromFile and
StretchPaintImageFromMem functions. (xgwang)
	* include/gdi.h
	* src/newgdi/readbmp.c

01/19. Fix a bug of _dc_fill_rect.
	* Using pencolor to fill the rect (src/newgdi/midc.h).

01/17. Remove check of FreeType 2 from configure.in.
	* configure.in

01/16. Send MSG_IME_SETTARGET to IME window while registering IME target
window in MiniGUI-StandAlone running-mode. 
	* src/kernel/desktop-comm.c

01/10. Delete the support of _MATH_3D in MiniGUI. 
	* include/fixedmath.h
	* src/newgdi/polygon.h
	* src/misc/Makefile.am
	* remove src/misc/math3d.c

01/10. Fix a bug of negative number handling in fixceil.
	* include/fixedmath.h

12/21. Fix a bug of memory leaks in InitMyBitmapSL.
	* src/mybmp/mybmp.c

12/19. Fix a bug of QVFB IAL engine (forget the release event of a key).
	* src/ial/qvfb.c

12/19. Fix a bug of error initialization of ListView control.
	* ext/control/listview.c

12/19. Fix a bug of invalid long key press message handling.
	* src/gui/window.c

12/19. Disable long key press handling at startup.
	* src/kernel/event.c

12/19. Tune QueueMessage to compact last two MSG_MOUSEMOVE message.
	* src/kernel/message.c

12/19. Add "dfb" IAL engine for DirectFB.
	* configure.in
	* src/ial/ial.c
	* src/ial/dfb.c
	* src/ial/dfb.h

12/19. Add "dfb" NEWGAL engine for DirectFB.
	* configure.in
	* src/newgal/video.c
	* src/newgal/sysvideo.h
	* src/newgal/dfb/*

12/19. Fix bug of get_char_pixmap for qpf font.
	* src/font/qpf.c.
	* src/newgdi/drawtext.c.
	* src/gdi/drawtext.c.

11/29. Add "fix" prefix for fixed math functions.
	* src/misc/math.c.
	* src/newgdi/line.c.
	* src/newgdi/polygon.c.
	* ext/skin/rotslider.c.
	* include/fixedmath.c.

11/29. Fix a bug when calculate the line width with QPF font (DrawText).
	* src/newgdi/text.c.
	* src/gdi/text.c.

11/29. Fix a bug of charset operations (get_next_word) for UTF-8.
	* src/font/charset.c.

11/22. Add a key in bgpicture section to define the file name of the
background picture, and delete the SYSBMP_BGPICTURE.
	* src/mgetc/mgetc.c
	* src/kernel/desktop-procs.c
	* src/kernel/desktop-comm.c
	* src/include/gdi.h
	* etc/*.cfg

11/19. Fix bug of QVFB IAL engine.
	* Correct handling of repeated key from QVFB.
	* src/ial/qvfb.c

11/19. Merg enhancements from patch-1-6.
	* Long Key Press messages.
	* src/kernel/event.c
	* src/gui/window.c
	* src/gui/keyboard.c
	* src/gui/transkey.c

	* ListView Control 
	* ext/include/ext/listview.h 
	* ext/control/listview.c 
	* ext/control/listview_impl.h

11/19. Tune text output to support scale of pixmap.
	* src/newgdi/drawtext.c.

11/18. Tune font module.
	* Remove get_bitmap_size and max_bitmap_size operations from FONTOPS.
	* Tune QPF module to return sbc_devfont information when the char can not
	be found in the font.
	*  Enhance QPF module to support auto-scale.
	* src/font/*.c

11/18. Tune FONTOPS to get scale when get_char_bitmap or get_char_pixmap
	* src/newgdi/drawtext.c.
	* src/gdi/drawtext.c.

11/18. Add WS_EX_MODALDISABLED style for main window to maintain the old
enable status of hosting of the modal dialog box.
	* src/gui/dialog.c.
	* ext/skin/skin.c.

11/18. Add a helper function: FixStrDup.
	* src/kernel/fixstr.c.

11/18. Enhance ETC operations.
	* Add SaveEtcToFile to save an etc object to a file.
	* Enhance SetValueInEtc to create new section.
	* Add FindSectionInEtc to get the section object or create a new section.
	* Add GetValueFromEtcSec and GetIntValueFromEtcSec to get value from
	section object.
	* Add SetValueInEtcSec to set value in section object.
	* Add RemoveSectionInEtcFile and RemoveSectionInEtc to remove a section 
	from etc object or etc file.
	* Use FixStrDup/FreeFixStr to allocate the memory for section names, 
	keys and values.
	* Because of changes of internal structures, the extern function set_mgetc 
	defined by some platform should be rewrite to meet the changes.
	* src/misc/misc.c.

11/17. Merge __mg_tmpfile family functions from patch-1-6.
	* src/misc/nposix.c.
	* src/misc/misc.c.

11/17. Merge definitions of _mg_time family functions from patch-1-6.
	* src/misc/nposix.c 
	* ext/control/monthcalendar.c, ext/control/monthcalendar_impl.h

11/17. Tune the sequence of termination (TerminateGUI) for MiniGUI-Threads.
	* Avoid lock of keyboard when using fbcon and console engines.
	* src/kernel/init.c 

11/16. Fix bug of Windows BMP file loading.
	* The flag of MYBITMAP object should be MYBMP_FLOW_DOWN,
	  becaus of the new code has been change the flow direction.

11/16. Fix bug of PrtScrn key handling of MiniGUI-Processes.
	* src/kernel/desktop-procs.c.

11/16. Add SaveScreenRectContent and rewrite SaveMainWindowContent.
	* src/gdi/screen.c, src/newgdi/screen.c.

11/09. Fix a bug of FillBoxWithBitmapPart.
	* Forget offset the pointer of the line (src/newgdi/bitmap.c).

11/04. Fix bug of ThrowAwayMessages on sync messages. (snig)

*******************************************************************************
What's new in this version (2.0.2, 2005/10/01 ~ 2005/10/31):

10/31. Do not use SA_RESTART when install system timer for MiniGUI-Processes.
	* InstallIntervalTimer (src/kernel/timer.c).

10/31. Handling duplicated JoinLayer calls in the server.
	* do_client_join_layer (src/server/layer.c).

10/31. Fix bug of StretchBlt.
	* set initial pddc->cur_ban to be NULL (src/newgdi/bitmap.c).

10/31. Return HWND_DESKTOP for GetHosting when reaching the hosting root in threaded mode.
	* src/gui/window.c.

10/31. Do not handle SOCKERR_CLOSED when sending message to a client.
	* __mg_send2client (src/server/client.c).

10/31. Tune ProgressBar to not repaint when the position not changed.
	* src/control/progressbar.c.

10/31. Tune ANIMATION control to optimize the painting.
	* ext/control/gif89a.c (set delaytime to 10 for less than 10).
	* ext/control/animation.c (remove scaled_mem_dc and color key handling of
	memory dc).

10/31.Tune caption drawing of groupbox to meet requirment of WS_EX_TRANSPARENT
(qzlong)
	* src/control/static.c

10/28. Tune init_bitmap_from_mybmp to use the RGBA masks when dest DC has Amask.
	* src/newgdi/readbmp.c

10/28. Fix bug of scrolled window refresh. (snig)
	* Refresh the whole window as long as the visible area is changed.

10/28. Tune EndDialog.
	* Only acitve the hosting when it is visible (src/gui/dialog.c).

10/28. Fix a bug of loading png image. (qzlong)
	* Update the assignment rountine of MYBITMAP structure. (src/mybmp/png.c)

10/28. Enable size change of radio button and checkbox when using phone style (qzlong)
	* src/control/button.c

10/28. Fix a bug of mouse capture in the GridView control.  (qzlong)
	* ext/control/gridview.c

10/27. Fix a bug of creating selection controls in the GridView control.  (qzlong)
	* Justify the size of the creating selection controls
	(ext/control/gridviewcelltype.c).

10/27. Call DestroyAllControls before destroying the hosted main windows.
	* DestroyMainWindow (src/gui/window.c).

10/26. Tune capture of mouse.

10/26. Fix bug of keyboard operations of the dialog which doesn't contain any controls. (qzlong)
	* GetNextDlgGroupItem (src/gui/dialog.c).

10/25. Call MainWindowCleanup for dialog after the message loop instead of in EndDialog.
	* (src/gui/dialog.c).

10/25. Tune the APIs of accelerator.
	* (src/gui/accelkey.c).

10/25. Fix bug of remove znode of a client (MiniGUI-Processes).
	* set zi->active_win to zero before calling SetActiveWindow.
	* (src/kernel/desktop-procs.c).

10/25. Fix bug of double-clicks the head in ListView control.
	* Do not send the notification message while double-clicks the head of
	ListView control.

10/24. Add DT_CHARBREAK for DrawText.
	* txtGetOneLine (src/newgdi/text.c, src/gdi/text.c)

10/24. Add HideCaret and ShowCaret when erasing the background of a window.
	* wndEraseBackground (src/gui/window.c)

10/24. Add judgement for whether the skin variable is NULL in SkinWinProc, which
avoiding segment fault when clicks the close box of skin window. (qzlong)
	* ext/skin/skin.c.

10/23. Add MSG_STARTDRAGWIN, MSG_CANCELDRAGWIN, and MSG_WINDOWDROPPED.
	* Drag and drop of main window handled by the server or the desktop.
	* Resolved the bug when dragging a main window.
	* Enhanced the handling of dragging and dropping a main window.

10/22. Tune the function of txtGetOneLine used by DrawTextEx2.
	* src/newgdi/text.c.

10/22. Change the third argument meaning of gdi_get_TabbedTextOut_extent to width of TAB.
	* src/newgdi/text.c, src/newgdi/drawtext.c.

10/19. Add function ServerCreateLayer for creating a layer by the server.
	* src/server/layer.c.

10/19. Fix bug of GetMessage when handling QS_PAINT.
	* Do not generate MSG_PAINT when get message for HWND_DESKTOP
	  but reserved this for MiniGUI-Threads.
	  (src/kernel/message.c).

10/19. Tune the End Session handling of MiniGUI-Processes and MiniGUI-Standalone.
	* src/kernel/desktop-procs.c, src/kernel/desktop-comm.c.

10/18. Fix bug of srvMoveWindow (MiniGUI-Processes).
	* Do not copy window content when the topmost layer switched.
	* src/kernel/desktop-procs.c

10/18. Fix bug of dskMoveMainWindow (MiniGUI-Threads and MiniGUI-Standalone).
	* Update region covered by all upper windows (src/kernel/desktop-comm.c).

10/18. Active the hosting main window when a dialog is down.
	* src/gui/dialog.c

10/18. Fix bug of refresh on hiding menu (MiniGUI-Threads and MiniGUI-Standalone).
	* Bad MSG_NCPAINT arguments (src/kernel/desktop-comm.c).

10/18. Fix bug of UNLOCK_GCRINFO (MiniGUI-Processes).
	* Add check for general DC (src/include/dc.h).

10/14. Fix bug of txtGetOneLine.
	* src/newgdi/text.c

10/14. Remove '#undef DT_WORDBREAK 0' in TextEdit control.
	* src/control/textedit.c

10/14. Remove the '\t' handling of GetTextExtentPoint.
	* src/newgdi/text.c.

10/14. Merge ext/control from the branch patch-1-6.
	* Remove printf from GridView control (ext/control/gridview.c).
	* Fix the bad fix of TreeView control (ext/control/treeview.c).

10/14. Merge src/control from the branch patch-1-6.
	* textedit.c scrolled.c listbox.c
	* Fix caret bug of Edit control with the style ES_PASSWOR (edit.c).

10/14. Remove configuration option for OLDMEDIT.
	* configure.in
	* src/control/Makefile.am

10/14. Add new implementation of BMP_TYPE_RLE for NEWGAL.
	* consider <skip> for transparent pixels.

10/14. Merge enhancement and bug fix of the branch patch-1-6.
	* SetPalette_physical (src/newgal/video.c).
	* Disable calling of dwMove2Topmost when moving a main window
	(src/kernel/desktop-comm.c).
	* Remove calling of pthread_kill_other_threads_np (src/kernel/init.c).
	* Tune the implementation of Expand256CBitmap (src/newgdi/bitmap.c).

10/14. Use IPC_KEY_BASE instead of calling ftok.
	* src/kernel/sharedres.c.
	* src/server/layer.c.

*******************************************************************************
What's new in this version (2.0.1, 2005/09/01 ~ 2005/09/25):

09/08. Fix race-condition bug of MoveWindow.
	* Merge srvMoveWindow1 and srvMoveWindow2 to be srvMoveWindow.
	* src/kernel/desktop-procs.c.

09/08. Adjust the position of MessageBox to not display out of the screen.
	* src/gui/dialog.c.

09/08. Shield the WS_EX_TRANSPARENT style for main window.

09/08. Fix bug of srvMoveWindow1
	* Forget to check the new window position (src/kernel/desktop-procs.c).

09/07. Tune DestroyMainWindow for dialogbox. (snig)
	* DestroyMainWindow will destroy all the hosted main windows, including 
	dialog boxes.
	* Revise EndDialog, Call DestroyMainWindow directly.

09/05. Fix bug of bitmap filling.
	* src/newgdi/bitmap.c

09/05. Fix bug of drawing hline and vline:
	* src/newgdi/pixel_ops.c
	_dc_cliphline, _dc_clipvline, _dc_draw_hline_clip, _dc_draw_vline_clip 

09/05. Add implementation of MSG_GETNEXTMAINWIN messge for desktop.

09/05. Optimize __mg_remove_all_znodes_of_client.
	* (src/kernel/desktop-procs.c).

*******************************************************************************
What's new in this version (2.0.0, 2005/08/01 ~ 2005/08/31):

08/31. Beta version of MiniGUI 2.0.0 released.

08/25. Alpha version of MiniGUI 2.0.0 released.

*******************************************************************************
What's new in this version (1.6.8, 2005/04/04 ~ 2005/09/05):

09/05. MiniGUI Version 1.6.8 released!

09/02. Clean up the API description.
	* include/common.h
	* include/window.h

09/02. Fix bug of draw horizontal line and vertical line.
	* src/newgdi/pixel_ops.c

09/02. Fix bug of combobox.
	* Wrongly use of int and unsigned int.

09/01. Fix bugs of FillBoxWithBitmap when scaling a transparent bitmap.
	* src/newgdi/bitmap.c
	* src/include/bitmap.h

09/01. Fix some cleanup bugs of MiniGUI-Threads.
	* No need remove the threadinfo of desktop, but remove it with
	destroyThreadHash.
	* Remove freeDesktopWindow and make initDesktopWindow static.

08/30. Fix the bug of gif loading.
	* src/newgui/readbmp.c
	* src/mybmp/gif.c

08/30. Fix the bug of winbmp loading when handling RLE8 and RLE4.
	* Lost last scanline (src/mybmp/winbmp.c).

08/30. Fix a little (potential fatal) bug of draw vline:
	* _dc_drawvline (src/newgdi/pixel_ops.c)

08/27. Fix the hosting handling bug.
	* Make the default hosting of MiniGUI-Lite and MiniGUI-Standalone main windows to be the desktop window.
	* The hosting of a root main window of MiniGUI-Threads is NULL.
	* src/gui/window.c.
	* src/kernel/message.c

08/12. Remove the configuration option for timeuintms (this is default).

08/31. Revise the action of edit control with ES_PASSWD style. (snig)
	* Can only input printable ascii chars, an invalid inputed char will be
	  converted to '*'.

08/30. Revise the returned value of ClipRgnIntersect (old gdi). (snig)
	* To be the same with newgdi.

08/19. Revise paint color of textedit control. (snig)
	* The background color of text in focus is different from the case without focus.

08/19. Revise EM_LIMITTEXT of sledit control. (snig)
	* Truncate text when the original text length is larger than the limit.

08/11. The most-used under-lay bitmap file loading routines are changed:
	* Windows BMP, GIF, JPEG, and PNG.

08/10. LoadBitmapEx function optimized.
	* The low-level bitmap loading routines changed.
	* Add InitMyBitmapSL, LoadMyBitmapSL, and CleanupMyBitmapSL.
	* Add PaintImageEx, PaintImageFromFile, and PaintImageFromMem 
	  (Only for _USE_NEWGAL).

08/10. Let LoadEtcFile return 0 when opening file fails. (snig)

08/09. Fix bug of FillBox. (snig)
	* When the argument w or h is a negative value, FillBox will go wrong.

08/09. Fix bug of monthcalendar control. (snig)
	* Should not paint title when MCS_NOYEARMONTH is used.

08/09. Destroy mutex locks for control.
	* DestroyWindow (src/gui/window.c).

08/05. Fix bug of the display of medit while it lost focus. (qzlong)
	* now the multi-edit will not highlight display any more while it lost
	* focus.
	* src/control/textedit.c motified.

08/05. Revise set_select_timeout function. (snig)
	* usec should be compared with my_timeout.tv_usec. <client.c>
	* setting select timeout according to the minimal timer interval. <timer.c>

08/05. Optimize timer implementation and fix a bug of SetTimerSpeed. (snig)
	* timer.c, message.c, desktop-comm.c, internals.h, timer.h 
	* Optimize data structures, TimerOwner and TimerID in the MSGQUEUE are discarded.
	* Use mutex to protect global data, and revise the implmentation of API functions
	  (no need to go through desktop thread)
	* Add HaveFreeTimer function for animition control.
	* The max timer number of an application is 32 now, and there is no special timer 
	  limit for a window.

08/04. Add the MSG_CLOSE handler of the Window created by createStatusWin for
closing the status window. (qzlong)

08/04. Add the MSG_CLOSE handler of the Window created by createProgressWin for
closing the progress window. (qzlong)

08/04. Remove all the calls to InitMiniGUIExt in the mgext library. (snig)
	* You must call it yourself before you can use any functions in this lib.

08/04. Fix bug in animation control.
	* In the ANM_STOPPLAY process, add next_frame call.

08/04. Fix bug in GetClipBoardByte function.
	*  if index < 0, will return CBERR_NOMEM.

08/04. Fix bug in the listbox control.
	* When user cancel a selected item, a LBN_SELCANCEL notification will be sent.

08/04. Fix bugs in the edit control.
	* src/control/edit.c
	* When pressed a backspace, if the current character numbers of the text is 
	  larger than the limit number, then an EN_MAXTEXT noficiation will be sent.
	* When the user set the limit number of the edit control, if the current character 
	  numbers if larger than the limit number, then an EN_MAXTEXT noficication will be sent.

08/04. Fix a bug about the IntersectRegion function.
	* When the intersect of two regions is NULL, the return value should be FALSE.

08/04. Fix a bug about the SetTabStop.
	* newgdi/drawtext.c, if the character is '\t', the width of this character should 
	  be controlled by the value by calling SetTabStop.  

08/04. Fix bug of LISTVIEW control on LVS_UPNOTIFY style. (snig)
	* Make LVS_UPNOTIFY affect LVN_CLICKED only, and LVN_SELCHANGE will be decided
	  by the mouse down event.
	* If LVS_UPNOTIFY style is used, when we press left mouse button on a listview
	  item, the LVN_SELCHANGE message will be issued first; then if we release the
	  button, the LVN_CLICKED is issued.

08/04. Fix bug of LISTVIEW control LVM_GETITEM message. (snig)
	* dwFlags
	* itemData

07/29. Fix bug of standalone event process error. (snig)
	* Causes endless key down messages.

07/25. Fix bug of create_clip_board. (jgcheng)
	* Judge if can add a new clipboard.

07/25. Add jpeg item int the bitmap_types array. (jgcheng)
	* mybmp/mybmp.c

07/24. Fix bug of propersheet control. (jgcheng)
	* In create_page function, when the control number is more than 0, the control 
	  array will be check if it is null.

07/24. Fix bug of CreateWindowEx. (jgcheng)
	* "if (pNewCtrl->pGCRInfo) free (pNewCtrl->pGCRInfo)", this statement will 
	  cause double free when CreateWindowEx failed.

07/24. Fix bug of ANIMATION control. (jgcheng)
	* Call IsAvailableTimer function in the MSG_CREATE message's process. If there is no 
	  available timer, value -1 will be returned.

07/24. Add a IsAvailableTimer function to judge if a timer is available in the system. (jgcheng)
	* src/kernel/timer.c

07/24. Fix a bug in function skin_set_slider_info. (jgcheng)
	* Need judge if the parameter is valid.

07/24. Fix a bug for TreeView control.(jgcheng)
	* Modify the code related to process MSG_VSCROLL and MSG_HSCROLL message of the TreeView control 

07/22. Enhance QPF module to support incore resource, and add three incore QPF fonts.
	* src/font/qpf.c
	* src/font/in-core/qpf-*-*.c

07/06. Add get_next_word operation for UTF-8.
	* src/font/charset.c

07/06. Add a SHADOW NEWGAL engine subdriver for FrameBuffer console.
	* Provide support for packed-pixel modes with depth less than 8.
	* Provide support for coordinates transformation.

07/06. Add in-core RBF Hei for GB2312.

07/05. Make GBK to be compatible with GB2312.
	* Using GB2312 as the charset name to create logical font will select GBK device font 
	  first if there is a such device font.
	* src/font/charset.c, operation of gbk_is_this_charset?
	* Add GetCharsetOpsEx to return the exact charset_ops of device fonts.
	* Add IsCompatibleCharset to check whether a charset is compatible with a given charset_ops.
	* Device fonts should use the standard charset names defined by MiniGUI, for example, 
	  using GB2312-0 for GB2312 device fonts.

07/01. Fix a bug of StretchBlt. (snig)
	* Remove IsCovered, not needed?
	* Add extreme conditions check.
	* I am not sure whether it is all right and whether it is exactly what it should be.

06/29. Add support for aos timer. (snig)
	* We do not use an indepenent timer thread for aos, but employing os timer instead.

06/26. Fix bug of error background handling of ANIMATION control.

06/26. Setting text color and bkcolor by using GetWindowElementEx functions
for GridView control. (qzlong)

06/25. Do not using low_passing filtering when bkcolor == textcolor.

06/25. Add extended style of WS_EX_CLIPCHILDREN to exclude children areas 
when painting a window.
	* include/window.h.
	* src/gui/window.c (BeginPaint function)

06/20. Add setting window bk color before text out for monthcalendar control. (snig) 

06/16. Tune ComboBox control to reflect MoveWindow.

06/16. Cleanup header files to avoid using C++ convention of comments.

06/16. Fix bug of ScrollWindow when moving the children.

06/15. Fix bug of password handling of SLEDIT to use the default logical font
when style ES_PASSWORD set.
	* src/control/edit.c and src/control/simedit.c.

06/15. Tune the controls's TextOut/DrawText to set the bkcolor explicitly 
even when using transparent mode.
	* All controls but MonthCalendar and GridView not reviewed.
	* These two control do not use the window element colors.

06/15. Fix bug of GetFontMetrics to return the logical font size for font_height.
	* src/font/logfont.c

06/15. Fix some incorrect descriptions about window API functions such as GetHosting. (snig)
	* Because of definition of HWND_DESKTOP is changed.

06/14. Fix bug of DestroyMainWindow and DestroyWindow on calling DestroyAllControls. (snig)
	* Should call DestroyAllControls after MSG_DESTROY message is sent.

06/13. Enhance ScrollWindow to move the children after scrolling a window.
	* ScrollWindow (src/gui/window.c)
	* dskScrollMainWindow (src/kernel/desktop-comm.c)

06/08. Fix bug of __mg_mouselock uninitialized when cursor support is disabled.

06/08. Add random IAL engine.

06/08. Fix a bug of GetNextDlgItem.
	* This bug make a segment fault when there is only one control with WS_GROUP.

06/08. Rename hh44b0 engine to embest44b0.

06/08. Add 12x12, 16x16, and 24x24 RBF fonts of BIG5.

06/08. Rename variable name of incore fonts to add prefix of __mgif_.

06/08. Merge ver-1-8-dev branch.
	* This version is merged from ver-1-8-dev branch at 2005/06/08.

06/07. Add low-pass filtering when the font has WEIGHT_BOOK style.
	* Disable font scale when not using NEWGAL.
	* Add gray_pixels and filter_pixels in struct DC.
	* Change the gdi_start_new_line to regenerate gray_pixels and filter_pixels.
	* Add do_low_pass_filtering function (src/newgdi/drawtext.c).
	* Add fontCopyStyleFromName function (src/font/fontname.c).
	* This feature only available for NEWGAL.

06/07. Change the configuration header from config.h to mgconfig.h.

06/06. Move logfont.c to src/font dir.

06/06. Add automatical scale factor for RBF and VBF fonts.

06/06. Fix bug of gridview on wrongly using HWND_DESKTOP. (snig)
	* including coolbar, skin, spinbox

05/25. Fix bug of timer in lite version. (snig)

05/20. Revise palette operations. (snig)
	* make GetPalette return the number of color entries received.
	* Add API functions CreatePalette, GetDefaultPalette, GetPaletteEntries, 
	SetPaletteEntries, ResizePalette, GetNearestPaletteIndex, GetNearestColor.

05/20. Add operations for GetGDCapability. (snig) 
	* GDCAP_DEPTH should return color depth, not bits per pixel.
	* GDCAP_BITSPP for getting bits per pixel.
	* GDCAP_RMASK, GDCAP_GMASK, GDCAP_BMASK

05/18. Add conv_from_uc16 operation to CHARSETOPS.
	* Add MB2WC, WC2MB, MBS2WCS, WCS2MBS functions to convert native char/string
	to unicode string.

05/09. Add CreateClipRgn and DestroyClipRgn. (snig)

04/20. Add IsDialog API function and MSG_ISDIALOG synchronous message.(snig)

04/20. Add DefaultWindowProc API function. (snig)
	* Can be used for all types of window.

04/20. Add GetWindowUnderCursor API function. (snig)
	* Gets the lowest level child window under the mouse cursor.

04/20. Changes the definition of HWND_DESKTOP. (snig)
	* HWND_DESKTOP is not zero now, but __mg_dsk_win, which is main window pointer 
	  of the desktop window.
	* May cause some problems of old application codes!

04/20. Changes the usage of pMainWin member of MAINWIN structure. (snig)
	* For main window, pMainWin equals main window pointer of itself.

04/20. Changes the usage of pHosting member of MAINWIN structure. (snig)
	* For the top level main window, pHosting equals __mg_dsk_win.

04/20. Add THREADINFO structure. (snig)
	* Used to store the information of a thread, including message queue and thread id.

04/20. Add PeekMesage and WaitMessage API function. (snig)
	* Changes the implementation of GetMessage function, you can specify window handle as zero
	  to get the messages of the current thread.

04/20. Add hash.c in the src/kernel directory. (snig)
	* For generic hash operations.

04/20. Moves timer-related codes in client, server and standalone directories to timer.c. (snig)

04/19. Fix bug of drawing text in transparent mode: (snig)
	* text color can have the same value with background color now.

04/04. Add _USE_FIXED_SB_BARLEN for scrollbar: (snig)
	* If you want to use a fixed-size scrollbar slider, enable this feature.

*******************************************************************************
What's new in this version (1.6.3, 2005/04/01 ~ 2005/04/30):

04/18. Add argument check in DestroyLogFont.
	* src/newgdi/logfont.c
	* src/gdi/logfont.c

04/18. Do not reset the fbcon's mode when start a new client.
	* src/newgal/fbcon/fbvideo.c
	* MiniGUI-Lite only

04/20. Tune CommLCD engine.
	* Use subdriver, and implement subdrivers for VxWorks i386 target 
	  and eCos generic target. 
	* Move implementation for ThreadX VisualFone Anvil to Shadow engine.

04/21. Add Shadow engine, and test QVFB subdriver.
	* Use subdriver and implement the subdriver for Linux QVFB target.
	* Implement subdrivers for ThreadX VisualFone Anvil target.
	* MiniGUI-Threads only.

04/22. Cleanup code of NEWGAL.

04/22. Fix a bug of error values of rect of __mg_screen_dc.
	* src/newgdi/gdi.c
	* src/gdi/gdi.c

04/26. Add ES_RIGHT and ES_CENTER styles support for SLEDIT control. (snig)

05/09. Add some code for pSOS. (snig)

05/18. Shield CircleArc and CircleArcGenerator when _HAVE_MATH_LIB not defined.

05/18. Use asyn...ly updating for Em85xx OSD engine.

06/06. Fix bug of listview control on malloc for text string. (snig)

06/06. Fix bug of textedit control on moving left arrow key on the beginning of a line. (snig)

*******************************************************************************
What's new in this version (1.6.2, 2005/03/01 ~ 2005/03/31):

03/02. fix a bug of sbUpButton function in window.c (panweiguo)
	* The bug is caused when don't needed the arrows of scrollbar.

03/02. Add return value checking of GetMainWindowPtrOfControl in GetMsgQueue function: (snig)

03/07. Fix bug of DrawTextEx2 and txtGetOneLine: (snig)
	* in the case of non-DT_WORDBREAK, condition for outputing only one char is not correct,
	  which will cause infinite loop in DrawTextEx2.
	* move some "!= 0" conditions for string lengths to "> 0".
	* add arguments checking for DrawTextEx2.

03/04. Modify "scale.h" to "evmv10.h" in the src/ial/evmv10.c file. (panweiguo)

03/07. Modify vcongui.h, because it causes a error when compliling MiniGUI for ECOS. (panweiguo)

03/09. Make ccitable in src/gui/ctrlclass.c to be a static variable.

03/09. Make InitIncoreVBFonts return TRUE when there is no incore vbfonts defined.

03/10. Modify src/include/internals.h and src/kernel/cursor-lite.c.
	*  When using --enable-lite and --enalbe-standalone, there are two errors.

03/12. Add hh2440 IAL engine.

03/17. Modify src/gdi/Makefile.am and add the file loadicon.c.

03/18. Fix bug of makefile.ng in src and ext directories. (snig)

03/18. Add the --disable-adv2dapi option to build/buildlib-ucos2-skyeye shell (qzlong)

03/18. Change attr->prio's value from MINIGUI_HIGHEST_MUTEXT_PRIO to OS_LOWEST_PRIO (qzlong)
	* In function pthread_mutexattr_init contained by src/libc/ucos2_mutex.c
	* It causes we can't compile minigui for ucos-ii
		 because the MINIGUI_HIGHEST_MUTEXT_PRIO macro is undefined currently.

03/20. Modify the function of DesktopSetActiveWindow in  src/kernel/desktop-comm.c  (panweiguo)
	*  Modify the function of open_ime_window in src/gui/window.c 
	*  Fix the bug of ime in STAND_ALONE mode.

03/21. Add support for Nucleus OS. (snig)
	* wvfb ial have unknown problems, to be fixed.

03/21. Add _USE_OWN_PTHREAD. (snig)
	* Should be defined in config.h, if own pthread implementation for an OS is needed.

03/21. Add TARGET_OS definition in rule files. (snig)
	* each rule file for a non-unix OS should define this macro.

03/21. Add __NODLL__ definition in config.h for win32 and nucleus-mnt. (snig)
	* If you want to compile MiniGUI as a static library, define this macro in the config.h used.

03/21. Fix some pthread.h and semaphore.h includes. (snig)
	* Removed some unnecessary includes for these two headers.
	* MiniGUI source files should not include these two headers directly, because they have
	  been included in common.h for thread version.
	* Let common.h include theadx_pthread.h, not pthread.h. The same as ucos2_pthread.h,
	  nucleus_pthread.h and semaphore.h.
	* Let 'make install' install threadx_pthread.h as pthread.h, threadx_semaphore.h as semaphore.h

03/21. Add mgetc-ucosii-skyeye.c to src/sysres/ directory. (qzlong)

03/21. Modify src/mgetc-ucosii-arm3000.c for compatible with the new added mgetc-ucosii-skyeye.c file (qzlong)
	* Should we add a macro for skyeye?

03/23. Fix bug of rules.make. (snig)
	* Should use CFLAGS +=, not CFLAGS =.

03/23. Modify the function of  LookForEtcFile in src/misc/misc.c to change the search path of MiniGUI.cfg(panweiguo)
	*  Make it same as MiniGUI-Str

03/23. Add skyeyeep7312 IAL. 
	*  add the files of src/ial/skyeye-ep7312.c, src/ial/skyeye-ep7312.h, build/buildlib-linux-ep7312-skyeye
	*  modify the files of configure.in, make_tarball, configs/config.in, configs/Configure.help, configs/defconfig,
	*  configs/feature.in, configs/Makefile.am, build/Makefile.am, src/ial/Makefile.am, src/ial/ial.c

03/25. Fix serious bug of RemoveTimer. (snig)
	*  Should remove the timer message flag in 'pMsgQueue->dwState' associated with this timer,
	   otherwise, a timer message may occur event when this timer has been destroyed.
	*  The same problem with SetTimerSpeed.
	*  The same problem with ThrowAwayMessages.
	*  Add ClearTimer, implements RemoveTimer with ClearTimer
	*  If id argument of KillTimer/RemoveTimer is zero or a negative value, all timers of the
	   specified window will be destroyed.

03/25. Tune DestroyMainWindow and DestroyWindow. (snig) 
	*  To be safer, call DestroyAllControls and KillTimer at the begin of each these functions.
	*  No need to call dlgDestroyAllControls and ThrowAwayMessages in DestroyMainWindowIndirect
	   and DialogBoxIndirectParam.

03/28. Merge several duplicated QueueMessage functions to one. (snig)
	*  from client.c, server.c, standalone.c and init.c to message.c

03/28. Merge code of timer-lite.c to timer.c. (snig)

*******************************************************************************
What's new in this version (1.6.2, 2005/01/31 ~ 2005/02/28):

02/16. Add makefile.msvc files for NMAKE+MSVC compilation: (snig)
	* add makefile.msvc files for MS NMAKE and VC
	* revise makefile.ng files to use Makefile.am defines
	* add __MGEXT_LIB__ predefined macro for mgext library
	* lets _LITE_VERSIOIN and _STAND_ALONE to be the predefined compile-time
	  macros which are defined by a '-D' flag.
	* controls compilation of *-lite.c of lite version through _LITE_VERSION
	  and _STAND_ALONE, these files may be compiled even in the thread mode.
	* fix error of MG_EXPORT definition, and add MGEXT_EXPORT

02/16. Fix bug of RectVisible of OLDGDI (src/gdi/clip.c)

02/17. Rename wvfb.c in the src/ial directory to wvfbial.c: (snig)
	* Having the same name may cause problems in some compilation environments.

02/18. Wakeup the waiting threads in ThrowAwayMessages.

02/18. Add arguments check code in APIs exported by window.c.

02/18. Using environment variables to specify the values of keys in section "system" of MiniGUI.cfg.
	* The keys are gal_engine, defaultmode, ial_engine, mdev, and mtype.
	* The settings of environment variables will overload the settings in MiniGUI.cfg
		o src/newgal/newgal.c
		o src/ial/ial.c
		o src/gal/gal.c

02/19. Code cleanup in message.c: (snig)
	* Merge lite version codes to thread version

02/19. Fix bug of EndPaint (snig)
	* Should call GetCaretBitmaps when caret is able to blink.

02/19. Fix bug of PostMessage, PostQuitMessage, and SendNotifyMessage: (snig)
	* Should call sem_post only when the target window does not belong to the current thread
	* Add BE_DESKTOP_THREAD and BE_THIS_THREAD

02/21. Add MG_CHECK and MG_CHECK_RET in internal.h for arguments checking in API functions: (snig)
	* use MG_IS_WINDOW to decide whether a window handle represents a valid window
	* add MG_GET_WINDOW_PTR and MG_GET_CONTROL_PTR

02/22. Add mgconfig.h: (snig)
	* should include mgconfig.h not config.h directly

*******************************************************************************
What's new in this version (1.6.1, 2004/10/06 ~ 2005/01/31):

10/09. Fix bug of pallete copy in GIF98a:
	* ext/control/gif89a.c (430), lost some entries of palette
		memcpy (ImageDesc->ColorMap, GifScreen->ColorMap, MAXCOLORMAPSIZE*3);
	* to
		memcpy (ImageDesc->ColorMap, GifScreen->ColorMap, MAXCOLORMAPSIZE*sizeof (RGB));

10/18. Enhance src/mybmp/winbmp.c to handle the BI_BITFIELDS and 16-bpp BMP files:
	* add read_16bit_image function to handle 16-bbp BMP files.
	* add support code for BI_BITFILEDS type, but only color masks specific to
	* Windows 95 are supported.

10/19. Add IconView control to mgext library. (snig)
	* add src/include/control/listmodel.h
	* add src/control/listmodel.c
	* add ext/control/iconview.c iconview.h
	* some codes are moved from scrollview.c to listmodel.c and scrolled.c because
	* iconview and scrollview have the same list-like data model, but with a different UI.

10/20. Fix documentation bugs in header files:
	* include/common.h (SBPolicyType)
	* include/gdi.h (_DTFIRSTLINE)
	* include/control.h (SVM_SELECTITEM)
	* include/control.h (scrollview_set_item_height)
	* ext/include/mgext.h (SPS_TYPE_DOWNARROW)

10/20. Upgrade configuration options:
	* Version number to 1.6.1 in configure.in.
	* Add configuration options for IconView control in files under configs/.

10/28. Add imeinfo section for incore-res:
	* Add key and value definitions in src/sysres/mgetc.c when _IME_GB2312 defined.
	* Delete build_ime_gb2312="no" when "x$incore_res" = "xyes" in configure.in.

11/03. Fix bug of textedit control on inserting string: (snig)
	* src/control/textedit.h, textdoc_insert_string_ex_2 inline function,
	  should call txtdoc->change_cont event after deleting selection.

11/12. Fix bug of scrollview control on scrollview_del_item: (snig)
	* src/control/scrollview.c, wrong usage of psvlist pointer
	* introduced by revising for iconview and listmodel.c

11/14. Fix bug of sledit control on backspace: (snig)
	* introduced by last bug fix for multi-byte process(09/28)
	* src/control/edit.c, should not both process MSG_KEYDOWN and MSG_CHAR
	* process only MSG_CHAR now like the textedit control
	* This change will affect input methold?

11/16. modify behaviour of MSG_SETTEXT for edit and textedit control
	* If wParam of MSG_SETTEXT is not zero, the caret will be set to the end of the text.

11/30. Add initial version of GridView control in MiniGUIExt library. (clear)
	* add ext/control/gridview.c gridview.h gridviewcelltype.c

12/01. Change the macros for GridView control:
	* from _EXT_CTRL_GRID to _EXT_CTRL_GRIDVIEW
	* from --enable-extctrlgrid to --enable-extctrlgridview

12/03. Fix bug of gridview control on dragging of a column which has checkbox control(s). (qzlong)
	* if the downsizing of the column is going to hide the whole text of the checkbox control,
	* the column will not downsize any more.
	* ext/control/gridview.c, check if the column has a checkbox control.

12/03. Fix bug of gridview control on dragging of the first column or the first row. (qzlong)

12/03. Fix bug of gridview control on getting of the column's width or row's height. (qzlong)

12/03. Fix bug of gridview control on ending of the edit control's editting. (qzlong)
	* ext/control/gridviewcelltype.c, add MSG_KILLFOCUS message to end the editting
	* while the focus of the edit control lost.

12/03. Make GridView enabled by default:
	* configure.in.

12/03. Fix bug of GetNextMainWindow: (clear)
	* In src/kernel/desktop-comm.c when handling MSG_GETNEXTMAINWIN message.

12/06. Fix bug of gridview control on editting after delete a col or a row. (qzlong)
	* ext/control/gridview.c, check if current column(row) should be decreased after delete a column(row).

12/07. Fix bug of gridview control on editting the hided cell. (qzlong)
	* make the cell visible while it is being edited.

12/07. Fix bug of gridview control on dragging of the last column or row. (qzlong)

12/08. Add EM_CHANGECARETSHAPE message for edit controls. (snig)
	* use this message to change caret shape
	* ED_CARETSHAPE_LINE and ED_CARETSHAPE_BLOCK

12/09. Add EM_REFRESHCARET, EM_SETGETCARETWIDTHFUNC and EM_SETDRAWSELECTFUNC. (snig)

12/09. Add initial NEWGAL engine for MB93493(UDTech). (clear)

12/09. Add initial IAL engine for ABSSIG(UDTech). (clear)

12/13. Add VBF 2.0 support. (qzlong)

12/15. Add input engine for HHARM2410R3 touch screen. (cxzhang)
	* add file  src/sysres/mgetc-hh2410r3.c
	* src/sysres/mgetc.c

12/25. Fix a mistake of VBF loading code:
	* This bug only affect big endian system (src/font/varbitmap.c:447~448)

12/25. Fix bug of NEWGDI put_hline:
	* This bug only affect 32-bpp mode (src/newgdi/gdi.c:1178)

12/28. Fix segmentation fault bug when loading bad gif file:
	* add "return -1" to src/mybmp/gif.c:434
	* add "return -1" to ext/control/gif98a.c:214
	* add "if (v >= 0)" return 0;" to ext/control/gif98a.c:530

12/28. Add fields to handle the disposal of ANIMATION objects:
   * ext/include/mgext.h: add 'disposal' to ANIMATIONFRAME structure.
   * ext/include/mgext.h: add 'bk' to ANIMATION structure to specify the global background.
   * ext/control/gif98a.c and ext/control/animation.c: change code to handle the disposal.

12/30. Tune mouse handle of tracking popup menu.
   * Do not handle BUTTONUP message when there is no hilited item (src/gui/menu.c:2555).

12/30.  Remove contents of dti.c
   * Contents of include/dti.c have been moved to src/sysres/dti.c.
   * Application does not need to include dti.c file.

12/30. Main entry of MiniGUI changed.
   * Change InitGUI of MiniGUI-Thread to return int value of step.
   * Merge main-lite.c into main.c
   * Add --enable-miniguientry option to configure.
   * Change CustomizeDesktopMenu&CustomDesktopCommand to function pointer and remove them from dti.c.
   * Applications can use InitGUI and TerminateGUI directly.
   * MiniGUIMain is changed to a macro.

01/04. Merge lite and thread version of old gdi codes.
   * Codes in *-lite.c files are merged into *.c files.

01/05. Update copyright informatioin in header files.

01/05. Add vcongui/foo.c for creating a foo VCOnGUI library.

01/05. Add more osname options in configure.in:
	* win32: for Win32 platform
	* darwin: for OpenDarwin (Max OS X), but sem_init is not implemented
	* threadx: for ThreadX
	* Change macro __NOLINUX__ to __NOUNIX__

01/05. Add PThread mutex and POSIX nonamed semaphore implementation on SysV IPC.
	* Move including of <pthread.h> and <semaphore.h> from minigui.h to common.h.
	* Tested on Darwin and uClinux.

01/06. Cleanup code.
	* Remove PreInitGUI and PostTerminateGUI functions from include/dti.c.
	* Define "void __mg_os_timer_loop (void)" function for UNIX-like OS, 
	  just call pthread_join (src/kernel/timer.c:147), and delete conditional-compilation
	  in src/kernel/init.c:218.

01/07. Scripts in configs/ cleanup.

01/07. Add SetMouseCalibrationParameters function.
	* Add code in src/include/ial.h and src/ial/ial.c
	* Add mousecalibrate option in configure.in and macro _MISC_MOUSECALIBATE.
	* Change internal global viriable cur_input to __mg_cur_input.
	* Change internal global viriable cur_gfx to __mg_cur_gfx.

01/07. Fix ANIMATION control to use shadow memory dc to redraw (ext/control/animation.c).

01/08. Add --with-targetname to configure.in.

01/08. Optimize mouse calibration routines to use integer operations (src/ial/ial.c).

01/08. Fix alignment bug of OLDGAL native engine:
	* putboxmask functions of 8-bpp, 16-bpp, and 32-bpp (src/gal/native/fblin[8,16,32].c.

01/10. Fix bug of GetGDCapability (src/gdi/gdi.c and src/newgdi/gdi.c).

01/10. Fix ANIMATION control. (ext/control/animation.c)
	* Dynamic colorkey selection, transparence should be OK.
	* Add style ANS_SCALED, scale the animation to the control size
	* Allow NULL value of ANIMATION*, user can use ANM_SETANIMATION set it after created.

01/14. Change src/libc/nulldev.c to src/libc/defdevc.c
	* Change __mg_null_dev to __mg_def_dev

01/14. Add malloc and stdio implementation for ThreadX:
	* Add minigui_tx_malloc_init function and code specific to ThreadX (src/libc/malloc.c).
	* Add definition of __mg_def_dev specific to ThreadX (src/libc/defdev.c).
	* Fix round name confiliction of round in src/libc/vfnprintf.c.

01/14. Add __mg_os_time_delay implementation for ThreadX:
	* Call tx_thread_sleep to do delay (src/misc/nposix.c).

01/17. Use macro to control the typedes of BYTE, WORD, DWORD, UINT, and LONG (include/common.h)
	* If not defined _HAVE_TYPE_BYTE, common.h will define BYTE.
	* If not defined _HAVE_TYPE_WORD, common.h will define WORD.
	* If not defined _HAVE_TYPE_DWORD, common.h will define DWORD.
	* If not defined _HAVE_TYPE_UINT, common.h will define UINT.
	* If not defined _HAVE_TYPE_LONG, common.h will define LONG.

01/18. Add configure option for locale.h in configure.in.
	* Call setlocale (LC_ALL, "C") if HAVE_LOCALE_H defined.

01/10. Fix ANIMATION control. (ext/control/animation.c)
	* Fix bugs cause compile error with OLDGAL.
	* Add style ANS_FITTOANI, resize the control to the animation's size
	* Rewrite the code handle disposal and fix a bug when disposal is 3.

01/16. Add docs target to Makefile
	* Now, run 'make docs' in the top directory can generate doxygen documents.
	* Remove most warrings and errors with doxygen.
	* Regenerate Doxyfile with doxywizard.

01/19. Split control.h and mgext.h into small files.

01/19. Fix memory leak bug of FillBoxWithBitmap(Part).

01/19. Add dynamic colorkey selection to ExpandMyBitmap.

01/20. Tune fixed math routines to avoid use Uint64 type.
	* Function fhypot (src/misc/math.c).
	* CircleArcGenerators no longer use fixed math routines, and ang2 is relative to ang1.

01/31. Merge the branch 'threadx'.

01/31. Cleanup the README files and header files (include/*.h and src/include/control/*.h)

01/31. Fix filename conflict in IDS.

01/31. Remove some warnings.

02/01. Fix bugs in qvfb IAL.

02/01. Fix bug with EM_SETCARETPOS message in simedit.c.

02/02. Fix bug of output rect of ArcEx.

02/04. Fix bug of CreateLogFontByName and fontGetStyleFromName.

02/05. Optimize textedit control on caret and long text input
	* Add EM_ENABLECARET message
	* Add EM_INSERTTEXT

02/06. Optimize implementation for Win32:
	* Use Sleep instead of _sleep.
	* Use mutex object to optimize WVFB engine.

*******************************************************************************
What's new in this version (1.6.0, 2004/06/26 ~ 2004/10/01):

06/26. Merge to be version 1.6.0 candidate.

06/28. Add osname of 'swlinux' to support Winbond SWLinux.

06/28. Fix bug of FillBoxWithBitmapPart.

06/29. Uses dwReserved field of MAINWINCREATE to store dialog template pointer, instead of dwAddData. (snig)
	*  This change is to make sure that the user can get his additional dialog data before MSG_CREATE.

06/29. Fix bug of DrawTextEx2 on old GAL for MiniGUI-Lite.

06/30. Add SVM_GETITEMADDDATA, SVM_SETITEMADDDATA, SVM_REFRESHITEM messages for scrollview. (snig)

07/06. Add key operations support for monthcalendar control. (snig)

07/08. Change the primitive of TabbedTextOutLen:
	* The tabs will be expanded directly.

07/08. Fix the bug of incorrect width with tabs of DrawTextEx2.

07/14. Add ANIMATION control and GIF 89a support in MiniGUIExt.

07/15. Fix bug of multiple line output and bold font of DrawTextEx2.

07/16. Add incore resource for new OpenFileDialogBox.

07/16. Add system text for OpenFileBox and ColorSelectionBox.

07/16. Add internal functions to init/cleanup global resource for new OpenFileDialogBox:
	* InitNewOpenFileBox/NewOpenFileBoxCleanup.

07/16. Add internal functions to include/exclude the extended style of a window:
	* IncludeWindowExStyle/ExcludeWindowExStyle

07/16. Tune DialogBoxIndirectParam to active the parent only when the dialog is active.

07/17. Optimize drawing of scrollbar and ListBox/TreeView control.

07/19. Fix bug of treeview refreshing previous selected item when clicking on the "+" area. (snig)

07/20. Add initial NEWGAL and IAL engines for UTPMC.

07/21. Add the illustation of the functions and the structures in colorspace.h and colordlg.h. (panweiguo)

07/21. Tune the interface about color conversion.

07/21. Add EM_GETLINEHEIGHT and EM_SETLINEHEIGHT for textedit control. (snig)

07/21. Add MCM_GETCURWEEKDAY for monthcalendar control. (snig)

07/22. Fix bug of simedit control on showing password character. (snig)

07/22. Fix bug of monthcalendar control in the case of going to a year before 1970. (snig)

07/23. Fix bug of textedit control when do delete_selection.

07/23. Fix bug of lock/unlock screen semaphore in MiniGUI-Lite.

07/26. Move buildlib-* scripts to the build directory. (snig)

07/26. Add EM_COPYTOCB message for sledit and textedit control.

07/27. Fix warning in newfiledlg.c. (panweiguo)

07/27. Reimplement ColorSelectionDialogBox to not use global variable. (zxh)

07/27. Adjust the display style of the dialog in newfiledlg.c (panweiguo).

07/28. Rebuild the code of the new open dialog in newfiledlg.c (panweiguo).

07/28. Use GIF compatible memory DC to build the frame of ANIMATION when using NEWGAL.

07/29. Add insert key support for sledit control. (snig)

07/29. Adjust the code in newfiledlg.c. (panweiguo)

07/30. Move the implementation of strnchr and substrlen to src/misc/misc.c.

07/30. Move the implementation of strtrimall from  ext/mywins/newfiledlg.c  to src/misc/misc.c. (panweiguo)

08/02. ucos2lcd and ecoslcd engine are replaced by commlcd engine, removed from code. (snig) 

08/02. ucos2ial is replaced by commial, removed from code. (snig)

08/02. add __mg_os_time_delay function for time delay. (snig)

08/02. Remove the extended style of NewToolBar control to be a normal style.

08/02. Split mgetc.c to several files according to os type and gal engine. (snig)

08/03. Fix bug of PolyLineEx when using zero pen.

08/03. Add __mg_ prefix to load_bmp/check_bmp functions.

08/05. Fix bugs of TreeView:
	* LVM_DELTREE can not handle root node correctly.
	* The initial scroll bars runs abnormally.

08/05. Fix bugs of TrackBar:
	* Can not refresh the tip when draging the slider.
	* Can not handle arrow keys when the control is in a DialogBox.

08/05. RecalcClientArea when calling UpdateWindow.

08/05. Define MY_PATHMAX and MY_NAMEMAX to replace PATH_MAX and NAME_MAX in newfiledlg.h.

08/05. Add mgetc-uptech.c for netarm3000.

08/07. changes name of button.c and button.h in the ext/skin/ directory to cmdbutton.c and cmdbutton.h (snig)

08/10. Fix bug of textedit mouse move action. (snig)

08/10. Remove GetPixelInBitmap from bmplabel. (snig)

08/12. Fix bug of PropertySheet and CoolBar control.

08/12. Modify the CreateThreadForMainWindow function in window.c for uClinux.

08/16. Modify ShowOpenDialog, Make the directory can be open when it was clicked. 

09/08. Fix bugs of ArcEx and tiled bitmap filling.

09/14. Remove examples/ from distribution.

09/15. Handle scrollbars of TreeView control more gracefully.

09/15. Add MSG_FONTCHANGED handling and fix bug of multibyte strings handling of edit control. (snig)

09/16. Add the following IAL engines:
	* For DigiPro DM270. (yaoyy)
	* For DigiPro EVMV10. (yaoyy)
	* For SinoVee ADS 7846. (clear)
	* For Up-Tech ARM3000. (yaoyy)
	* For FFT ARM7202. (yaoyy)
	* For Fudan-Tech RM9200. (panweiguo)

09/16. Fix bug of AnimationControlCleanup.

09/16. Add macro _MG_PRINTF to control the debug messsages.

09/16. Fix naming bug of ResetTimer.

09/17. Fix display bug of edit control in ES_PASSWORD style. (snig)

09/22. Fix mouse capture bug of TrackBar control.

09/28. Fix bug of textedit and edit control on dealing with char code larger than 0x7F.(snig)

09/29. Fix bug of timeout workaround for BF533 engine under MiniGUI-Standalone:
	* src/standalone/standalone.c

09/30. Tune code for scrollbars.

10/01. Release as version 1.6.0 and create CVS tag ver-1-6-0.

*******************************************************************************
What's new in this version (1.6.0-dev, 2004/05/09 ~ 2004/06/30):

05/09. Create ver-1-6-dev branch.

05/10. Move src/include/control/list.h to src/include/.

05/10. Add following functions:
	* SetWindowElementMetricsEx/GetWindowElementMetricsEx.
	* SetWindowElementColorEx/GetWindowElementColorEx.

05/10. Add following internal functions:
	* get_window_element_data/set_window_element_data/free_window_element_data
	* can be used to maintain window data of specified type.

05/11. Update all controls to use GetWindowElementColorEx function to retrive the pixel value.

05/26. Redefine the window element colors.

05/26. The following API changed to use the window specific color definitions:
	* DrawFlatControlFrame removed.
	* Draw3DControlFrame removed.
	* Draw3DUpThinFrame/Draw3DDownThinFrame removed.
	* Draw3DUpThickFrame/Draw3DDownThickFrame removed.
	* Draw3DBorder removed.
	* DisabledTextOut removed.
	* DrawFlatControlFrameEx changed.
	* Draw3DControlFrameEx added.
	* Draw3DThinFrameEx added.
	* Draw3DBorderEx added.
	* DisabledTextOutEx added.

05/29. Add treeview support to listview control, and adjust the interface of listview.

05/29. Add MSG_FREEZECTRL.

06/03. Add back compatibility definitions for the following interfaces:
	* Draw3DUpFrame/Draw3DDownFrame.
	* Draw3DUpThickFrame/Draw3DDownThickFrame.
	* Draw3DUpThinFrame/Draw3DDownThinFrame.
	* Draw3DBorder.
	* DisabledTextOut.
	* DrawFlatControlFrame.
	* Draw3DControlFrame.

06/09. System headers and README files updated.

06/15. A popup menu drawing bug fixed (The status of first menu item ignored).

06/16. Add newtoolbar support the following function (Linxs):
	* Add new toolbar style  NTBES_HORIZONTAL, NTBES_VERTICAL, NTBES_MULTLINE.
	* Add new item style NTBIF_CHECKBUTTON, NTBIF_NEWLINE, NTBIF_CHECKED.

06/17. Add ColorSelDialog in mywin to select color. (Linxs).

06/17. Newtoolbar support MSG_RBUTTONUP and MSG_LBUTTONDBCLICK now, and the id of item should not larger than 16384. (Linxs)
	* If right button up, parent will get MSG_COMMAND with (HIWORD(wParam) & 0x8000) == 0x8000.
	* If left button double clicked, parent will get MSG_COMMAND with (HIWORD(wParam) & 0x4000) == 0x4000.

06/17. Fix bug of SLEDIT control when selecting a short text. (snig)

06/22. Do not check fbcon modes for SPC (NEWGAL FBCON engine).

06/22. Add support for cygwin and windows virtual framebuffer (WVFB). (snig)
	* support MiniGUI-Thread on cygwin/wvfb.
	* WVFB is far from complete now.

06/24. Let DefaultContainerProc of SCROLLWND control return DefaultPageProc at default cases. (snig)

06/24. Fix bug of code for saving windows bitmap file.

06/24. Add BitmapDDAScaler/BitmapDDAScaler2 functions and implement the following functions by using the scalers (NEWGDI):
	* ScaleBitmap
	* FillBoxWithBitmap
	* FillBoxWithBitmapPart
	* StretchBlt

06/25. Fix bug of clipboard in LITE version. (snig)

06/25. Fix bug of UnionRegion (incorrect bounding box of region). (ymwei)

*******************************************************************************
What's new in this version (1.5.4, 2004/05/10 ~ 2004/06/30):

05/10. Update the 'make menuconfig' scripts.

05/13. Fix erase bkground bug of SKIN control.

05/13. Add NEWGAL engine for BF533 OSD via SPI.

05/13. Fix miwideline drawing bug.

05/17. Fix bug of mouse message handling of SKIN (ymwei).

05/17. Add IAL engine for Ads7846.

05/18. Do not send MSG_TIMEOUT from the server to clients (ymwei).
	* Clients sends MSG_TIMEOUT to its desktop when there is no event from the server.

05/19. Add IAL engine for HHCF5249 PS/2 keyboard and IrDA (ymwei).

05/19. Add the following definitions in common.h (ymwei):
	* SCANCODE_POWER
	* SCANCODE_SLEEP
	* SCANCODE_WAKEUP

06/07. Tune TranslateMessage to ignore the scancode above SCANCODE_USER (ymwei).

06/08. Fix bug of Endian-Read functions (ymwei):
	* MGUI_ReadLE16Mem, MGUI_ReadLE32Mem
	* MGUI_ReadBE16Mem, MGUI_ReadBE32Mem

06/10. Fix incore bitmap loading bug of MiniGUI-Lite (ymwei).

06/16. Rewrite code calling sigaction for uClinux on M68K (ymwei).

06/16. Make interval time of SIGALARM to be 100ms for uClinux and MiniGUI-Standalone (ymwei).

06/16. Note that the font_size field of in-core VBF font should be zero (ymwei)!!!!

06/19. Use clone and fock to implemente the asynchronous update of BF533 engine.

06/23. Add LBS_SBALWAYS style to listbox control (snig).

06/24. Fix parameter of NewToolBar control of message NTBM_GETITEM, NTBM_SETITEM, and NTBM_ENABLEITEM.

06/24. Fix bug of SLEDIT control when selecting a short text. (snig)

*******************************************************************************
What's new in this version (1.5.3, 2004/03/01 ~ 2004/04/31):

03/01. Create ver-1-5-2-rc1-phone branch for MiniGUI phone style.

03/01. Add with-style=[pc3d/flat/phone] option in configure.in.

03/01. Add MiniGUI-phone.cfg file.

03/01. Add incore-resource for phone style.

03/01. Add GetSysFontHeight, GetSysFontMaxWidth, GetSysFontAveWidth functions.

03/01. Change SIMEDIT control to use the default fixed system font.

03/02. Add CBS_SPINARROW_TOPBOTTOM and CBS_SPINARROW_LEFTRIGHT styles for COMBOBOX control.

03/02. Fix bug of error args calling SetAutoRepeatMessage function in COMBOBOX and SPIN control.

03/04. Fix bug of IntersectClipRect to handle empty clipping rect.

03/05. Add phone style for TrackBar control.

03/10. Add phone style for Button control.

03/10. Add phone style for ScrollBar.

03/10. Add some predefined colors for control elements.

03/10. Background painting of EDIT, LISTBOX, TREEVIEW, and so on removed from MSG_PAINT code.

03/11. Rewrite the code for resetting capture information.
	* Do not post message MSG_MOUSEMOVE in the case.
	* Just reset the cursor to default cursor.

03/12. Update MiniGUI.cfgs in etc/.

03/19. Fix bug of paint baseline of SIMEDIT control.

03/19. Add SPS_HORIZONTAL style for SPINBOX control.

03/20. Add GetStockBitmap function and rename the SYSBMP_* macros to STOCKBMP_* macros.
	* Note that the code should use this function to load the stock bitmap objects.

03/20. Enhance MENUBUTTON control.
	* Add new styles MBS_NOBUTTON, MBS_LEFTARROW, MBS_ALIGNLEFT, MBS_ALIGNRIGHT, MBS_ALIGNCENTER.
	* Add new notification code MBN_CLICKED.

03/24. Enhance SPINBOX control.
	* Add new styles SPS_TYPE_NORMAL, SPS_TYPE_UPARROW, and SPS_TYPE_DOWNARROW.
	* The default is SPS_TYPE_NORMAL, which means the spin box has two arrows.
	* Merge GetVertSpinBoxSize and GetHorzSpinBoxSize to GetSpinBoxSize function.

03/31. Tune mouse capture mechanism.
	* Only force to release the capture when change the window itself.
	* Force to release the capture when destroy the window.

04/01. Rewrite the TrackBar control.
	* Add TBN_STARTDRAG and TBN_STOPDRAG notification codes.
	* No longer use memory DC to paint.

04/01. Tune code of ProgressBar control.
	* No longer use memory DC to paint.

04/01  Add ScrollView control.

04/01  Add TextEdit control.
	*  The old medit control is obsolete now.

04/01. Merge phone-style branch.

04/06. Add DrawTextEx2 function to retrive the info of first output line.

04/16. Enhance ListBox control to cancel selected item by using LB_SETCURSEL message.

04/18. EUC-JP and Shift-JIS now can use the same font file.

04/19. Merge svpxxosd-newgal-engine branch.

04/21. Add BMP_TYPE_MONOKEY and bmColorRep field to support colorful mono bitmap.

04/23. Add GetTabbedTextExtentPoint to get the extent of a formatted string.

04/30. Fix bug of memory leakage in ListView control

*******************************************************************************
What's new in this version (1.5.2, 2004/02/02 ~ 2004/02/29):

02/02. Create ver-1-5-ucos2 branch for MiniGUI for uC/OS-II.

02/02. Add our own implementation of malloc/calloc/free.

02/02. Add our own implementation of printf/fprintf/sprintf.

02/03. Our own malloc/stdio implementations tested on Linux.

02/04. Add our own implementation of pthread for uC/OS-II.

02/04. Change definition of MSG for MiniGUI-Threads.
	* The type of 'time' field changed to unsigned int.

02/04. MiniGUI no longer uses the function 'gettimeofday'.
	* The private version of this function has been deleted.

02/06. MiniGUI can run on uC/OS-II (target SkyEye) now.

02/06. Change the default stack size of MiniGUI thread to 12KB.

02/11. MiniGUI can now be compiled by ARMCC.

02/11. Use AC_ARG_WITH macro to specify the Operating System.
	* Please use --with-osname=[linux/uclinux/ecos/ucos2] to specify the name of the target operating system.

02/20. Add support for simulation of mouse in FIP IAL engine.

02/25. Merge ver-1-5-ucos2 branch.

02/28. Fix bug of MGUI_ReadLE16Mem, MGUI_ReadLE32Mem.
	* This bug will cause error when reading 32-bit integer on no four-byte boundary.

03/30. UpdateTopmostLayer (the dirty rect should be intersected before send2client).

*******************************************************************************
What's new in this version (1.5.1, 2003/11/20 ~ 2004/02/02):

11/20. Create a branch for MiniGUI Version 1.5.0.

12/03. Remove SetClientScreen function.

12/11. Merge this branch to main branch.

12/10. Add GRID control to MGExt library.

12/11. Enhanced SLEDIT control to support selection and Copy/Paste.

12/15. Add IAL engine for Intel DMG GEN10 STB.
	* add src/ial/dmg-stb.c and src/ial/dmg-stb.h.

12/22. Add clipboard operations.
	* add declarations in include/minigui.h.
	* add _MGHAVE_CLIPBOARD condition and "clipboard" configuration option.
	* CreateClipBoard, DestroyClipBoard functions.
	* SetClipBoardData/GetClipBoardDataLen/GetClipBoardData/GetClipBoardByte functions.

12/22. Add advanced 2D graphics APIs.
	* add declarations in include/gdi.h.
	* add _MGHAVE_ADV_2DAPI condition and "adv2dapi" configuration option.
	* add GetPenType/SetPenType functions to get/set the pen type.
	* add SetPenDashes to set the way dashed-lines are drawn.
	* add GetPenCapStyle/SetPenCapStyle to get/set the way the end of lines are drawn.
	* add GetPenJoinStyle/SetPenJoinStyle to get/set the way the joins between segments of a polygon.
	* add GetPenWidth/SetPenWidth to get/set the width of the pen.
	* add GetBrushType/SetBrushType to get/set the brush type.
	* add SetBrushInfo to set the brush tile and stipple bitmaps.
	* add SetBrushOrigin to set the origin of the tile or stipple bitmaps.
	* add LineEx to draw a line.
	* add ArcEx to draw an arc.
	* add FillArcEx to fill an arc.
	* add PolyLinEx to draw a poly-line.
	* add PolyArcEx to draw a poly-arc.
	* add PolyFillArcEx to fill a poly-arc.

12/22. No longer use the configuration header template file, "acconfig.h".

12/25. Change some NEWGDI APIs.
	* Rename ArcGenerator to CircleArcGenereator.
	* Rename Arc to CircleArc.

12/25. Advanced 2D graphics APIs are OK now.

12/25. ClipBoard APIs are OK now..

12/28. Add NEWGAL engine for EM85xx QUASAR OSD FrameBuffer.

12/28. Add IAL engine for EM85xx NEXTBASE Front Panel and Remote Controller.

12/30. Add WS_EX_TRANSPARENT style support for control.
	* ListView is OK now.

01/03. Do not use inter-libraries dependency any more.
	* You should specify the dependent libraries of MiniGUI when build
	  applications.

01/04. Fix a bug of FillBoxWithBitmapPart in old GDI module.

01/05. Fix a bug when loading transparent paletted PNG file.

01/09. Use strncmp instead of strncasecmp for clipboard ops.
   * The clipboard name is case-sensitive.

01/09. Use strncmp instead of strncasecmp for engine names.
   * The ial/gal engine names in MiniGUI.cfg are case-sensitive.

01/09. Use __ECOS__ macro instead of __ECOS.

01/12. Implement the alignment flags of TrackPopupMenu.

01/15. Fix bug of MoveWindow.
	* But still need more optimization.

01/29. Cleanup dummy IAL engine.

01/29. Add Automatic IAL engine.

01/29. Add IAL engine for OKWAP Palm2.

01/29. Add __mg_ prefix for some internal-only extern functions.

01/29. Screen DCs for client will be clipped by server windows. (LITE version).

01/29. Fix documentation for GRID control in MGExt library.

02/01. Use pthread_setstacksize function to set the stack size on eCos.

02/02. Release as version 1.5.1.

*******************************************************************************
What's new in this version (1.3.2, 2003/11/04 ~ 2003/12/31):

11/04. Fix bug of small resolution on NEWGAL.

11/06. Add IAL engine for SMDK2410 touch screen.

11/21. Fix bug of SKIN and TerminateSysRes function.

11/21. Tune the QVFB IAL engine.

11/23. Add support for eCos, and tested on iPAQ H3600.

11/23. PtInRegion, RectInRegion, and OffsetRegion are available for old GAL.

12/01. Fix bugs in loading PCX and TGA image file.

12/04. Fix bugs in OpenFileDlgBoxEx function.

12/31. Release version 1.3.1.

*******************************************************************************
What's new in this version (1.3.1, 2003/09/12 ~ 2003/10/31):

09/12. Add function GetNextDevFont.

09/14. Fix a bug of hzinput.c for big endian systems.

09/16. Fix a bug of SetValueToEtcFile function.

09/16. Fix a bug of ScaleBitmap function.
	* This bug only affects the mode of depth 8 bits.

09/26. Optimize of etc file functions and system resources loading.
	* Add LoadEtcFile and UnloadEtcFile functions.
	* Add GetValueFromEtc, GetIntValueFromEtc, and SetValueToEtc functions.

09/28. Add _MGHAVE_FIXED_MATH condition.

09/29. Use pre-compilation condition to include/exclude the incore fonts.

10/13. Add APIs for skin support.

10/31. Release as version 1.3.1.

*******************************************************************************
What's new in this version (1.3.0, 2003/08/01 ~ 2003/09/11):

08/01. Merge modifications from branch rel-1-2-6-patches.

08/01. Change license to GPL.

08/01. MiniGUI will be configured as MiniGUI-Threads by default.

08/01. Use g_rcScr instead of g_rcDesktop for MiniGUI-Threads.

08/04. Fix bug of CreateMemDCFromBitmap.

08/05. Delete no useful system bitmaps.

08/06. Fix a bug of NEWTOOLBAR control.

08/06. Add IAL engine for uClinux touch screen palm/mc68ez328.

08/07. Make InitBitmap available for OLDGAL.

08/12. Add constants definition for uClinux.

08/12. Add debug messages for uClinux.

08/13. Add incore resource option.

08/14. Add LoadCursorFromMem and LoadIconFromMem functions.

08/14. Add code for _MGINCORE_RES condition.

08/15. Add initial code for MiniGUI-Lite StandAlone version.

08/15. The MiniGUI for uClinux is almost OK. :)

08/17. IAL engine for Xcopilot is OK now. :)

08/25. Restore the old MiniGUI-Lite C/S code.

08/25. Use the first IAL engine as the default engine.

08/25. Merge changes for LISTVIEW control from branch rel-1-2-6-patches.

08/25. Tune QVFB IAL engine.

09/02. Remove mkmnuconfig and makefile.mnu, you can "make menuconfig" directly now.

09/02. Add m68k-elf-gcc to compilers

09/03. All files are cleaned up for GPL license.

09/04. Remove ep7211 gal and ads gal configure options

09/09. Fix compilation bugs when INCORE_RES defined for MiniGUI-Lite no standalone version.

09/10. Change ftok to use /etc/passwd file.

09/11. Release as version 1.3.0.

*******************************************************************************
What's new in this version (1.2.6-5, 2003/07/10 ~ 2003/xx/xx):

07/10. Fix system menu bitmap loading bug.
	* This bug only effect 1bpp ~ 4bpp vedio mode.

07/10. Fix fblin1 subdriver of fbcon OLDGAL engine.

07/10. Make IncludeClipRect, ExcludeClipRect and PtVisible functions on OLDGAL the same as ones on NEWGAL.

07/10. Cleanup fblin1, fblin2, and fblin4 subdrivers of fbcon OLDGAL engine.

07/10. Fix bug of uninitialized palette in LoadMyBitmap function.
	* This bug only effect the mode with less than 8bpp.

07/10. Fix a bug of MLEDIT control.

07/11. Cleanup configuration scripts.

07/12. Fix a bug of freeing hardware surface in FBCON engine of NEWGAL.

07/29. Fix a bug of undefined ClipCursor when _MGHAVE_CURSOR not defined.

07/29. Fix bugs of error variables in the file configure.in.

08/01. Fix bugs of NEWTOOLBAR control.

*******************************************************************************
What's new in this version (1.2.6-4, aka, 1.2.6-var, 2003/06/17 ~ 2003/06/18):

06/17. Upgrade to 1.2.6-var.

06/18. Fix compilation bug of LBM image support.

06/18. Fix bug of Update when cursor support disabled.

06/18. Fix disabled cursor support for MiniGUI-Threads.

06/18. Fix erasing background bug of vcongui.
	* This bug is caused by non-zero descent of RBF font.

06/19. Merge menuconfig tools.

06/20. Add support for MS serial mouse.

06/22. Fix a bug of BitBlt and StretchBlt of NEWGDI.

07/04. Fix a bug of MSG_CHAR handling of SIMEDIT and MLEDIT.

06/26. Restore VBFINFO structure.

07/04. Fix a bug of MSG_CHAR message handling of SIMEDIT and MLEDIT.

07/04. Fix a bug of UnloadQPFont function in src/font/qpf.c.

*******************************************************************************
What's new in this version (1.2.6-3, 2003/06/05 ~ 2003/06/17):

06/05. Fix a bug of Intelligent Pinyin Input Method of GB2312 (src/ime/pinyin.c)
	* This bug only affects the Big-Endin systems.

06/06. Cleanup hosted main window when destroying the hosting main window.

06/06. Remove the definition of WS_EX_IMECOMPOSE from include/window.h

06/07. Add UnloadMyBitmap function.

06/07. Return non-zero descent for RBF font according to its height.
   * Add get_char_ascent operation for RBF font.

06/09. Fix a bug of insert item in non-sorted LISTBOX control.

06/10. Add LBS_NOTIFY check for all notification in LISTBOX control.

06/10. Add DLGC_WANTENTER dialog code.

06/10. Do not use memory DC for LISTVIEW control.

06/12. DialogBox uses dwAddData2 of main window to pass the return code.
   * Applications should use the first additional data of DialogBox.

06/12. Fix two bugs in PROPSHEET control.
   * Pass dwAddData of DLGTEMPLATE struct to be the dwAddData of property page.
   * Fix calculation error of window size of property page.

06/13. Modify event hook API for MiniGUI-Lite.
   * SetServerEventHook function returns old event hook.

06/13. Fix bug of MoveWindow in MiniGUI-Lite.

06/13. Adjust server timeout value to be 10ms for MiniGUI-Lite.

*******************************************************************************
What's new in this version (1.2.6-2, 2003/05/27 ~ 2003/06/05):

05/27. Enhance dskGetFirstVisibleWindow function in src/kernel/desktop-common.c.
	* Rename it to dskGetFirstActivableWindow.
	* Exclude main window with WS_EX_TOOLWINDOW style.

05/29. Fix a bug of get_char_bitmap function in src/font/varbitmap.c.
	* This bug only affects Big-Endian systems.

05/30. Fix a bug of CreateLogFont function in src/font/devfont.c.
	* This bug only affects QPF and TTF fonts which support multiple charsets.

06/01. Enhance the default MiniGUI.cfg to use QPF font.

06/02. Fix a bug of LISTBOX control.
	* PageDown key will cause core dump when the box is empty.

06/02. Fix a bug of FillBox function in NEWGDI.
	* This bug only affects PowerPC system.

06/03. Fix a bug of CreateCompatibleDCEx function in NEWGDI.
	* Must initialize palette of the memory DC.
	* This bug only affects 8bpp system.

06/03. Fix a bug of putboxmask functions in old fbcon engine.
	* This bug only affects filling box with transparent bitmap 
	  on 16bpp and 32 bpp systems.

06/04. Fix a bug of UnloadBitmap function in OLDGDI.
	* Reset bmBits field to NULL.

06/04. Update GB2312 charset data and gb2312_to_unicode map.
	* User must use the new RBF font for GB2312.

06/05. Update GBK charset data.
	* User must use the new RBF font for GBK.

*******************************************************************************
What's new in this version (1.2.6, 2003/05/27):

01. Update configuration scripts for Automake/Autoconf.
02. Merge MyWins library to MiniGUIExt library.

03. Add SetNotificationCallback/GetNotificationCallback functions.
04. Add NotifyParentEx function.
	* Define NotifyParent as macro calling NotifyParentEx

05. Add GetIconSize function to retrive the size of an icon object.
06. Add SETSTRCMPFUNC message to the following controls:
	* LISTBOX (LB_SETSTRCMPFUNC)
	* COMBOBOX (CB_SETSTRCMPFUNC)
	* MENUBUTTON (MB_SETSTRCMPFUNC)
	* LISTVIEW (LVM_SETSTRCMPFUNC)
	* TREEVIEW (TVM_SETSTRCMPFUNC)

07. Add NEWTOOLBAR control.

08. Add support of screen rotation for iPAQ H3800 (Old-GAL).
	* Handle counterclockwise rotation of screen (src/gal/native/native.c).
	* Handle counterclockwise rotation of screen (src/ial/native/native.c).
	* Handle counterclockwise rotation of screen (src/ial/ipaq.c).
	* Change conf option --enable-coortrans to --enable-cootrans_cw.
	* Add conf option --enable-coortrans_ccw.
	* Modify the shortcut script buildlib-ipaq.

09. Fix bug of loading mono-color bitmap.
10. Fix bug of refresh of LISTVIEW control.
11. Fix bug of strcmp in UnregisterWindowClass function.
12. Fix bug of MoveWindow and ScrollWindow under MiniGUI-Lite.
13. Fix bug of MSG_ENABLE handling.
14. Fix bug of DrawText with flag DT_EXPANDTABS.
15. Fix bug of FocusRect (NEWGDI).
16. Fix bug of offset value in surface (NEWGAL).
17. Fix bug of SetActiveWindow.
18. Fix bug of main window caption drawing of Flat-Style.
19. Fix bug of Alpha-PNG image loading.
20. Fix bug of missing Backspace in GB IME module.
21. Fix bug of get_str_width method for TrueType font.
22. Fix bug of QPF font rendering.
23. Fix bug in GetTextMCharInfo function.
24. Fix bug of NULL pointer in DispatchTimerMessage function.
25. Fix bug of FillBoxWithBitmapPart in NEWGDI.
26. Fix bug in gdi_width_one_char function (newgdi/drawtext.c).
27. Fix bug of static viariable in myWinHelpMessage function. (ext/mywins/helpwin.c).
28. Fix bug of invalid use of window additional data in myWinHelpMessage function.

29. Clean up EDIT and SLEDIT control.
	* Add EM_GETCARETPOS and EM_SETCARETPOS messages.

30. Clean up STATIC control.
	* Implement all styles.

31. Clean up BUTTON control.
32. Clean up MENUBUTTON control.
33. Clean up LISTBOX control.
34. Clean up COMBOBOX control.
	* APIs have been modified vastly.
	* Backwards compatiblity has been broken.

35. Clean up TRACKBAR control.
36. Clean up PROPSHEET control.
37. Clean up COOLBAR control in MiniGUIExt library.
	* APIs have been modified slightly.
	* Backwards compatiblity has been broken.

38. Clean up SPINBOX control in MiniGUIExt library.
39. Clean up TREEVIEW control in MiniGUIExt library.
	* APIs have been modified slightly.
	* Backwards compatiblity has been broken.

40. Clean up LISTVIEW control in MiniGUIExt library.
	* Almost rewritten. 
	* APIs have been modified vastly.
	* Backwards compatiblity has been broken.

41. Clean up low-level text out functions.

42. Enhance MessageBox to handle default MSG_CLOSE message.
43. Enhance OnlyMeCanDraw and ClientCanDrawNow to handle nested calling.
44. Enhance timer mechanism, and control can call SetTimer now.
45. Enhance IME mechanism:
	* Use MSG_DOESNEEDIME to determine a window whether needs IME window.
	* Use MSG_SETFOCUS and MSG_KILLFOCUS to open or close 
	  IME window automatically.
	* WS_EX_IMECOMPOSE is obsolete.

46. Modify the class of Simple Edit Control.
	* Renamed to CTRL_EDIT ("edit").

47. Modify key and mouse message hook APIs.
	* Backwards compatiblity has been broken.

48. Modify the GB IME APIs.
	* Backwards compatiblity has been broken.

49. Modify the management of pthread objects in MiniGUI-Threads.
	* Destroy all mutex and semaphore variables for MiniGUI-Threads.

50. Modify the low-level event handler.

51. Modify BITMAP struct of Old-GDI.
	* Make sure to use bmType, bmBitsPerPixel, bmBytesPerPixel, and bmPitch.
	* Rename transparent field to bmColorKey.
	* Add GetPixelInBitmap, SetPixelInBitmap, and ScaleBitmap functions.

*******************************************************************************
What's new in this version (1.2.5, 2003/03/23):

1. Delete old UJIS charset support.
1. Add EUC-JP and Shift-JIS charset support.
2. Fix EUC-KR charset support.
3. Fix some charset names.
4. Add EUC-JP, Shift-JIS, EUC-KR, and BIG5 to UNICODE maps.
5. Fix bug of error return when InitGDI failure.
6. Fix bug of ExpandeMyBitmap in NEWGDI.
7. Add support for all ISO8859 charsets.
8. Add SetKeyboardLayout function to switch among keyboard layouts on run-time.
9. Add GetFontMetrics and GetGlyphBitmap functions.
10. Old Edit control renamed to Simple Edit control, class name is "SIMEDIT".
11. The "EDIT" control now can handle no-fixed font.

*******************************************************************************
What's new in this version (1.2.4, 2003/02/20):

1. Add IAL subdriver for IMPS2 mouse.
2. Add support for GBK charset.
3. Add support for GB18030 charset.
4. Fix a notification message sending bug of ListView control.
5. Fix clipping error of old GAL engine when coordinates translation enbabled.
6. Fix bug of pthread link.
7. Fix a endian-related bug in varbitmap.c.
8. Add argument checking in FillBoxWithBitmap and FillBoxWithBitmapPart.
9. Fix a bug in GDI cleanup routine.
10. Fix bug of double-byte character testing in vcongui/vt.c.
11. Add ISO8859-5 to UCS conversion function.
12. No longer use F10 as the sys_char modifier.
13. Fix bug of VGA16 GAL engine.
14. Add support for Qt Prerendered Fonts.
15. Fix bug of compilation of in-core symbol font.
16. Use Linux keymap to translate key messages.
17. Add MSG_KEYSYM message to handle non-latin key symbol.
18. VCOnGUI now uses the keymap in libminigui.
19. EDIT control now can handle non-fixed font.

*******************************************************************************
What's new in this version (1.2.3, 2002/10/09):

1. Add CreateLogFontByName function.
2. Optimize memory allocation of mywins library.
3. Fix dead loop bug in RectInRegion function.
4. Enhance flat style for colorful screen.
5. Fix error alignment bug of dot line.
6. Fix a refresh bug of BUTTON control.
7. Add GetNextChild and GetNextMainWindow functions.

*******************************************************************************
What's new in this version (1.2.2, 2002/07/28):

1. We no longer use signals to handle layer switching and client screen setting.
   Layer switching now is more smoother and stabler.
2. Fix a bug of init_count in InitMiniGUIExt and InitVectorialFonts functions.
3. Fix a bug in hardware accelerated blitting for NeoMagic chipset in NEWGAL.
4. Fix compilation error in src/server/request.c when cursor support disabled.
5. Fix a bug when SetActiveWindow to HWND_DESKTOP.
6. Tune flat window style for main window and built-in controls.
   Note that you should use new resource package version 1.2.0 for flat window style.
7. Use /dev/tty0 instead of /dev/tty when euid=0 in the console IAL engine.
8. Use control's default background color as the bkgnd color of IME window.
9. Optimize MoveWindow function.
10. Fix some misspelling in the API documentation.

*******************************************************************************
What's new in this version (1.2.1, 2002/06/12):

1. Fix a bug in timer handling of MiniGUI-Lite.
2. Fix dead-lock bug of cursor handling of MiniGUI-Lite.
3. Make background picture as the shared resource, so clients can 
   display the background picture as the server in MiniGUI-Lite.
4. Fix a bug in Intelligent Pinyin Input method.
5. Fix some misspelling in the API documentation.

*******************************************************************************
